# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'GetFormResult',
    'AwaitableGetFormResult',
    'get_form',
    'get_form_output',
]

@pulumi.output_type
class GetFormResult:
    def __init__(__self__, cta=None, data_type=None, fields=None, form_action_type=None, id=None, label_decorator=None, name=None, schema_version=None, sectional_elements=None, style=None, tags=None):
        if cta and not isinstance(cta, dict):
            raise TypeError("Expected argument 'cta' to be a dict")
        pulumi.set(__self__, "cta", cta)
        if data_type and not isinstance(data_type, dict):
            raise TypeError("Expected argument 'data_type' to be a dict")
        pulumi.set(__self__, "data_type", data_type)
        if fields and not isinstance(fields, dict):
            raise TypeError("Expected argument 'fields' to be a dict")
        pulumi.set(__self__, "fields", fields)
        if form_action_type and not isinstance(form_action_type, str):
            raise TypeError("Expected argument 'form_action_type' to be a str")
        pulumi.set(__self__, "form_action_type", form_action_type)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if label_decorator and not isinstance(label_decorator, str):
            raise TypeError("Expected argument 'label_decorator' to be a str")
        pulumi.set(__self__, "label_decorator", label_decorator)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if schema_version and not isinstance(schema_version, str):
            raise TypeError("Expected argument 'schema_version' to be a str")
        pulumi.set(__self__, "schema_version", schema_version)
        if sectional_elements and not isinstance(sectional_elements, dict):
            raise TypeError("Expected argument 'sectional_elements' to be a dict")
        pulumi.set(__self__, "sectional_elements", sectional_elements)
        if style and not isinstance(style, dict):
            raise TypeError("Expected argument 'style' to be a dict")
        pulumi.set(__self__, "style", style)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def cta(self) -> Optional['outputs.FormCta']:
        """
        The `FormCTA` object that stores the call to action configuration for the form.
        """
        return pulumi.get(self, "cta")

    @property
    @pulumi.getter(name="dataType")
    def data_type(self) -> Optional['outputs.FormDataTypeConfig']:
        """
        The type of data source to use to create the form.
        """
        return pulumi.get(self, "data_type")

    @property
    @pulumi.getter
    def fields(self) -> Optional[Mapping[str, 'outputs.FormFieldConfig']]:
        """
        The configuration information for the form's fields.
        """
        return pulumi.get(self, "fields")

    @property
    @pulumi.getter(name="formActionType")
    def form_action_type(self) -> Optional['FormActionType']:
        """
        Specifies whether to perform a create or update action on the form.
        """
        return pulumi.get(self, "form_action_type")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        The ID for the form.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="labelDecorator")
    def label_decorator(self) -> Optional['FormLabelDecorator']:
        """
        Specifies an icon or decoration to display on the form.
        """
        return pulumi.get(self, "label_decorator")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The name of the form.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="schemaVersion")
    def schema_version(self) -> Optional[str]:
        """
        The schema version of the form.
        """
        return pulumi.get(self, "schema_version")

    @property
    @pulumi.getter(name="sectionalElements")
    def sectional_elements(self) -> Optional[Mapping[str, 'outputs.FormSectionalElement']]:
        """
        The configuration information for the visual helper elements for the form. These elements are not associated with any data.
        """
        return pulumi.get(self, "sectional_elements")

    @property
    @pulumi.getter
    def style(self) -> Optional['outputs.FormStyle']:
        """
        The configuration for the form's style.
        """
        return pulumi.get(self, "style")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, str]]:
        """
        One or more key-value pairs to use when tagging the form data.
        """
        return pulumi.get(self, "tags")


class AwaitableGetFormResult(GetFormResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFormResult(
            cta=self.cta,
            data_type=self.data_type,
            fields=self.fields,
            form_action_type=self.form_action_type,
            id=self.id,
            label_decorator=self.label_decorator,
            name=self.name,
            schema_version=self.schema_version,
            sectional_elements=self.sectional_elements,
            style=self.style,
            tags=self.tags)


def get_form(app_id: Optional[str] = None,
             environment_name: Optional[str] = None,
             id: Optional[str] = None,
             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFormResult:
    """
    Definition of AWS::AmplifyUIBuilder::Form Resource Type


    :param str app_id: The unique ID of the Amplify app associated with the form.
    :param str environment_name: The name of the backend environment that is a part of the Amplify app.
    :param str id: The ID for the form.
    """
    __args__ = dict()
    __args__['appId'] = app_id
    __args__['environmentName'] = environment_name
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:amplifyuibuilder:getForm', __args__, opts=opts, typ=GetFormResult).value

    return AwaitableGetFormResult(
        cta=pulumi.get(__ret__, 'cta'),
        data_type=pulumi.get(__ret__, 'data_type'),
        fields=pulumi.get(__ret__, 'fields'),
        form_action_type=pulumi.get(__ret__, 'form_action_type'),
        id=pulumi.get(__ret__, 'id'),
        label_decorator=pulumi.get(__ret__, 'label_decorator'),
        name=pulumi.get(__ret__, 'name'),
        schema_version=pulumi.get(__ret__, 'schema_version'),
        sectional_elements=pulumi.get(__ret__, 'sectional_elements'),
        style=pulumi.get(__ret__, 'style'),
        tags=pulumi.get(__ret__, 'tags'))
def get_form_output(app_id: Optional[pulumi.Input[str]] = None,
                    environment_name: Optional[pulumi.Input[str]] = None,
                    id: Optional[pulumi.Input[str]] = None,
                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetFormResult]:
    """
    Definition of AWS::AmplifyUIBuilder::Form Resource Type


    :param str app_id: The unique ID of the Amplify app associated with the form.
    :param str environment_name: The name of the backend environment that is a part of the Amplify app.
    :param str id: The ID for the form.
    """
    __args__ = dict()
    __args__['appId'] = app_id
    __args__['environmentName'] = environment_name
    __args__['id'] = id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('aws-native:amplifyuibuilder:getForm', __args__, opts=opts, typ=GetFormResult)
    return __ret__.apply(lambda __response__: GetFormResult(
        cta=pulumi.get(__response__, 'cta'),
        data_type=pulumi.get(__response__, 'data_type'),
        fields=pulumi.get(__response__, 'fields'),
        form_action_type=pulumi.get(__response__, 'form_action_type'),
        id=pulumi.get(__response__, 'id'),
        label_decorator=pulumi.get(__response__, 'label_decorator'),
        name=pulumi.get(__response__, 'name'),
        schema_version=pulumi.get(__response__, 'schema_version'),
        sectional_elements=pulumi.get(__response__, 'sectional_elements'),
        style=pulumi.get(__response__, 'style'),
        tags=pulumi.get(__response__, 'tags')))
