# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'CapabilityConfigurationProperties',
    'CapabilityEdiConfiguration',
    'CapabilityEdiTypeProperties',
    'CapabilityS3Location',
    'CapabilityX12Details',
    'PartnershipCapabilityOptions',
    'PartnershipOutboundEdiOptionsProperties',
    'PartnershipX12Delimiters',
    'PartnershipX12Envelope',
    'PartnershipX12FunctionalGroupHeaders',
    'PartnershipX12InterchangeControlHeaders',
    'PartnershipX12OutboundEdiHeaders',
    'TransformerEdiTypeProperties',
    'TransformerFormatOptionsProperties',
    'TransformerInputConversion',
    'TransformerMapping',
    'TransformerOutputConversion',
    'TransformerSampleDocumentKeys',
    'TransformerSampleDocuments',
    'TransformerX12Details',
]

@pulumi.output_type
class CapabilityConfigurationProperties(dict):
    def __init__(__self__, *,
                 edi: 'outputs.CapabilityEdiConfiguration'):
        pulumi.set(__self__, "edi", edi)

    @property
    @pulumi.getter
    def edi(self) -> 'outputs.CapabilityEdiConfiguration':
        return pulumi.get(self, "edi")


@pulumi.output_type
class CapabilityEdiConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "inputLocation":
            suggest = "input_location"
        elif key == "outputLocation":
            suggest = "output_location"
        elif key == "transformerId":
            suggest = "transformer_id"
        elif key == "capabilityDirection":
            suggest = "capability_direction"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in CapabilityEdiConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        CapabilityEdiConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        CapabilityEdiConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 input_location: 'outputs.CapabilityS3Location',
                 output_location: 'outputs.CapabilityS3Location',
                 transformer_id: str,
                 type: 'outputs.CapabilityEdiTypeProperties',
                 capability_direction: Optional['CapabilityDirection'] = None):
        pulumi.set(__self__, "input_location", input_location)
        pulumi.set(__self__, "output_location", output_location)
        pulumi.set(__self__, "transformer_id", transformer_id)
        pulumi.set(__self__, "type", type)
        if capability_direction is not None:
            pulumi.set(__self__, "capability_direction", capability_direction)

    @property
    @pulumi.getter(name="inputLocation")
    def input_location(self) -> 'outputs.CapabilityS3Location':
        return pulumi.get(self, "input_location")

    @property
    @pulumi.getter(name="outputLocation")
    def output_location(self) -> 'outputs.CapabilityS3Location':
        return pulumi.get(self, "output_location")

    @property
    @pulumi.getter(name="transformerId")
    def transformer_id(self) -> str:
        return pulumi.get(self, "transformer_id")

    @property
    @pulumi.getter
    def type(self) -> 'outputs.CapabilityEdiTypeProperties':
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="capabilityDirection")
    def capability_direction(self) -> Optional['CapabilityDirection']:
        return pulumi.get(self, "capability_direction")


@pulumi.output_type
class CapabilityEdiTypeProperties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "x12Details":
            suggest = "x12_details"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in CapabilityEdiTypeProperties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        CapabilityEdiTypeProperties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        CapabilityEdiTypeProperties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 x12_details: 'outputs.CapabilityX12Details'):
        pulumi.set(__self__, "x12_details", x12_details)

    @property
    @pulumi.getter(name="x12Details")
    def x12_details(self) -> 'outputs.CapabilityX12Details':
        return pulumi.get(self, "x12_details")


@pulumi.output_type
class CapabilityS3Location(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "bucketName":
            suggest = "bucket_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in CapabilityS3Location. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        CapabilityS3Location.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        CapabilityS3Location.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 bucket_name: Optional[str] = None,
                 key: Optional[str] = None):
        if bucket_name is not None:
            pulumi.set(__self__, "bucket_name", bucket_name)
        if key is not None:
            pulumi.set(__self__, "key", key)

    @property
    @pulumi.getter(name="bucketName")
    def bucket_name(self) -> Optional[str]:
        return pulumi.get(self, "bucket_name")

    @property
    @pulumi.getter
    def key(self) -> Optional[str]:
        return pulumi.get(self, "key")


@pulumi.output_type
class CapabilityX12Details(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "transactionSet":
            suggest = "transaction_set"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in CapabilityX12Details. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        CapabilityX12Details.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        CapabilityX12Details.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 transaction_set: Optional['CapabilityX12TransactionSet'] = None,
                 version: Optional['CapabilityX12Version'] = None):
        if transaction_set is not None:
            pulumi.set(__self__, "transaction_set", transaction_set)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="transactionSet")
    def transaction_set(self) -> Optional['CapabilityX12TransactionSet']:
        return pulumi.get(self, "transaction_set")

    @property
    @pulumi.getter
    def version(self) -> Optional['CapabilityX12Version']:
        return pulumi.get(self, "version")


@pulumi.output_type
class PartnershipCapabilityOptions(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "outboundEdi":
            suggest = "outbound_edi"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PartnershipCapabilityOptions. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PartnershipCapabilityOptions.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PartnershipCapabilityOptions.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 outbound_edi: Optional['outputs.PartnershipOutboundEdiOptionsProperties'] = None):
        """
        :param 'PartnershipOutboundEdiOptionsProperties' outbound_edi: A structure that contains the outbound EDI options.
        """
        if outbound_edi is not None:
            pulumi.set(__self__, "outbound_edi", outbound_edi)

    @property
    @pulumi.getter(name="outboundEdi")
    def outbound_edi(self) -> Optional['outputs.PartnershipOutboundEdiOptionsProperties']:
        """
        A structure that contains the outbound EDI options.
        """
        return pulumi.get(self, "outbound_edi")


@pulumi.output_type
class PartnershipOutboundEdiOptionsProperties(dict):
    def __init__(__self__, *,
                 x12: 'outputs.PartnershipX12Envelope'):
        pulumi.set(__self__, "x12", x12)

    @property
    @pulumi.getter
    def x12(self) -> 'outputs.PartnershipX12Envelope':
        return pulumi.get(self, "x12")


@pulumi.output_type
class PartnershipX12Delimiters(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "componentSeparator":
            suggest = "component_separator"
        elif key == "dataElementSeparator":
            suggest = "data_element_separator"
        elif key == "segmentTerminator":
            suggest = "segment_terminator"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PartnershipX12Delimiters. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PartnershipX12Delimiters.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PartnershipX12Delimiters.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 component_separator: Optional[str] = None,
                 data_element_separator: Optional[str] = None,
                 segment_terminator: Optional[str] = None):
        if component_separator is not None:
            pulumi.set(__self__, "component_separator", component_separator)
        if data_element_separator is not None:
            pulumi.set(__self__, "data_element_separator", data_element_separator)
        if segment_terminator is not None:
            pulumi.set(__self__, "segment_terminator", segment_terminator)

    @property
    @pulumi.getter(name="componentSeparator")
    def component_separator(self) -> Optional[str]:
        return pulumi.get(self, "component_separator")

    @property
    @pulumi.getter(name="dataElementSeparator")
    def data_element_separator(self) -> Optional[str]:
        return pulumi.get(self, "data_element_separator")

    @property
    @pulumi.getter(name="segmentTerminator")
    def segment_terminator(self) -> Optional[str]:
        return pulumi.get(self, "segment_terminator")


@pulumi.output_type
class PartnershipX12Envelope(dict):
    def __init__(__self__, *,
                 common: Optional['outputs.PartnershipX12OutboundEdiHeaders'] = None):
        if common is not None:
            pulumi.set(__self__, "common", common)

    @property
    @pulumi.getter
    def common(self) -> Optional['outputs.PartnershipX12OutboundEdiHeaders']:
        return pulumi.get(self, "common")


@pulumi.output_type
class PartnershipX12FunctionalGroupHeaders(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "applicationReceiverCode":
            suggest = "application_receiver_code"
        elif key == "applicationSenderCode":
            suggest = "application_sender_code"
        elif key == "responsibleAgencyCode":
            suggest = "responsible_agency_code"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PartnershipX12FunctionalGroupHeaders. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PartnershipX12FunctionalGroupHeaders.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PartnershipX12FunctionalGroupHeaders.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 application_receiver_code: Optional[str] = None,
                 application_sender_code: Optional[str] = None,
                 responsible_agency_code: Optional[str] = None):
        if application_receiver_code is not None:
            pulumi.set(__self__, "application_receiver_code", application_receiver_code)
        if application_sender_code is not None:
            pulumi.set(__self__, "application_sender_code", application_sender_code)
        if responsible_agency_code is not None:
            pulumi.set(__self__, "responsible_agency_code", responsible_agency_code)

    @property
    @pulumi.getter(name="applicationReceiverCode")
    def application_receiver_code(self) -> Optional[str]:
        return pulumi.get(self, "application_receiver_code")

    @property
    @pulumi.getter(name="applicationSenderCode")
    def application_sender_code(self) -> Optional[str]:
        return pulumi.get(self, "application_sender_code")

    @property
    @pulumi.getter(name="responsibleAgencyCode")
    def responsible_agency_code(self) -> Optional[str]:
        return pulumi.get(self, "responsible_agency_code")


@pulumi.output_type
class PartnershipX12InterchangeControlHeaders(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "acknowledgmentRequestedCode":
            suggest = "acknowledgment_requested_code"
        elif key == "receiverId":
            suggest = "receiver_id"
        elif key == "receiverIdQualifier":
            suggest = "receiver_id_qualifier"
        elif key == "repetitionSeparator":
            suggest = "repetition_separator"
        elif key == "senderId":
            suggest = "sender_id"
        elif key == "senderIdQualifier":
            suggest = "sender_id_qualifier"
        elif key == "usageIndicatorCode":
            suggest = "usage_indicator_code"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PartnershipX12InterchangeControlHeaders. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PartnershipX12InterchangeControlHeaders.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PartnershipX12InterchangeControlHeaders.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 acknowledgment_requested_code: Optional[str] = None,
                 receiver_id: Optional[str] = None,
                 receiver_id_qualifier: Optional[str] = None,
                 repetition_separator: Optional[str] = None,
                 sender_id: Optional[str] = None,
                 sender_id_qualifier: Optional[str] = None,
                 usage_indicator_code: Optional[str] = None):
        if acknowledgment_requested_code is not None:
            pulumi.set(__self__, "acknowledgment_requested_code", acknowledgment_requested_code)
        if receiver_id is not None:
            pulumi.set(__self__, "receiver_id", receiver_id)
        if receiver_id_qualifier is not None:
            pulumi.set(__self__, "receiver_id_qualifier", receiver_id_qualifier)
        if repetition_separator is not None:
            pulumi.set(__self__, "repetition_separator", repetition_separator)
        if sender_id is not None:
            pulumi.set(__self__, "sender_id", sender_id)
        if sender_id_qualifier is not None:
            pulumi.set(__self__, "sender_id_qualifier", sender_id_qualifier)
        if usage_indicator_code is not None:
            pulumi.set(__self__, "usage_indicator_code", usage_indicator_code)

    @property
    @pulumi.getter(name="acknowledgmentRequestedCode")
    def acknowledgment_requested_code(self) -> Optional[str]:
        return pulumi.get(self, "acknowledgment_requested_code")

    @property
    @pulumi.getter(name="receiverId")
    def receiver_id(self) -> Optional[str]:
        return pulumi.get(self, "receiver_id")

    @property
    @pulumi.getter(name="receiverIdQualifier")
    def receiver_id_qualifier(self) -> Optional[str]:
        return pulumi.get(self, "receiver_id_qualifier")

    @property
    @pulumi.getter(name="repetitionSeparator")
    def repetition_separator(self) -> Optional[str]:
        return pulumi.get(self, "repetition_separator")

    @property
    @pulumi.getter(name="senderId")
    def sender_id(self) -> Optional[str]:
        return pulumi.get(self, "sender_id")

    @property
    @pulumi.getter(name="senderIdQualifier")
    def sender_id_qualifier(self) -> Optional[str]:
        return pulumi.get(self, "sender_id_qualifier")

    @property
    @pulumi.getter(name="usageIndicatorCode")
    def usage_indicator_code(self) -> Optional[str]:
        return pulumi.get(self, "usage_indicator_code")


@pulumi.output_type
class PartnershipX12OutboundEdiHeaders(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "functionalGroupHeaders":
            suggest = "functional_group_headers"
        elif key == "interchangeControlHeaders":
            suggest = "interchange_control_headers"
        elif key == "validateEdi":
            suggest = "validate_edi"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PartnershipX12OutboundEdiHeaders. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PartnershipX12OutboundEdiHeaders.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PartnershipX12OutboundEdiHeaders.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 delimiters: Optional['outputs.PartnershipX12Delimiters'] = None,
                 functional_group_headers: Optional['outputs.PartnershipX12FunctionalGroupHeaders'] = None,
                 interchange_control_headers: Optional['outputs.PartnershipX12InterchangeControlHeaders'] = None,
                 validate_edi: Optional[bool] = None):
        if delimiters is not None:
            pulumi.set(__self__, "delimiters", delimiters)
        if functional_group_headers is not None:
            pulumi.set(__self__, "functional_group_headers", functional_group_headers)
        if interchange_control_headers is not None:
            pulumi.set(__self__, "interchange_control_headers", interchange_control_headers)
        if validate_edi is not None:
            pulumi.set(__self__, "validate_edi", validate_edi)

    @property
    @pulumi.getter
    def delimiters(self) -> Optional['outputs.PartnershipX12Delimiters']:
        return pulumi.get(self, "delimiters")

    @property
    @pulumi.getter(name="functionalGroupHeaders")
    def functional_group_headers(self) -> Optional['outputs.PartnershipX12FunctionalGroupHeaders']:
        return pulumi.get(self, "functional_group_headers")

    @property
    @pulumi.getter(name="interchangeControlHeaders")
    def interchange_control_headers(self) -> Optional['outputs.PartnershipX12InterchangeControlHeaders']:
        return pulumi.get(self, "interchange_control_headers")

    @property
    @pulumi.getter(name="validateEdi")
    def validate_edi(self) -> Optional[bool]:
        return pulumi.get(self, "validate_edi")


@pulumi.output_type
class TransformerEdiTypeProperties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "x12Details":
            suggest = "x12_details"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TransformerEdiTypeProperties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TransformerEdiTypeProperties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TransformerEdiTypeProperties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 x12_details: 'outputs.TransformerX12Details'):
        pulumi.set(__self__, "x12_details", x12_details)

    @property
    @pulumi.getter(name="x12Details")
    def x12_details(self) -> 'outputs.TransformerX12Details':
        return pulumi.get(self, "x12_details")


@pulumi.output_type
class TransformerFormatOptionsProperties(dict):
    def __init__(__self__, *,
                 x12: 'outputs.TransformerX12Details'):
        pulumi.set(__self__, "x12", x12)

    @property
    @pulumi.getter
    def x12(self) -> 'outputs.TransformerX12Details':
        return pulumi.get(self, "x12")


@pulumi.output_type
class TransformerInputConversion(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "fromFormat":
            suggest = "from_format"
        elif key == "formatOptions":
            suggest = "format_options"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TransformerInputConversion. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TransformerInputConversion.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TransformerInputConversion.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 from_format: 'TransformerFromFormat',
                 format_options: Optional['outputs.TransformerFormatOptionsProperties'] = None):
        pulumi.set(__self__, "from_format", from_format)
        if format_options is not None:
            pulumi.set(__self__, "format_options", format_options)

    @property
    @pulumi.getter(name="fromFormat")
    def from_format(self) -> 'TransformerFromFormat':
        return pulumi.get(self, "from_format")

    @property
    @pulumi.getter(name="formatOptions")
    def format_options(self) -> Optional['outputs.TransformerFormatOptionsProperties']:
        return pulumi.get(self, "format_options")


@pulumi.output_type
class TransformerMapping(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "templateLanguage":
            suggest = "template_language"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TransformerMapping. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TransformerMapping.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TransformerMapping.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 template_language: 'TransformerMappingTemplateLanguage',
                 template: Optional[str] = None):
        pulumi.set(__self__, "template_language", template_language)
        if template is not None:
            pulumi.set(__self__, "template", template)

    @property
    @pulumi.getter(name="templateLanguage")
    def template_language(self) -> 'TransformerMappingTemplateLanguage':
        return pulumi.get(self, "template_language")

    @property
    @pulumi.getter
    def template(self) -> Optional[str]:
        return pulumi.get(self, "template")


@pulumi.output_type
class TransformerOutputConversion(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "toFormat":
            suggest = "to_format"
        elif key == "formatOptions":
            suggest = "format_options"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TransformerOutputConversion. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TransformerOutputConversion.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TransformerOutputConversion.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 to_format: 'TransformerToFormat',
                 format_options: Optional['outputs.TransformerFormatOptionsProperties'] = None):
        pulumi.set(__self__, "to_format", to_format)
        if format_options is not None:
            pulumi.set(__self__, "format_options", format_options)

    @property
    @pulumi.getter(name="toFormat")
    def to_format(self) -> 'TransformerToFormat':
        return pulumi.get(self, "to_format")

    @property
    @pulumi.getter(name="formatOptions")
    def format_options(self) -> Optional['outputs.TransformerFormatOptionsProperties']:
        return pulumi.get(self, "format_options")


@pulumi.output_type
class TransformerSampleDocumentKeys(dict):
    def __init__(__self__, *,
                 input: Optional[str] = None,
                 output: Optional[str] = None):
        if input is not None:
            pulumi.set(__self__, "input", input)
        if output is not None:
            pulumi.set(__self__, "output", output)

    @property
    @pulumi.getter
    def input(self) -> Optional[str]:
        return pulumi.get(self, "input")

    @property
    @pulumi.getter
    def output(self) -> Optional[str]:
        return pulumi.get(self, "output")


@pulumi.output_type
class TransformerSampleDocuments(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "bucketName":
            suggest = "bucket_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TransformerSampleDocuments. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TransformerSampleDocuments.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TransformerSampleDocuments.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 bucket_name: str,
                 keys: Sequence['outputs.TransformerSampleDocumentKeys']):
        pulumi.set(__self__, "bucket_name", bucket_name)
        pulumi.set(__self__, "keys", keys)

    @property
    @pulumi.getter(name="bucketName")
    def bucket_name(self) -> str:
        return pulumi.get(self, "bucket_name")

    @property
    @pulumi.getter
    def keys(self) -> Sequence['outputs.TransformerSampleDocumentKeys']:
        return pulumi.get(self, "keys")


@pulumi.output_type
class TransformerX12Details(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "transactionSet":
            suggest = "transaction_set"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TransformerX12Details. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TransformerX12Details.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TransformerX12Details.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 transaction_set: Optional['TransformerX12TransactionSet'] = None,
                 version: Optional['TransformerX12Version'] = None):
        if transaction_set is not None:
            pulumi.set(__self__, "transaction_set", transaction_set)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="transactionSet")
    def transaction_set(self) -> Optional['TransformerX12TransactionSet']:
        return pulumi.get(self, "transaction_set")

    @property
    @pulumi.getter
    def version(self) -> Optional['TransformerX12Version']:
        return pulumi.get(self, "version")


