# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from .. import outputs as _root_outputs
from ._enums import *

__all__ = [
    'GetBudgetsActionResult',
    'AwaitableGetBudgetsActionResult',
    'get_budgets_action',
    'get_budgets_action_output',
]

@pulumi.output_type
class GetBudgetsActionResult:
    def __init__(__self__, action_id=None, action_threshold=None, approval_model=None, definition=None, execution_role_arn=None, notification_type=None, resource_tags=None, subscribers=None):
        if action_id and not isinstance(action_id, str):
            raise TypeError("Expected argument 'action_id' to be a str")
        pulumi.set(__self__, "action_id", action_id)
        if action_threshold and not isinstance(action_threshold, dict):
            raise TypeError("Expected argument 'action_threshold' to be a dict")
        pulumi.set(__self__, "action_threshold", action_threshold)
        if approval_model and not isinstance(approval_model, str):
            raise TypeError("Expected argument 'approval_model' to be a str")
        pulumi.set(__self__, "approval_model", approval_model)
        if definition and not isinstance(definition, dict):
            raise TypeError("Expected argument 'definition' to be a dict")
        pulumi.set(__self__, "definition", definition)
        if execution_role_arn and not isinstance(execution_role_arn, str):
            raise TypeError("Expected argument 'execution_role_arn' to be a str")
        pulumi.set(__self__, "execution_role_arn", execution_role_arn)
        if notification_type and not isinstance(notification_type, str):
            raise TypeError("Expected argument 'notification_type' to be a str")
        pulumi.set(__self__, "notification_type", notification_type)
        if resource_tags and not isinstance(resource_tags, list):
            raise TypeError("Expected argument 'resource_tags' to be a list")
        pulumi.set(__self__, "resource_tags", resource_tags)
        if subscribers and not isinstance(subscribers, list):
            raise TypeError("Expected argument 'subscribers' to be a list")
        pulumi.set(__self__, "subscribers", subscribers)

    @property
    @pulumi.getter(name="actionId")
    def action_id(self) -> Optional[str]:
        """
        A system-generated universally unique identifier (UUID) for the action.
        """
        return pulumi.get(self, "action_id")

    @property
    @pulumi.getter(name="actionThreshold")
    def action_threshold(self) -> Optional['outputs.BudgetsActionActionThreshold']:
        """
        The trigger threshold of the action.
        """
        return pulumi.get(self, "action_threshold")

    @property
    @pulumi.getter(name="approvalModel")
    def approval_model(self) -> Optional['BudgetsActionApprovalModel']:
        """
        This specifies if the action needs manual or automatic approval.
        """
        return pulumi.get(self, "approval_model")

    @property
    @pulumi.getter
    def definition(self) -> Optional['outputs.BudgetsActionDefinition']:
        """
        Specifies all of the type-specific parameters.
        """
        return pulumi.get(self, "definition")

    @property
    @pulumi.getter(name="executionRoleArn")
    def execution_role_arn(self) -> Optional[str]:
        """
        The role passed for action execution and reversion. Roles and actions must be in the same account.
        """
        return pulumi.get(self, "execution_role_arn")

    @property
    @pulumi.getter(name="notificationType")
    def notification_type(self) -> Optional['BudgetsActionNotificationType']:
        """
        The type of a notification.
        """
        return pulumi.get(self, "notification_type")

    @property
    @pulumi.getter(name="resourceTags")
    def resource_tags(self) -> Optional[Sequence['_root_outputs.Tag']]:
        """
        An optional list of tags to associate with the specified budget action. Each tag consists of a key and a value, and each key must be unique for the resource.
        """
        return pulumi.get(self, "resource_tags")

    @property
    @pulumi.getter
    def subscribers(self) -> Optional[Sequence['outputs.BudgetsActionSubscriber']]:
        """
        A list of subscribers.
        """
        return pulumi.get(self, "subscribers")


class AwaitableGetBudgetsActionResult(GetBudgetsActionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBudgetsActionResult(
            action_id=self.action_id,
            action_threshold=self.action_threshold,
            approval_model=self.approval_model,
            definition=self.definition,
            execution_role_arn=self.execution_role_arn,
            notification_type=self.notification_type,
            resource_tags=self.resource_tags,
            subscribers=self.subscribers)


def get_budgets_action(action_id: Optional[str] = None,
                       budget_name: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBudgetsActionResult:
    """
    An example resource schema demonstrating some basic constructs and validation rules.


    :param str action_id: A system-generated universally unique identifier (UUID) for the action.
    :param str budget_name: A string that represents the budget name. ":" and "\\" characters aren't allowed.
    """
    __args__ = dict()
    __args__['actionId'] = action_id
    __args__['budgetName'] = budget_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:budgets:getBudgetsAction', __args__, opts=opts, typ=GetBudgetsActionResult).value

    return AwaitableGetBudgetsActionResult(
        action_id=pulumi.get(__ret__, 'action_id'),
        action_threshold=pulumi.get(__ret__, 'action_threshold'),
        approval_model=pulumi.get(__ret__, 'approval_model'),
        definition=pulumi.get(__ret__, 'definition'),
        execution_role_arn=pulumi.get(__ret__, 'execution_role_arn'),
        notification_type=pulumi.get(__ret__, 'notification_type'),
        resource_tags=pulumi.get(__ret__, 'resource_tags'),
        subscribers=pulumi.get(__ret__, 'subscribers'))
def get_budgets_action_output(action_id: Optional[pulumi.Input[str]] = None,
                              budget_name: Optional[pulumi.Input[str]] = None,
                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetBudgetsActionResult]:
    """
    An example resource schema demonstrating some basic constructs and validation rules.


    :param str action_id: A system-generated universally unique identifier (UUID) for the action.
    :param str budget_name: A string that represents the budget name. ":" and "\\" characters aren't allowed.
    """
    __args__ = dict()
    __args__['actionId'] = action_id
    __args__['budgetName'] = budget_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('aws-native:budgets:getBudgetsAction', __args__, opts=opts, typ=GetBudgetsActionResult)
    return __ret__.apply(lambda __response__: GetBudgetsActionResult(
        action_id=pulumi.get(__response__, 'action_id'),
        action_threshold=pulumi.get(__response__, 'action_threshold'),
        approval_model=pulumi.get(__response__, 'approval_model'),
        definition=pulumi.get(__response__, 'definition'),
        execution_role_arn=pulumi.get(__response__, 'execution_role_arn'),
        notification_type=pulumi.get(__response__, 'notification_type'),
        resource_tags=pulumi.get(__response__, 'resource_tags'),
        subscribers=pulumi.get(__response__, 'subscribers')))
