# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'NotificationRuleTargetArgs',
    'NotificationRuleTargetArgsDict',
]

MYPY = False

if not MYPY:
    class NotificationRuleTargetArgsDict(TypedDict):
        target_address: pulumi.Input[str]
        """
        The Amazon Resource Name (ARN) of the AWS Chatbot topic or AWS Chatbot client.
        """
        target_type: pulumi.Input[str]
        """
        The target type. Can be an Amazon Simple Notification Service topic or AWS Chatbot client.

        - Amazon Simple Notification Service topics are specified as `SNS` .
        - AWS Chatbot clients are specified as `AWSChatbotSlack` .
        - AWS Chatbot clients for Microsoft Teams are specified as `AWSChatbotMicrosoftTeams` .
        """
elif False:
    NotificationRuleTargetArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class NotificationRuleTargetArgs:
    def __init__(__self__, *,
                 target_address: pulumi.Input[str],
                 target_type: pulumi.Input[str]):
        """
        :param pulumi.Input[str] target_address: The Amazon Resource Name (ARN) of the AWS Chatbot topic or AWS Chatbot client.
        :param pulumi.Input[str] target_type: The target type. Can be an Amazon Simple Notification Service topic or AWS Chatbot client.
               
               - Amazon Simple Notification Service topics are specified as `SNS` .
               - AWS Chatbot clients are specified as `AWSChatbotSlack` .
               - AWS Chatbot clients for Microsoft Teams are specified as `AWSChatbotMicrosoftTeams` .
        """
        pulumi.set(__self__, "target_address", target_address)
        pulumi.set(__self__, "target_type", target_type)

    @property
    @pulumi.getter(name="targetAddress")
    def target_address(self) -> pulumi.Input[str]:
        """
        The Amazon Resource Name (ARN) of the AWS Chatbot topic or AWS Chatbot client.
        """
        return pulumi.get(self, "target_address")

    @target_address.setter
    def target_address(self, value: pulumi.Input[str]):
        pulumi.set(self, "target_address", value)

    @property
    @pulumi.getter(name="targetType")
    def target_type(self) -> pulumi.Input[str]:
        """
        The target type. Can be an Amazon Simple Notification Service topic or AWS Chatbot client.

        - Amazon Simple Notification Service topics are specified as `SNS` .
        - AWS Chatbot clients are specified as `AWSChatbotSlack` .
        - AWS Chatbot clients for Microsoft Teams are specified as `AWSChatbotMicrosoftTeams` .
        """
        return pulumi.get(self, "target_type")

    @target_type.setter
    def target_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "target_type", value)


