# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetIpamAllocationResult',
    'AwaitableGetIpamAllocationResult',
    'get_ipam_allocation',
    'get_ipam_allocation_output',
]

@pulumi.output_type
class GetIpamAllocationResult:
    def __init__(__self__, ipam_pool_allocation_id=None):
        if ipam_pool_allocation_id and not isinstance(ipam_pool_allocation_id, str):
            raise TypeError("Expected argument 'ipam_pool_allocation_id' to be a str")
        pulumi.set(__self__, "ipam_pool_allocation_id", ipam_pool_allocation_id)

    @property
    @pulumi.getter(name="ipamPoolAllocationId")
    def ipam_pool_allocation_id(self) -> Optional[str]:
        """
        Id of the allocation.
        """
        return pulumi.get(self, "ipam_pool_allocation_id")


class AwaitableGetIpamAllocationResult(GetIpamAllocationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetIpamAllocationResult(
            ipam_pool_allocation_id=self.ipam_pool_allocation_id)


def get_ipam_allocation(cidr: Optional[str] = None,
                        ipam_pool_allocation_id: Optional[str] = None,
                        ipam_pool_id: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetIpamAllocationResult:
    """
    Resource Schema of AWS::EC2::IPAMAllocation Type


    :param str cidr: The CIDR you would like to allocate from the IPAM pool. Note the following:
           
           - If there is no DefaultNetmaskLength allocation rule set on the pool, you must specify either the NetmaskLength or the CIDR.
           - If the DefaultNetmaskLength allocation rule is set on the pool, you can specify either the NetmaskLength or the CIDR and the DefaultNetmaskLength allocation rule will be ignored.
           
           Possible values: Any available IPv4 or IPv6 CIDR.
    :param str ipam_pool_allocation_id: Id of the allocation.
    :param str ipam_pool_id: Id of the IPAM Pool.
    """
    __args__ = dict()
    __args__['cidr'] = cidr
    __args__['ipamPoolAllocationId'] = ipam_pool_allocation_id
    __args__['ipamPoolId'] = ipam_pool_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:ec2:getIpamAllocation', __args__, opts=opts, typ=GetIpamAllocationResult).value

    return AwaitableGetIpamAllocationResult(
        ipam_pool_allocation_id=pulumi.get(__ret__, 'ipam_pool_allocation_id'))
def get_ipam_allocation_output(cidr: Optional[pulumi.Input[str]] = None,
                               ipam_pool_allocation_id: Optional[pulumi.Input[str]] = None,
                               ipam_pool_id: Optional[pulumi.Input[str]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetIpamAllocationResult]:
    """
    Resource Schema of AWS::EC2::IPAMAllocation Type


    :param str cidr: The CIDR you would like to allocate from the IPAM pool. Note the following:
           
           - If there is no DefaultNetmaskLength allocation rule set on the pool, you must specify either the NetmaskLength or the CIDR.
           - If the DefaultNetmaskLength allocation rule is set on the pool, you can specify either the NetmaskLength or the CIDR and the DefaultNetmaskLength allocation rule will be ignored.
           
           Possible values: Any available IPv4 or IPv6 CIDR.
    :param str ipam_pool_allocation_id: Id of the allocation.
    :param str ipam_pool_id: Id of the IPAM Pool.
    """
    __args__ = dict()
    __args__['cidr'] = cidr
    __args__['ipamPoolAllocationId'] = ipam_pool_allocation_id
    __args__['ipamPoolId'] = ipam_pool_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('aws-native:ec2:getIpamAllocation', __args__, opts=opts, typ=GetIpamAllocationResult)
    return __ret__.apply(lambda __response__: GetIpamAllocationResult(
        ipam_pool_allocation_id=pulumi.get(__response__, 'ipam_pool_allocation_id')))
