# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from .. import _inputs as _root_inputs
from .. import outputs as _root_outputs

__all__ = ['TransitGatewayArgs', 'TransitGateway']

@pulumi.input_type
class TransitGatewayArgs:
    def __init__(__self__, *,
                 amazon_side_asn: Optional[pulumi.Input[int]] = None,
                 association_default_route_table_id: Optional[pulumi.Input[str]] = None,
                 auto_accept_shared_attachments: Optional[pulumi.Input[str]] = None,
                 default_route_table_association: Optional[pulumi.Input[str]] = None,
                 default_route_table_propagation: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 dns_support: Optional[pulumi.Input[str]] = None,
                 multicast_support: Optional[pulumi.Input[str]] = None,
                 propagation_default_route_table_id: Optional[pulumi.Input[str]] = None,
                 security_group_referencing_support: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]] = None,
                 transit_gateway_cidr_blocks: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vpn_ecmp_support: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a TransitGateway resource.
        :param pulumi.Input[int] amazon_side_asn: A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range is 64512 to 65534 for 16-bit ASNs. The default is 64512.
        :param pulumi.Input[str] association_default_route_table_id: The ID of the default association route table.
        :param pulumi.Input[str] auto_accept_shared_attachments: Enable or disable automatic acceptance of attachment requests. Disabled by default.
        :param pulumi.Input[str] default_route_table_association: Enable or disable automatic association with the default association route table. Enabled by default.
        :param pulumi.Input[str] default_route_table_propagation: Enable or disable automatic propagation of routes to the default propagation route table. Enabled by default.
        :param pulumi.Input[str] description: The description of the transit gateway.
        :param pulumi.Input[str] dns_support: Enable or disable DNS support. Enabled by default.
        :param pulumi.Input[str] multicast_support: Indicates whether multicast is enabled on the transit gateway
        :param pulumi.Input[str] propagation_default_route_table_id: The ID of the default propagation route table.
        :param pulumi.Input[str] security_group_referencing_support: Enables you to reference a security group across VPCs attached to a transit gateway (TGW). Use this option to simplify security group management and control of instance-to-instance traffic across VPCs that are connected by transit gateway. You can also use this option to migrate from VPC peering (which was the only option that supported security group referencing) to transit gateways (which now also support security group referencing). This option is disabled by default and there are no additional costs to use this feature.
               
               For important information about this feature, see [Create a transit gateway](https://docs.aws.amazon.com/vpc/latest/tgw/tgw-transit-gateways.html#create-tgw) in the *AWS Transit Gateway Guide* .
        :param pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]] tags: The tags for the transit gateway.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] transit_gateway_cidr_blocks: The transit gateway CIDR blocks.
        :param pulumi.Input[str] vpn_ecmp_support: Enable or disable Equal Cost Multipath Protocol support. Enabled by default.
        """
        if amazon_side_asn is not None:
            pulumi.set(__self__, "amazon_side_asn", amazon_side_asn)
        if association_default_route_table_id is not None:
            pulumi.set(__self__, "association_default_route_table_id", association_default_route_table_id)
        if auto_accept_shared_attachments is not None:
            pulumi.set(__self__, "auto_accept_shared_attachments", auto_accept_shared_attachments)
        if default_route_table_association is not None:
            pulumi.set(__self__, "default_route_table_association", default_route_table_association)
        if default_route_table_propagation is not None:
            pulumi.set(__self__, "default_route_table_propagation", default_route_table_propagation)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if dns_support is not None:
            pulumi.set(__self__, "dns_support", dns_support)
        if multicast_support is not None:
            pulumi.set(__self__, "multicast_support", multicast_support)
        if propagation_default_route_table_id is not None:
            pulumi.set(__self__, "propagation_default_route_table_id", propagation_default_route_table_id)
        if security_group_referencing_support is not None:
            pulumi.set(__self__, "security_group_referencing_support", security_group_referencing_support)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if transit_gateway_cidr_blocks is not None:
            pulumi.set(__self__, "transit_gateway_cidr_blocks", transit_gateway_cidr_blocks)
        if vpn_ecmp_support is not None:
            pulumi.set(__self__, "vpn_ecmp_support", vpn_ecmp_support)

    @property
    @pulumi.getter(name="amazonSideAsn")
    def amazon_side_asn(self) -> Optional[pulumi.Input[int]]:
        """
        A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range is 64512 to 65534 for 16-bit ASNs. The default is 64512.
        """
        return pulumi.get(self, "amazon_side_asn")

    @amazon_side_asn.setter
    def amazon_side_asn(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "amazon_side_asn", value)

    @property
    @pulumi.getter(name="associationDefaultRouteTableId")
    def association_default_route_table_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the default association route table.
        """
        return pulumi.get(self, "association_default_route_table_id")

    @association_default_route_table_id.setter
    def association_default_route_table_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "association_default_route_table_id", value)

    @property
    @pulumi.getter(name="autoAcceptSharedAttachments")
    def auto_accept_shared_attachments(self) -> Optional[pulumi.Input[str]]:
        """
        Enable or disable automatic acceptance of attachment requests. Disabled by default.
        """
        return pulumi.get(self, "auto_accept_shared_attachments")

    @auto_accept_shared_attachments.setter
    def auto_accept_shared_attachments(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_accept_shared_attachments", value)

    @property
    @pulumi.getter(name="defaultRouteTableAssociation")
    def default_route_table_association(self) -> Optional[pulumi.Input[str]]:
        """
        Enable or disable automatic association with the default association route table. Enabled by default.
        """
        return pulumi.get(self, "default_route_table_association")

    @default_route_table_association.setter
    def default_route_table_association(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default_route_table_association", value)

    @property
    @pulumi.getter(name="defaultRouteTablePropagation")
    def default_route_table_propagation(self) -> Optional[pulumi.Input[str]]:
        """
        Enable or disable automatic propagation of routes to the default propagation route table. Enabled by default.
        """
        return pulumi.get(self, "default_route_table_propagation")

    @default_route_table_propagation.setter
    def default_route_table_propagation(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default_route_table_propagation", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the transit gateway.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="dnsSupport")
    def dns_support(self) -> Optional[pulumi.Input[str]]:
        """
        Enable or disable DNS support. Enabled by default.
        """
        return pulumi.get(self, "dns_support")

    @dns_support.setter
    def dns_support(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dns_support", value)

    @property
    @pulumi.getter(name="multicastSupport")
    def multicast_support(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates whether multicast is enabled on the transit gateway
        """
        return pulumi.get(self, "multicast_support")

    @multicast_support.setter
    def multicast_support(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "multicast_support", value)

    @property
    @pulumi.getter(name="propagationDefaultRouteTableId")
    def propagation_default_route_table_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the default propagation route table.
        """
        return pulumi.get(self, "propagation_default_route_table_id")

    @propagation_default_route_table_id.setter
    def propagation_default_route_table_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "propagation_default_route_table_id", value)

    @property
    @pulumi.getter(name="securityGroupReferencingSupport")
    def security_group_referencing_support(self) -> Optional[pulumi.Input[str]]:
        """
        Enables you to reference a security group across VPCs attached to a transit gateway (TGW). Use this option to simplify security group management and control of instance-to-instance traffic across VPCs that are connected by transit gateway. You can also use this option to migrate from VPC peering (which was the only option that supported security group referencing) to transit gateways (which now also support security group referencing). This option is disabled by default and there are no additional costs to use this feature.

        For important information about this feature, see [Create a transit gateway](https://docs.aws.amazon.com/vpc/latest/tgw/tgw-transit-gateways.html#create-tgw) in the *AWS Transit Gateway Guide* .
        """
        return pulumi.get(self, "security_group_referencing_support")

    @security_group_referencing_support.setter
    def security_group_referencing_support(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_group_referencing_support", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]]:
        """
        The tags for the transit gateway.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="transitGatewayCidrBlocks")
    def transit_gateway_cidr_blocks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The transit gateway CIDR blocks.
        """
        return pulumi.get(self, "transit_gateway_cidr_blocks")

    @transit_gateway_cidr_blocks.setter
    def transit_gateway_cidr_blocks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "transit_gateway_cidr_blocks", value)

    @property
    @pulumi.getter(name="vpnEcmpSupport")
    def vpn_ecmp_support(self) -> Optional[pulumi.Input[str]]:
        """
        Enable or disable Equal Cost Multipath Protocol support. Enabled by default.
        """
        return pulumi.get(self, "vpn_ecmp_support")

    @vpn_ecmp_support.setter
    def vpn_ecmp_support(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpn_ecmp_support", value)


class TransitGateway(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 amazon_side_asn: Optional[pulumi.Input[int]] = None,
                 association_default_route_table_id: Optional[pulumi.Input[str]] = None,
                 auto_accept_shared_attachments: Optional[pulumi.Input[str]] = None,
                 default_route_table_association: Optional[pulumi.Input[str]] = None,
                 default_route_table_propagation: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 dns_support: Optional[pulumi.Input[str]] = None,
                 multicast_support: Optional[pulumi.Input[str]] = None,
                 propagation_default_route_table_id: Optional[pulumi.Input[str]] = None,
                 security_group_referencing_support: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[Union['_root_inputs.TagArgs', '_root_inputs.TagArgsDict']]]]] = None,
                 transit_gateway_cidr_blocks: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vpn_ecmp_support: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Resource Type definition for AWS::EC2::TransitGateway

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] amazon_side_asn: A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range is 64512 to 65534 for 16-bit ASNs. The default is 64512.
        :param pulumi.Input[str] association_default_route_table_id: The ID of the default association route table.
        :param pulumi.Input[str] auto_accept_shared_attachments: Enable or disable automatic acceptance of attachment requests. Disabled by default.
        :param pulumi.Input[str] default_route_table_association: Enable or disable automatic association with the default association route table. Enabled by default.
        :param pulumi.Input[str] default_route_table_propagation: Enable or disable automatic propagation of routes to the default propagation route table. Enabled by default.
        :param pulumi.Input[str] description: The description of the transit gateway.
        :param pulumi.Input[str] dns_support: Enable or disable DNS support. Enabled by default.
        :param pulumi.Input[str] multicast_support: Indicates whether multicast is enabled on the transit gateway
        :param pulumi.Input[str] propagation_default_route_table_id: The ID of the default propagation route table.
        :param pulumi.Input[str] security_group_referencing_support: Enables you to reference a security group across VPCs attached to a transit gateway (TGW). Use this option to simplify security group management and control of instance-to-instance traffic across VPCs that are connected by transit gateway. You can also use this option to migrate from VPC peering (which was the only option that supported security group referencing) to transit gateways (which now also support security group referencing). This option is disabled by default and there are no additional costs to use this feature.
               
               For important information about this feature, see [Create a transit gateway](https://docs.aws.amazon.com/vpc/latest/tgw/tgw-transit-gateways.html#create-tgw) in the *AWS Transit Gateway Guide* .
        :param pulumi.Input[Sequence[pulumi.Input[Union['_root_inputs.TagArgs', '_root_inputs.TagArgsDict']]]] tags: The tags for the transit gateway.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] transit_gateway_cidr_blocks: The transit gateway CIDR blocks.
        :param pulumi.Input[str] vpn_ecmp_support: Enable or disable Equal Cost Multipath Protocol support. Enabled by default.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[TransitGatewayArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource Type definition for AWS::EC2::TransitGateway

        :param str resource_name: The name of the resource.
        :param TransitGatewayArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TransitGatewayArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 amazon_side_asn: Optional[pulumi.Input[int]] = None,
                 association_default_route_table_id: Optional[pulumi.Input[str]] = None,
                 auto_accept_shared_attachments: Optional[pulumi.Input[str]] = None,
                 default_route_table_association: Optional[pulumi.Input[str]] = None,
                 default_route_table_propagation: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 dns_support: Optional[pulumi.Input[str]] = None,
                 multicast_support: Optional[pulumi.Input[str]] = None,
                 propagation_default_route_table_id: Optional[pulumi.Input[str]] = None,
                 security_group_referencing_support: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[Union['_root_inputs.TagArgs', '_root_inputs.TagArgsDict']]]]] = None,
                 transit_gateway_cidr_blocks: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vpn_ecmp_support: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TransitGatewayArgs.__new__(TransitGatewayArgs)

            __props__.__dict__["amazon_side_asn"] = amazon_side_asn
            __props__.__dict__["association_default_route_table_id"] = association_default_route_table_id
            __props__.__dict__["auto_accept_shared_attachments"] = auto_accept_shared_attachments
            __props__.__dict__["default_route_table_association"] = default_route_table_association
            __props__.__dict__["default_route_table_propagation"] = default_route_table_propagation
            __props__.__dict__["description"] = description
            __props__.__dict__["dns_support"] = dns_support
            __props__.__dict__["multicast_support"] = multicast_support
            __props__.__dict__["propagation_default_route_table_id"] = propagation_default_route_table_id
            __props__.__dict__["security_group_referencing_support"] = security_group_referencing_support
            __props__.__dict__["tags"] = tags
            __props__.__dict__["transit_gateway_cidr_blocks"] = transit_gateway_cidr_blocks
            __props__.__dict__["vpn_ecmp_support"] = vpn_ecmp_support
            __props__.__dict__["aws_id"] = None
            __props__.__dict__["transit_gateway_arn"] = None
        replace_on_changes = pulumi.ResourceOptions(replace_on_changes=["amazonSideAsn", "multicastSupport"])
        opts = pulumi.ResourceOptions.merge(opts, replace_on_changes)
        super(TransitGateway, __self__).__init__(
            'aws-native:ec2:TransitGateway',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'TransitGateway':
        """
        Get an existing TransitGateway resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = TransitGatewayArgs.__new__(TransitGatewayArgs)

        __props__.__dict__["amazon_side_asn"] = None
        __props__.__dict__["association_default_route_table_id"] = None
        __props__.__dict__["auto_accept_shared_attachments"] = None
        __props__.__dict__["aws_id"] = None
        __props__.__dict__["default_route_table_association"] = None
        __props__.__dict__["default_route_table_propagation"] = None
        __props__.__dict__["description"] = None
        __props__.__dict__["dns_support"] = None
        __props__.__dict__["multicast_support"] = None
        __props__.__dict__["propagation_default_route_table_id"] = None
        __props__.__dict__["security_group_referencing_support"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["transit_gateway_arn"] = None
        __props__.__dict__["transit_gateway_cidr_blocks"] = None
        __props__.__dict__["vpn_ecmp_support"] = None
        return TransitGateway(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="amazonSideAsn")
    def amazon_side_asn(self) -> pulumi.Output[Optional[int]]:
        """
        A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range is 64512 to 65534 for 16-bit ASNs. The default is 64512.
        """
        return pulumi.get(self, "amazon_side_asn")

    @property
    @pulumi.getter(name="associationDefaultRouteTableId")
    def association_default_route_table_id(self) -> pulumi.Output[Optional[str]]:
        """
        The ID of the default association route table.
        """
        return pulumi.get(self, "association_default_route_table_id")

    @property
    @pulumi.getter(name="autoAcceptSharedAttachments")
    def auto_accept_shared_attachments(self) -> pulumi.Output[Optional[str]]:
        """
        Enable or disable automatic acceptance of attachment requests. Disabled by default.
        """
        return pulumi.get(self, "auto_accept_shared_attachments")

    @property
    @pulumi.getter(name="awsId")
    def aws_id(self) -> pulumi.Output[str]:
        """
        The ID of the transit gateway.
        """
        return pulumi.get(self, "aws_id")

    @property
    @pulumi.getter(name="defaultRouteTableAssociation")
    def default_route_table_association(self) -> pulumi.Output[Optional[str]]:
        """
        Enable or disable automatic association with the default association route table. Enabled by default.
        """
        return pulumi.get(self, "default_route_table_association")

    @property
    @pulumi.getter(name="defaultRouteTablePropagation")
    def default_route_table_propagation(self) -> pulumi.Output[Optional[str]]:
        """
        Enable or disable automatic propagation of routes to the default propagation route table. Enabled by default.
        """
        return pulumi.get(self, "default_route_table_propagation")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description of the transit gateway.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="dnsSupport")
    def dns_support(self) -> pulumi.Output[Optional[str]]:
        """
        Enable or disable DNS support. Enabled by default.
        """
        return pulumi.get(self, "dns_support")

    @property
    @pulumi.getter(name="multicastSupport")
    def multicast_support(self) -> pulumi.Output[Optional[str]]:
        """
        Indicates whether multicast is enabled on the transit gateway
        """
        return pulumi.get(self, "multicast_support")

    @property
    @pulumi.getter(name="propagationDefaultRouteTableId")
    def propagation_default_route_table_id(self) -> pulumi.Output[Optional[str]]:
        """
        The ID of the default propagation route table.
        """
        return pulumi.get(self, "propagation_default_route_table_id")

    @property
    @pulumi.getter(name="securityGroupReferencingSupport")
    def security_group_referencing_support(self) -> pulumi.Output[Optional[str]]:
        """
        Enables you to reference a security group across VPCs attached to a transit gateway (TGW). Use this option to simplify security group management and control of instance-to-instance traffic across VPCs that are connected by transit gateway. You can also use this option to migrate from VPC peering (which was the only option that supported security group referencing) to transit gateways (which now also support security group referencing). This option is disabled by default and there are no additional costs to use this feature.

        For important information about this feature, see [Create a transit gateway](https://docs.aws.amazon.com/vpc/latest/tgw/tgw-transit-gateways.html#create-tgw) in the *AWS Transit Gateway Guide* .
        """
        return pulumi.get(self, "security_group_referencing_support")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence['_root_outputs.Tag']]]:
        """
        The tags for the transit gateway.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="transitGatewayArn")
    def transit_gateway_arn(self) -> pulumi.Output[str]:
        return pulumi.get(self, "transit_gateway_arn")

    @property
    @pulumi.getter(name="transitGatewayCidrBlocks")
    def transit_gateway_cidr_blocks(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        The transit gateway CIDR blocks.
        """
        return pulumi.get(self, "transit_gateway_cidr_blocks")

    @property
    @pulumi.getter(name="vpnEcmpSupport")
    def vpn_ecmp_support(self) -> pulumi.Output[Optional[str]]:
        """
        Enable or disable Equal Cost Multipath Protocol support. Enabled by default.
        """
        return pulumi.get(self, "vpn_ecmp_support")

