# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = ['VpcBlockPublicAccessOptionsArgs', 'VpcBlockPublicAccessOptions']

@pulumi.input_type
class VpcBlockPublicAccessOptionsArgs:
    def __init__(__self__, *,
                 internet_gateway_block_mode: pulumi.Input['VpcBlockPublicAccessOptionsInternetGatewayBlockMode']):
        """
        The set of arguments for constructing a VpcBlockPublicAccessOptions resource.
        :param pulumi.Input['VpcBlockPublicAccessOptionsInternetGatewayBlockMode'] internet_gateway_block_mode: The desired Block Public Access mode for Internet Gateways in your account. We do not allow to create in a off mode as this is the default value
        """
        pulumi.set(__self__, "internet_gateway_block_mode", internet_gateway_block_mode)

    @property
    @pulumi.getter(name="internetGatewayBlockMode")
    def internet_gateway_block_mode(self) -> pulumi.Input['VpcBlockPublicAccessOptionsInternetGatewayBlockMode']:
        """
        The desired Block Public Access mode for Internet Gateways in your account. We do not allow to create in a off mode as this is the default value
        """
        return pulumi.get(self, "internet_gateway_block_mode")

    @internet_gateway_block_mode.setter
    def internet_gateway_block_mode(self, value: pulumi.Input['VpcBlockPublicAccessOptionsInternetGatewayBlockMode']):
        pulumi.set(self, "internet_gateway_block_mode", value)


class VpcBlockPublicAccessOptions(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 internet_gateway_block_mode: Optional[pulumi.Input['VpcBlockPublicAccessOptionsInternetGatewayBlockMode']] = None,
                 __props__=None):
        """
        Resource Type definition for AWS::EC2::VPCBlockPublicAccessOptions

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input['VpcBlockPublicAccessOptionsInternetGatewayBlockMode'] internet_gateway_block_mode: The desired Block Public Access mode for Internet Gateways in your account. We do not allow to create in a off mode as this is the default value
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VpcBlockPublicAccessOptionsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource Type definition for AWS::EC2::VPCBlockPublicAccessOptions

        :param str resource_name: The name of the resource.
        :param VpcBlockPublicAccessOptionsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VpcBlockPublicAccessOptionsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 internet_gateway_block_mode: Optional[pulumi.Input['VpcBlockPublicAccessOptionsInternetGatewayBlockMode']] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VpcBlockPublicAccessOptionsArgs.__new__(VpcBlockPublicAccessOptionsArgs)

            if internet_gateway_block_mode is None and not opts.urn:
                raise TypeError("Missing required property 'internet_gateway_block_mode'")
            __props__.__dict__["internet_gateway_block_mode"] = internet_gateway_block_mode
            __props__.__dict__["account_id"] = None
        super(VpcBlockPublicAccessOptions, __self__).__init__(
            'aws-native:ec2:VpcBlockPublicAccessOptions',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'VpcBlockPublicAccessOptions':
        """
        Get an existing VpcBlockPublicAccessOptions resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = VpcBlockPublicAccessOptionsArgs.__new__(VpcBlockPublicAccessOptionsArgs)

        __props__.__dict__["account_id"] = None
        __props__.__dict__["internet_gateway_block_mode"] = None
        return VpcBlockPublicAccessOptions(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Output[str]:
        """
        The identifier for the specified AWS account.
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="internetGatewayBlockMode")
    def internet_gateway_block_mode(self) -> pulumi.Output['VpcBlockPublicAccessOptionsInternetGatewayBlockMode']:
        """
        The desired Block Public Access mode for Internet Gateways in your account. We do not allow to create in a off mode as this is the default value
        """
        return pulumi.get(self, "internet_gateway_block_mode")

