# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'ExperimentTemplateActionArgs',
    'ExperimentTemplateActionArgsDict',
    'ExperimentTemplateCloudWatchDashboardArgs',
    'ExperimentTemplateCloudWatchDashboardArgsDict',
    'ExperimentTemplateExperimentOptionsArgs',
    'ExperimentTemplateExperimentOptionsArgsDict',
    'ExperimentTemplateExperimentReportConfigurationDataSourcesPropertiesArgs',
    'ExperimentTemplateExperimentReportConfigurationDataSourcesPropertiesArgsDict',
    'ExperimentTemplateExperimentReportConfigurationOutputsPropertiesExperimentReportS3ConfigurationPropertiesArgs',
    'ExperimentTemplateExperimentReportConfigurationOutputsPropertiesExperimentReportS3ConfigurationPropertiesArgsDict',
    'ExperimentTemplateExperimentReportConfigurationOutputsPropertiesArgs',
    'ExperimentTemplateExperimentReportConfigurationOutputsPropertiesArgsDict',
    'ExperimentTemplateExperimentReportConfigurationArgs',
    'ExperimentTemplateExperimentReportConfigurationArgsDict',
    'ExperimentTemplateLogConfigurationCloudWatchLogsConfigurationPropertiesArgs',
    'ExperimentTemplateLogConfigurationCloudWatchLogsConfigurationPropertiesArgsDict',
    'ExperimentTemplateLogConfigurationS3ConfigurationPropertiesArgs',
    'ExperimentTemplateLogConfigurationS3ConfigurationPropertiesArgsDict',
    'ExperimentTemplateLogConfigurationArgs',
    'ExperimentTemplateLogConfigurationArgsDict',
    'ExperimentTemplateStopConditionArgs',
    'ExperimentTemplateStopConditionArgsDict',
    'ExperimentTemplateTargetFilterArgs',
    'ExperimentTemplateTargetFilterArgsDict',
    'ExperimentTemplateTargetArgs',
    'ExperimentTemplateTargetArgsDict',
]

MYPY = False

if not MYPY:
    class ExperimentTemplateActionArgsDict(TypedDict):
        """
        Specifies an action for the experiment template.
        """
        action_id: pulumi.Input[str]
        """
        The ID of the action.
        """
        description: NotRequired[pulumi.Input[str]]
        """
        A description for the action.
        """
        parameters: NotRequired[pulumi.Input[Mapping[str, pulumi.Input[str]]]]
        """
        The parameters for the action, if applicable.
        """
        start_after: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        The name of the action that must be completed before the current action starts.
        """
        targets: NotRequired[pulumi.Input[Mapping[str, pulumi.Input[str]]]]
        """
        One or more targets for the action.
        """
elif False:
    ExperimentTemplateActionArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateActionArgs:
    def __init__(__self__, *,
                 action_id: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 start_after: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 targets: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        Specifies an action for the experiment template.
        :param pulumi.Input[str] action_id: The ID of the action.
        :param pulumi.Input[str] description: A description for the action.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] parameters: The parameters for the action, if applicable.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] start_after: The name of the action that must be completed before the current action starts.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] targets: One or more targets for the action.
        """
        pulumi.set(__self__, "action_id", action_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if parameters is not None:
            pulumi.set(__self__, "parameters", parameters)
        if start_after is not None:
            pulumi.set(__self__, "start_after", start_after)
        if targets is not None:
            pulumi.set(__self__, "targets", targets)

    @property
    @pulumi.getter(name="actionId")
    def action_id(self) -> pulumi.Input[str]:
        """
        The ID of the action.
        """
        return pulumi.get(self, "action_id")

    @action_id.setter
    def action_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "action_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        A description for the action.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def parameters(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The parameters for the action, if applicable.
        """
        return pulumi.get(self, "parameters")

    @parameters.setter
    def parameters(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "parameters", value)

    @property
    @pulumi.getter(name="startAfter")
    def start_after(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The name of the action that must be completed before the current action starts.
        """
        return pulumi.get(self, "start_after")

    @start_after.setter
    def start_after(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "start_after", value)

    @property
    @pulumi.getter
    def targets(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        One or more targets for the action.
        """
        return pulumi.get(self, "targets")

    @targets.setter
    def targets(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "targets", value)


if not MYPY:
    class ExperimentTemplateCloudWatchDashboardArgsDict(TypedDict):
        dashboard_identifier: pulumi.Input[str]
        """
        The Amazon Resource Name (ARN) of the CloudWatch dashboard to include in the experiment report.
        """
elif False:
    ExperimentTemplateCloudWatchDashboardArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateCloudWatchDashboardArgs:
    def __init__(__self__, *,
                 dashboard_identifier: pulumi.Input[str]):
        """
        :param pulumi.Input[str] dashboard_identifier: The Amazon Resource Name (ARN) of the CloudWatch dashboard to include in the experiment report.
        """
        pulumi.set(__self__, "dashboard_identifier", dashboard_identifier)

    @property
    @pulumi.getter(name="dashboardIdentifier")
    def dashboard_identifier(self) -> pulumi.Input[str]:
        """
        The Amazon Resource Name (ARN) of the CloudWatch dashboard to include in the experiment report.
        """
        return pulumi.get(self, "dashboard_identifier")

    @dashboard_identifier.setter
    def dashboard_identifier(self, value: pulumi.Input[str]):
        pulumi.set(self, "dashboard_identifier", value)


if not MYPY:
    class ExperimentTemplateExperimentOptionsArgsDict(TypedDict):
        account_targeting: NotRequired[pulumi.Input['ExperimentTemplateExperimentOptionsAccountTargeting']]
        """
        The account targeting setting for the experiment template.
        """
        empty_target_resolution_mode: NotRequired[pulumi.Input['ExperimentTemplateExperimentOptionsEmptyTargetResolutionMode']]
        """
        The target resolution failure mode for the experiment template.
        """
elif False:
    ExperimentTemplateExperimentOptionsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateExperimentOptionsArgs:
    def __init__(__self__, *,
                 account_targeting: Optional[pulumi.Input['ExperimentTemplateExperimentOptionsAccountTargeting']] = None,
                 empty_target_resolution_mode: Optional[pulumi.Input['ExperimentTemplateExperimentOptionsEmptyTargetResolutionMode']] = None):
        """
        :param pulumi.Input['ExperimentTemplateExperimentOptionsAccountTargeting'] account_targeting: The account targeting setting for the experiment template.
        :param pulumi.Input['ExperimentTemplateExperimentOptionsEmptyTargetResolutionMode'] empty_target_resolution_mode: The target resolution failure mode for the experiment template.
        """
        if account_targeting is not None:
            pulumi.set(__self__, "account_targeting", account_targeting)
        if empty_target_resolution_mode is not None:
            pulumi.set(__self__, "empty_target_resolution_mode", empty_target_resolution_mode)

    @property
    @pulumi.getter(name="accountTargeting")
    def account_targeting(self) -> Optional[pulumi.Input['ExperimentTemplateExperimentOptionsAccountTargeting']]:
        """
        The account targeting setting for the experiment template.
        """
        return pulumi.get(self, "account_targeting")

    @account_targeting.setter
    def account_targeting(self, value: Optional[pulumi.Input['ExperimentTemplateExperimentOptionsAccountTargeting']]):
        pulumi.set(self, "account_targeting", value)

    @property
    @pulumi.getter(name="emptyTargetResolutionMode")
    def empty_target_resolution_mode(self) -> Optional[pulumi.Input['ExperimentTemplateExperimentOptionsEmptyTargetResolutionMode']]:
        """
        The target resolution failure mode for the experiment template.
        """
        return pulumi.get(self, "empty_target_resolution_mode")

    @empty_target_resolution_mode.setter
    def empty_target_resolution_mode(self, value: Optional[pulumi.Input['ExperimentTemplateExperimentOptionsEmptyTargetResolutionMode']]):
        pulumi.set(self, "empty_target_resolution_mode", value)


if not MYPY:
    class ExperimentTemplateExperimentReportConfigurationDataSourcesPropertiesArgsDict(TypedDict):
        """
        The data sources for the experiment report.
        """
        cloud_watch_dashboards: NotRequired[pulumi.Input[Sequence[pulumi.Input['ExperimentTemplateCloudWatchDashboardArgsDict']]]]
elif False:
    ExperimentTemplateExperimentReportConfigurationDataSourcesPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateExperimentReportConfigurationDataSourcesPropertiesArgs:
    def __init__(__self__, *,
                 cloud_watch_dashboards: Optional[pulumi.Input[Sequence[pulumi.Input['ExperimentTemplateCloudWatchDashboardArgs']]]] = None):
        """
        The data sources for the experiment report.
        """
        if cloud_watch_dashboards is not None:
            pulumi.set(__self__, "cloud_watch_dashboards", cloud_watch_dashboards)

    @property
    @pulumi.getter(name="cloudWatchDashboards")
    def cloud_watch_dashboards(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ExperimentTemplateCloudWatchDashboardArgs']]]]:
        return pulumi.get(self, "cloud_watch_dashboards")

    @cloud_watch_dashboards.setter
    def cloud_watch_dashboards(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ExperimentTemplateCloudWatchDashboardArgs']]]]):
        pulumi.set(self, "cloud_watch_dashboards", value)


if not MYPY:
    class ExperimentTemplateExperimentReportConfigurationOutputsPropertiesExperimentReportS3ConfigurationPropertiesArgsDict(TypedDict):
        bucket_name: pulumi.Input[str]
        prefix: NotRequired[pulumi.Input[str]]
elif False:
    ExperimentTemplateExperimentReportConfigurationOutputsPropertiesExperimentReportS3ConfigurationPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateExperimentReportConfigurationOutputsPropertiesExperimentReportS3ConfigurationPropertiesArgs:
    def __init__(__self__, *,
                 bucket_name: pulumi.Input[str],
                 prefix: Optional[pulumi.Input[str]] = None):
        pulumi.set(__self__, "bucket_name", bucket_name)
        if prefix is not None:
            pulumi.set(__self__, "prefix", prefix)

    @property
    @pulumi.getter(name="bucketName")
    def bucket_name(self) -> pulumi.Input[str]:
        return pulumi.get(self, "bucket_name")

    @bucket_name.setter
    def bucket_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "bucket_name", value)

    @property
    @pulumi.getter
    def prefix(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "prefix")

    @prefix.setter
    def prefix(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "prefix", value)


if not MYPY:
    class ExperimentTemplateExperimentReportConfigurationOutputsPropertiesArgsDict(TypedDict):
        """
        The output destinations of the experiment report.
        """
        experiment_report_s3_configuration: pulumi.Input['ExperimentTemplateExperimentReportConfigurationOutputsPropertiesExperimentReportS3ConfigurationPropertiesArgsDict']
elif False:
    ExperimentTemplateExperimentReportConfigurationOutputsPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateExperimentReportConfigurationOutputsPropertiesArgs:
    def __init__(__self__, *,
                 experiment_report_s3_configuration: pulumi.Input['ExperimentTemplateExperimentReportConfigurationOutputsPropertiesExperimentReportS3ConfigurationPropertiesArgs']):
        """
        The output destinations of the experiment report.
        """
        pulumi.set(__self__, "experiment_report_s3_configuration", experiment_report_s3_configuration)

    @property
    @pulumi.getter(name="experimentReportS3Configuration")
    def experiment_report_s3_configuration(self) -> pulumi.Input['ExperimentTemplateExperimentReportConfigurationOutputsPropertiesExperimentReportS3ConfigurationPropertiesArgs']:
        return pulumi.get(self, "experiment_report_s3_configuration")

    @experiment_report_s3_configuration.setter
    def experiment_report_s3_configuration(self, value: pulumi.Input['ExperimentTemplateExperimentReportConfigurationOutputsPropertiesExperimentReportS3ConfigurationPropertiesArgs']):
        pulumi.set(self, "experiment_report_s3_configuration", value)


if not MYPY:
    class ExperimentTemplateExperimentReportConfigurationArgsDict(TypedDict):
        data_sources: pulumi.Input['ExperimentTemplateExperimentReportConfigurationDataSourcesPropertiesArgsDict']
        """
        The data sources for the experiment report.
        """
        outputs: pulumi.Input['ExperimentTemplateExperimentReportConfigurationOutputsPropertiesArgsDict']
        """
        The output destinations of the experiment report.
        """
        post_experiment_duration: NotRequired[pulumi.Input[str]]
        """
        The duration after the experiment end time for the data sources to include in the report.
        """
        pre_experiment_duration: NotRequired[pulumi.Input[str]]
        """
        The duration before the experiment start time for the data sources to include in the report.
        """
elif False:
    ExperimentTemplateExperimentReportConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateExperimentReportConfigurationArgs:
    def __init__(__self__, *,
                 data_sources: pulumi.Input['ExperimentTemplateExperimentReportConfigurationDataSourcesPropertiesArgs'],
                 outputs: pulumi.Input['ExperimentTemplateExperimentReportConfigurationOutputsPropertiesArgs'],
                 post_experiment_duration: Optional[pulumi.Input[str]] = None,
                 pre_experiment_duration: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input['ExperimentTemplateExperimentReportConfigurationDataSourcesPropertiesArgs'] data_sources: The data sources for the experiment report.
        :param pulumi.Input['ExperimentTemplateExperimentReportConfigurationOutputsPropertiesArgs'] outputs: The output destinations of the experiment report.
        :param pulumi.Input[str] post_experiment_duration: The duration after the experiment end time for the data sources to include in the report.
        :param pulumi.Input[str] pre_experiment_duration: The duration before the experiment start time for the data sources to include in the report.
        """
        pulumi.set(__self__, "data_sources", data_sources)
        pulumi.set(__self__, "outputs", outputs)
        if post_experiment_duration is not None:
            pulumi.set(__self__, "post_experiment_duration", post_experiment_duration)
        if pre_experiment_duration is not None:
            pulumi.set(__self__, "pre_experiment_duration", pre_experiment_duration)

    @property
    @pulumi.getter(name="dataSources")
    def data_sources(self) -> pulumi.Input['ExperimentTemplateExperimentReportConfigurationDataSourcesPropertiesArgs']:
        """
        The data sources for the experiment report.
        """
        return pulumi.get(self, "data_sources")

    @data_sources.setter
    def data_sources(self, value: pulumi.Input['ExperimentTemplateExperimentReportConfigurationDataSourcesPropertiesArgs']):
        pulumi.set(self, "data_sources", value)

    @property
    @pulumi.getter
    def outputs(self) -> pulumi.Input['ExperimentTemplateExperimentReportConfigurationOutputsPropertiesArgs']:
        """
        The output destinations of the experiment report.
        """
        return pulumi.get(self, "outputs")

    @outputs.setter
    def outputs(self, value: pulumi.Input['ExperimentTemplateExperimentReportConfigurationOutputsPropertiesArgs']):
        pulumi.set(self, "outputs", value)

    @property
    @pulumi.getter(name="postExperimentDuration")
    def post_experiment_duration(self) -> Optional[pulumi.Input[str]]:
        """
        The duration after the experiment end time for the data sources to include in the report.
        """
        return pulumi.get(self, "post_experiment_duration")

    @post_experiment_duration.setter
    def post_experiment_duration(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "post_experiment_duration", value)

    @property
    @pulumi.getter(name="preExperimentDuration")
    def pre_experiment_duration(self) -> Optional[pulumi.Input[str]]:
        """
        The duration before the experiment start time for the data sources to include in the report.
        """
        return pulumi.get(self, "pre_experiment_duration")

    @pre_experiment_duration.setter
    def pre_experiment_duration(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "pre_experiment_duration", value)


if not MYPY:
    class ExperimentTemplateLogConfigurationCloudWatchLogsConfigurationPropertiesArgsDict(TypedDict):
        """
        The configuration for experiment logging to CloudWatch Logs .
        """
        log_group_arn: pulumi.Input[str]
elif False:
    ExperimentTemplateLogConfigurationCloudWatchLogsConfigurationPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateLogConfigurationCloudWatchLogsConfigurationPropertiesArgs:
    def __init__(__self__, *,
                 log_group_arn: pulumi.Input[str]):
        """
        The configuration for experiment logging to CloudWatch Logs .
        """
        pulumi.set(__self__, "log_group_arn", log_group_arn)

    @property
    @pulumi.getter(name="logGroupArn")
    def log_group_arn(self) -> pulumi.Input[str]:
        return pulumi.get(self, "log_group_arn")

    @log_group_arn.setter
    def log_group_arn(self, value: pulumi.Input[str]):
        pulumi.set(self, "log_group_arn", value)


if not MYPY:
    class ExperimentTemplateLogConfigurationS3ConfigurationPropertiesArgsDict(TypedDict):
        """
        The configuration for experiment logging to Amazon S3 .
        """
        bucket_name: pulumi.Input[str]
        prefix: NotRequired[pulumi.Input[str]]
elif False:
    ExperimentTemplateLogConfigurationS3ConfigurationPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateLogConfigurationS3ConfigurationPropertiesArgs:
    def __init__(__self__, *,
                 bucket_name: pulumi.Input[str],
                 prefix: Optional[pulumi.Input[str]] = None):
        """
        The configuration for experiment logging to Amazon S3 .
        """
        pulumi.set(__self__, "bucket_name", bucket_name)
        if prefix is not None:
            pulumi.set(__self__, "prefix", prefix)

    @property
    @pulumi.getter(name="bucketName")
    def bucket_name(self) -> pulumi.Input[str]:
        return pulumi.get(self, "bucket_name")

    @bucket_name.setter
    def bucket_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "bucket_name", value)

    @property
    @pulumi.getter
    def prefix(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "prefix")

    @prefix.setter
    def prefix(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "prefix", value)


if not MYPY:
    class ExperimentTemplateLogConfigurationArgsDict(TypedDict):
        log_schema_version: pulumi.Input[int]
        """
        The schema version.
        """
        cloud_watch_logs_configuration: NotRequired[pulumi.Input['ExperimentTemplateLogConfigurationCloudWatchLogsConfigurationPropertiesArgsDict']]
        """
        The configuration for experiment logging to CloudWatch Logs .
        """
        s3_configuration: NotRequired[pulumi.Input['ExperimentTemplateLogConfigurationS3ConfigurationPropertiesArgsDict']]
        """
        The configuration for experiment logging to Amazon S3 .
        """
elif False:
    ExperimentTemplateLogConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateLogConfigurationArgs:
    def __init__(__self__, *,
                 log_schema_version: pulumi.Input[int],
                 cloud_watch_logs_configuration: Optional[pulumi.Input['ExperimentTemplateLogConfigurationCloudWatchLogsConfigurationPropertiesArgs']] = None,
                 s3_configuration: Optional[pulumi.Input['ExperimentTemplateLogConfigurationS3ConfigurationPropertiesArgs']] = None):
        """
        :param pulumi.Input[int] log_schema_version: The schema version.
        :param pulumi.Input['ExperimentTemplateLogConfigurationCloudWatchLogsConfigurationPropertiesArgs'] cloud_watch_logs_configuration: The configuration for experiment logging to CloudWatch Logs .
        :param pulumi.Input['ExperimentTemplateLogConfigurationS3ConfigurationPropertiesArgs'] s3_configuration: The configuration for experiment logging to Amazon S3 .
        """
        pulumi.set(__self__, "log_schema_version", log_schema_version)
        if cloud_watch_logs_configuration is not None:
            pulumi.set(__self__, "cloud_watch_logs_configuration", cloud_watch_logs_configuration)
        if s3_configuration is not None:
            pulumi.set(__self__, "s3_configuration", s3_configuration)

    @property
    @pulumi.getter(name="logSchemaVersion")
    def log_schema_version(self) -> pulumi.Input[int]:
        """
        The schema version.
        """
        return pulumi.get(self, "log_schema_version")

    @log_schema_version.setter
    def log_schema_version(self, value: pulumi.Input[int]):
        pulumi.set(self, "log_schema_version", value)

    @property
    @pulumi.getter(name="cloudWatchLogsConfiguration")
    def cloud_watch_logs_configuration(self) -> Optional[pulumi.Input['ExperimentTemplateLogConfigurationCloudWatchLogsConfigurationPropertiesArgs']]:
        """
        The configuration for experiment logging to CloudWatch Logs .
        """
        return pulumi.get(self, "cloud_watch_logs_configuration")

    @cloud_watch_logs_configuration.setter
    def cloud_watch_logs_configuration(self, value: Optional[pulumi.Input['ExperimentTemplateLogConfigurationCloudWatchLogsConfigurationPropertiesArgs']]):
        pulumi.set(self, "cloud_watch_logs_configuration", value)

    @property
    @pulumi.getter(name="s3Configuration")
    def s3_configuration(self) -> Optional[pulumi.Input['ExperimentTemplateLogConfigurationS3ConfigurationPropertiesArgs']]:
        """
        The configuration for experiment logging to Amazon S3 .
        """
        return pulumi.get(self, "s3_configuration")

    @s3_configuration.setter
    def s3_configuration(self, value: Optional[pulumi.Input['ExperimentTemplateLogConfigurationS3ConfigurationPropertiesArgs']]):
        pulumi.set(self, "s3_configuration", value)


if not MYPY:
    class ExperimentTemplateStopConditionArgsDict(TypedDict):
        source: pulumi.Input[str]
        value: NotRequired[pulumi.Input[str]]
elif False:
    ExperimentTemplateStopConditionArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateStopConditionArgs:
    def __init__(__self__, *,
                 source: pulumi.Input[str],
                 value: Optional[pulumi.Input[str]] = None):
        pulumi.set(__self__, "source", source)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def source(self) -> pulumi.Input[str]:
        return pulumi.get(self, "source")

    @source.setter
    def source(self, value: pulumi.Input[str]):
        pulumi.set(self, "source", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "value", value)


if not MYPY:
    class ExperimentTemplateTargetFilterArgsDict(TypedDict):
        """
        Describes a filter used for the target resource input in an experiment template.
        """
        path: pulumi.Input[str]
        values: pulumi.Input[Sequence[pulumi.Input[str]]]
elif False:
    ExperimentTemplateTargetFilterArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateTargetFilterArgs:
    def __init__(__self__, *,
                 path: pulumi.Input[str],
                 values: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        Describes a filter used for the target resource input in an experiment template.
        """
        pulumi.set(__self__, "path", path)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def path(self) -> pulumi.Input[str]:
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: pulumi.Input[str]):
        pulumi.set(self, "path", value)

    @property
    @pulumi.getter
    def values(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        return pulumi.get(self, "values")

    @values.setter
    def values(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "values", value)


if not MYPY:
    class ExperimentTemplateTargetArgsDict(TypedDict):
        """
        Specifies a target for an experiment.
        """
        resource_type: pulumi.Input[str]
        """
        The resource type.
        """
        selection_mode: pulumi.Input[str]
        """
        Scopes the identified resources to a specific count or percentage.
        """
        filters: NotRequired[pulumi.Input[Sequence[pulumi.Input['ExperimentTemplateTargetFilterArgsDict']]]]
        """
        The filters to apply to identify target resources using specific attributes.
        """
        parameters: NotRequired[pulumi.Input[Mapping[str, pulumi.Input[str]]]]
        """
        The parameters for the resource type.
        """
        resource_arns: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        The Amazon Resource Names (ARNs) of the targets.
        """
        resource_tags: NotRequired[pulumi.Input[Mapping[str, pulumi.Input[str]]]]
        """
        The tags for the target resources.
        """
elif False:
    ExperimentTemplateTargetArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExperimentTemplateTargetArgs:
    def __init__(__self__, *,
                 resource_type: pulumi.Input[str],
                 selection_mode: pulumi.Input[str],
                 filters: Optional[pulumi.Input[Sequence[pulumi.Input['ExperimentTemplateTargetFilterArgs']]]] = None,
                 parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 resource_arns: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 resource_tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        Specifies a target for an experiment.
        :param pulumi.Input[str] resource_type: The resource type.
        :param pulumi.Input[str] selection_mode: Scopes the identified resources to a specific count or percentage.
        :param pulumi.Input[Sequence[pulumi.Input['ExperimentTemplateTargetFilterArgs']]] filters: The filters to apply to identify target resources using specific attributes.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] parameters: The parameters for the resource type.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] resource_arns: The Amazon Resource Names (ARNs) of the targets.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] resource_tags: The tags for the target resources.
        """
        pulumi.set(__self__, "resource_type", resource_type)
        pulumi.set(__self__, "selection_mode", selection_mode)
        if filters is not None:
            pulumi.set(__self__, "filters", filters)
        if parameters is not None:
            pulumi.set(__self__, "parameters", parameters)
        if resource_arns is not None:
            pulumi.set(__self__, "resource_arns", resource_arns)
        if resource_tags is not None:
            pulumi.set(__self__, "resource_tags", resource_tags)

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> pulumi.Input[str]:
        """
        The resource type.
        """
        return pulumi.get(self, "resource_type")

    @resource_type.setter
    def resource_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_type", value)

    @property
    @pulumi.getter(name="selectionMode")
    def selection_mode(self) -> pulumi.Input[str]:
        """
        Scopes the identified resources to a specific count or percentage.
        """
        return pulumi.get(self, "selection_mode")

    @selection_mode.setter
    def selection_mode(self, value: pulumi.Input[str]):
        pulumi.set(self, "selection_mode", value)

    @property
    @pulumi.getter
    def filters(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ExperimentTemplateTargetFilterArgs']]]]:
        """
        The filters to apply to identify target resources using specific attributes.
        """
        return pulumi.get(self, "filters")

    @filters.setter
    def filters(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ExperimentTemplateTargetFilterArgs']]]]):
        pulumi.set(self, "filters", value)

    @property
    @pulumi.getter
    def parameters(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The parameters for the resource type.
        """
        return pulumi.get(self, "parameters")

    @parameters.setter
    def parameters(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "parameters", value)

    @property
    @pulumi.getter(name="resourceArns")
    def resource_arns(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The Amazon Resource Names (ARNs) of the targets.
        """
        return pulumi.get(self, "resource_arns")

    @resource_arns.setter
    def resource_arns(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "resource_arns", value)

    @property
    @pulumi.getter(name="resourceTags")
    def resource_tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The tags for the target resources.
        """
        return pulumi.get(self, "resource_tags")

    @resource_tags.setter
    def resource_tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "resource_tags", value)


