# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetNotificationChannelResult',
    'AwaitableGetNotificationChannelResult',
    'get_notification_channel',
    'get_notification_channel_output',
]

@pulumi.output_type
class GetNotificationChannelResult:
    def __init__(__self__, sns_role_name=None, sns_topic_arn=None):
        if sns_role_name and not isinstance(sns_role_name, str):
            raise TypeError("Expected argument 'sns_role_name' to be a str")
        pulumi.set(__self__, "sns_role_name", sns_role_name)
        if sns_topic_arn and not isinstance(sns_topic_arn, str):
            raise TypeError("Expected argument 'sns_topic_arn' to be a str")
        pulumi.set(__self__, "sns_topic_arn", sns_topic_arn)

    @property
    @pulumi.getter(name="snsRoleName")
    def sns_role_name(self) -> Optional[str]:
        """
        The Amazon Resource Name (ARN) of the IAM role that allows Amazon SNS to record AWS Firewall Manager activity.
        """
        return pulumi.get(self, "sns_role_name")

    @property
    @pulumi.getter(name="snsTopicArn")
    def sns_topic_arn(self) -> Optional[str]:
        """
        The Amazon Resource Name (ARN) of the SNS topic that collects notifications from AWS Firewall Manager .
        """
        return pulumi.get(self, "sns_topic_arn")


class AwaitableGetNotificationChannelResult(GetNotificationChannelResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNotificationChannelResult(
            sns_role_name=self.sns_role_name,
            sns_topic_arn=self.sns_topic_arn)


def get_notification_channel(sns_topic_arn: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNotificationChannelResult:
    """
    Designates the IAM role and Amazon Simple Notification Service (SNS) topic that AWS Firewall Manager uses to record SNS logs.


    :param str sns_topic_arn: The Amazon Resource Name (ARN) of the SNS topic that collects notifications from AWS Firewall Manager .
    """
    __args__ = dict()
    __args__['snsTopicArn'] = sns_topic_arn
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:fms:getNotificationChannel', __args__, opts=opts, typ=GetNotificationChannelResult).value

    return AwaitableGetNotificationChannelResult(
        sns_role_name=pulumi.get(__ret__, 'sns_role_name'),
        sns_topic_arn=pulumi.get(__ret__, 'sns_topic_arn'))
def get_notification_channel_output(sns_topic_arn: Optional[pulumi.Input[str]] = None,
                                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetNotificationChannelResult]:
    """
    Designates the IAM role and Amazon Simple Notification Service (SNS) topic that AWS Firewall Manager uses to record SNS logs.


    :param str sns_topic_arn: The Amazon Resource Name (ARN) of the SNS topic that collects notifications from AWS Firewall Manager .
    """
    __args__ = dict()
    __args__['snsTopicArn'] = sns_topic_arn
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('aws-native:fms:getNotificationChannel', __args__, opts=opts, typ=GetNotificationChannelResult)
    return __ret__.apply(lambda __response__: GetNotificationChannelResult(
        sns_role_name=pulumi.get(__response__, 'sns_role_name'),
        sns_topic_arn=pulumi.get(__response__, 'sns_topic_arn')))
