# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'ComponentVersionComponentDependencyRequirementArgs',
    'ComponentVersionComponentDependencyRequirementArgsDict',
    'ComponentVersionComponentPlatformArgs',
    'ComponentVersionComponentPlatformArgsDict',
    'ComponentVersionLambdaContainerParamsArgs',
    'ComponentVersionLambdaContainerParamsArgsDict',
    'ComponentVersionLambdaDeviceMountArgs',
    'ComponentVersionLambdaDeviceMountArgsDict',
    'ComponentVersionLambdaEventSourceArgs',
    'ComponentVersionLambdaEventSourceArgsDict',
    'ComponentVersionLambdaExecutionParametersArgs',
    'ComponentVersionLambdaExecutionParametersArgsDict',
    'ComponentVersionLambdaFunctionRecipeSourceArgs',
    'ComponentVersionLambdaFunctionRecipeSourceArgsDict',
    'ComponentVersionLambdaLinuxProcessParamsArgs',
    'ComponentVersionLambdaLinuxProcessParamsArgsDict',
    'ComponentVersionLambdaVolumeMountArgs',
    'ComponentVersionLambdaVolumeMountArgsDict',
    'DeploymentComponentConfigurationUpdateArgs',
    'DeploymentComponentConfigurationUpdateArgsDict',
    'DeploymentComponentDeploymentSpecificationArgs',
    'DeploymentComponentDeploymentSpecificationArgsDict',
    'DeploymentComponentRunWithArgs',
    'DeploymentComponentRunWithArgsDict',
    'DeploymentComponentUpdatePolicyArgs',
    'DeploymentComponentUpdatePolicyArgsDict',
    'DeploymentConfigurationValidationPolicyArgs',
    'DeploymentConfigurationValidationPolicyArgsDict',
    'DeploymentIoTJobAbortConfigArgs',
    'DeploymentIoTJobAbortConfigArgsDict',
    'DeploymentIoTJobAbortCriteriaArgs',
    'DeploymentIoTJobAbortCriteriaArgsDict',
    'DeploymentIoTJobConfigurationArgs',
    'DeploymentIoTJobConfigurationArgsDict',
    'DeploymentIoTJobExecutionsRolloutConfigArgs',
    'DeploymentIoTJobExecutionsRolloutConfigArgsDict',
    'DeploymentIoTJobExponentialRolloutRateArgs',
    'DeploymentIoTJobExponentialRolloutRateArgsDict',
    'DeploymentIoTJobRateIncreaseCriteriaArgs',
    'DeploymentIoTJobRateIncreaseCriteriaArgsDict',
    'DeploymentIoTJobTimeoutConfigArgs',
    'DeploymentIoTJobTimeoutConfigArgsDict',
    'DeploymentPoliciesArgs',
    'DeploymentPoliciesArgsDict',
    'DeploymentSystemResourceLimitsArgs',
    'DeploymentSystemResourceLimitsArgsDict',
]

MYPY = False

if not MYPY:
    class ComponentVersionComponentDependencyRequirementArgsDict(TypedDict):
        dependency_type: NotRequired[pulumi.Input['ComponentVersionComponentDependencyRequirementDependencyType']]
        version_requirement: NotRequired[pulumi.Input[str]]
elif False:
    ComponentVersionComponentDependencyRequirementArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ComponentVersionComponentDependencyRequirementArgs:
    def __init__(__self__, *,
                 dependency_type: Optional[pulumi.Input['ComponentVersionComponentDependencyRequirementDependencyType']] = None,
                 version_requirement: Optional[pulumi.Input[str]] = None):
        if dependency_type is not None:
            pulumi.set(__self__, "dependency_type", dependency_type)
        if version_requirement is not None:
            pulumi.set(__self__, "version_requirement", version_requirement)

    @property
    @pulumi.getter(name="dependencyType")
    def dependency_type(self) -> Optional[pulumi.Input['ComponentVersionComponentDependencyRequirementDependencyType']]:
        return pulumi.get(self, "dependency_type")

    @dependency_type.setter
    def dependency_type(self, value: Optional[pulumi.Input['ComponentVersionComponentDependencyRequirementDependencyType']]):
        pulumi.set(self, "dependency_type", value)

    @property
    @pulumi.getter(name="versionRequirement")
    def version_requirement(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "version_requirement")

    @version_requirement.setter
    def version_requirement(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version_requirement", value)


if not MYPY:
    class ComponentVersionComponentPlatformArgsDict(TypedDict):
        attributes: NotRequired[pulumi.Input[Mapping[str, pulumi.Input[str]]]]
        """
        A dictionary of attributes for the platform. The AWS IoT Greengrass Core software defines the `os` and `platform` by default. You can specify additional platform attributes for a core device when you deploy the AWS IoT Greengrass nucleus component. For more information, see the [AWS IoT Greengrass nucleus component](https://docs.aws.amazon.com/greengrass/v2/developerguide/greengrass-nucleus-component.html) in the *AWS IoT Greengrass V2 Developer Guide* .
        """
        name: NotRequired[pulumi.Input[str]]
        """
        The friendly name of the platform. This name helps you identify the platform.

        If you omit this parameter, AWS IoT Greengrass creates a friendly name from the `os` and `architecture` of the platform.
        """
elif False:
    ComponentVersionComponentPlatformArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ComponentVersionComponentPlatformArgs:
    def __init__(__self__, *,
                 attributes: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] attributes: A dictionary of attributes for the platform. The AWS IoT Greengrass Core software defines the `os` and `platform` by default. You can specify additional platform attributes for a core device when you deploy the AWS IoT Greengrass nucleus component. For more information, see the [AWS IoT Greengrass nucleus component](https://docs.aws.amazon.com/greengrass/v2/developerguide/greengrass-nucleus-component.html) in the *AWS IoT Greengrass V2 Developer Guide* .
        :param pulumi.Input[str] name: The friendly name of the platform. This name helps you identify the platform.
               
               If you omit this parameter, AWS IoT Greengrass creates a friendly name from the `os` and `architecture` of the platform.
        """
        if attributes is not None:
            pulumi.set(__self__, "attributes", attributes)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def attributes(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A dictionary of attributes for the platform. The AWS IoT Greengrass Core software defines the `os` and `platform` by default. You can specify additional platform attributes for a core device when you deploy the AWS IoT Greengrass nucleus component. For more information, see the [AWS IoT Greengrass nucleus component](https://docs.aws.amazon.com/greengrass/v2/developerguide/greengrass-nucleus-component.html) in the *AWS IoT Greengrass V2 Developer Guide* .
        """
        return pulumi.get(self, "attributes")

    @attributes.setter
    def attributes(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "attributes", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The friendly name of the platform. This name helps you identify the platform.

        If you omit this parameter, AWS IoT Greengrass creates a friendly name from the `os` and `architecture` of the platform.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


if not MYPY:
    class ComponentVersionLambdaContainerParamsArgsDict(TypedDict):
        devices: NotRequired[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaDeviceMountArgsDict']]]]
        """
        The list of system devices that the container can access.
        """
        memory_size_in_kb: NotRequired[pulumi.Input[int]]
        """
        The memory size of the container, expressed in kilobytes.

        Default: `16384` (16 MB)
        """
        mount_ro_sysfs: NotRequired[pulumi.Input[bool]]
        """
        Whether or not the container can read information from the device's `/sys` folder.

        Default: `false`
        """
        volumes: NotRequired[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaVolumeMountArgsDict']]]]
        """
        The list of volumes that the container can access.
        """
elif False:
    ComponentVersionLambdaContainerParamsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ComponentVersionLambdaContainerParamsArgs:
    def __init__(__self__, *,
                 devices: Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaDeviceMountArgs']]]] = None,
                 memory_size_in_kb: Optional[pulumi.Input[int]] = None,
                 mount_ro_sysfs: Optional[pulumi.Input[bool]] = None,
                 volumes: Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaVolumeMountArgs']]]] = None):
        """
        :param pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaDeviceMountArgs']]] devices: The list of system devices that the container can access.
        :param pulumi.Input[int] memory_size_in_kb: The memory size of the container, expressed in kilobytes.
               
               Default: `16384` (16 MB)
        :param pulumi.Input[bool] mount_ro_sysfs: Whether or not the container can read information from the device's `/sys` folder.
               
               Default: `false`
        :param pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaVolumeMountArgs']]] volumes: The list of volumes that the container can access.
        """
        if devices is not None:
            pulumi.set(__self__, "devices", devices)
        if memory_size_in_kb is not None:
            pulumi.set(__self__, "memory_size_in_kb", memory_size_in_kb)
        if mount_ro_sysfs is not None:
            pulumi.set(__self__, "mount_ro_sysfs", mount_ro_sysfs)
        if volumes is not None:
            pulumi.set(__self__, "volumes", volumes)

    @property
    @pulumi.getter
    def devices(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaDeviceMountArgs']]]]:
        """
        The list of system devices that the container can access.
        """
        return pulumi.get(self, "devices")

    @devices.setter
    def devices(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaDeviceMountArgs']]]]):
        pulumi.set(self, "devices", value)

    @property
    @pulumi.getter(name="memorySizeInKb")
    def memory_size_in_kb(self) -> Optional[pulumi.Input[int]]:
        """
        The memory size of the container, expressed in kilobytes.

        Default: `16384` (16 MB)
        """
        return pulumi.get(self, "memory_size_in_kb")

    @memory_size_in_kb.setter
    def memory_size_in_kb(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "memory_size_in_kb", value)

    @property
    @pulumi.getter(name="mountRoSysfs")
    def mount_ro_sysfs(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether or not the container can read information from the device's `/sys` folder.

        Default: `false`
        """
        return pulumi.get(self, "mount_ro_sysfs")

    @mount_ro_sysfs.setter
    def mount_ro_sysfs(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "mount_ro_sysfs", value)

    @property
    @pulumi.getter
    def volumes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaVolumeMountArgs']]]]:
        """
        The list of volumes that the container can access.
        """
        return pulumi.get(self, "volumes")

    @volumes.setter
    def volumes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaVolumeMountArgs']]]]):
        pulumi.set(self, "volumes", value)


if not MYPY:
    class ComponentVersionLambdaDeviceMountArgsDict(TypedDict):
        add_group_owner: NotRequired[pulumi.Input[bool]]
        """
        Whether or not to add the component's system user as an owner of the device.

        Default: `false`
        """
        path: NotRequired[pulumi.Input[str]]
        """
        The mount path for the device in the file system.
        """
        permission: NotRequired[pulumi.Input['ComponentVersionLambdaFilesystemPermission']]
        """
        The permission to access the device: read/only ( `ro` ) or read/write ( `rw` ).

        Default: `ro`
        """
elif False:
    ComponentVersionLambdaDeviceMountArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ComponentVersionLambdaDeviceMountArgs:
    def __init__(__self__, *,
                 add_group_owner: Optional[pulumi.Input[bool]] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 permission: Optional[pulumi.Input['ComponentVersionLambdaFilesystemPermission']] = None):
        """
        :param pulumi.Input[bool] add_group_owner: Whether or not to add the component's system user as an owner of the device.
               
               Default: `false`
        :param pulumi.Input[str] path: The mount path for the device in the file system.
        :param pulumi.Input['ComponentVersionLambdaFilesystemPermission'] permission: The permission to access the device: read/only ( `ro` ) or read/write ( `rw` ).
               
               Default: `ro`
        """
        if add_group_owner is not None:
            pulumi.set(__self__, "add_group_owner", add_group_owner)
        if path is not None:
            pulumi.set(__self__, "path", path)
        if permission is not None:
            pulumi.set(__self__, "permission", permission)

    @property
    @pulumi.getter(name="addGroupOwner")
    def add_group_owner(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether or not to add the component's system user as an owner of the device.

        Default: `false`
        """
        return pulumi.get(self, "add_group_owner")

    @add_group_owner.setter
    def add_group_owner(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "add_group_owner", value)

    @property
    @pulumi.getter
    def path(self) -> Optional[pulumi.Input[str]]:
        """
        The mount path for the device in the file system.
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "path", value)

    @property
    @pulumi.getter
    def permission(self) -> Optional[pulumi.Input['ComponentVersionLambdaFilesystemPermission']]:
        """
        The permission to access the device: read/only ( `ro` ) or read/write ( `rw` ).

        Default: `ro`
        """
        return pulumi.get(self, "permission")

    @permission.setter
    def permission(self, value: Optional[pulumi.Input['ComponentVersionLambdaFilesystemPermission']]):
        pulumi.set(self, "permission", value)


if not MYPY:
    class ComponentVersionLambdaEventSourceArgsDict(TypedDict):
        topic: NotRequired[pulumi.Input[str]]
        """
        The topic to which to subscribe to receive event messages.
        """
        type: NotRequired[pulumi.Input['ComponentVersionLambdaEventSourceType']]
        """
        The type of event source. Choose from the following options:

        - `PUB_SUB` – Subscribe to local publish/subscribe messages. This event source type doesn't support MQTT wildcards ( `+` and `#` ) in the event source topic.
        - `IOT_CORE` – Subscribe to AWS IoT Core MQTT messages. This event source type supports MQTT wildcards ( `+` and `#` ) in the event source topic.
        """
elif False:
    ComponentVersionLambdaEventSourceArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ComponentVersionLambdaEventSourceArgs:
    def __init__(__self__, *,
                 topic: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input['ComponentVersionLambdaEventSourceType']] = None):
        """
        :param pulumi.Input[str] topic: The topic to which to subscribe to receive event messages.
        :param pulumi.Input['ComponentVersionLambdaEventSourceType'] type: The type of event source. Choose from the following options:
               
               - `PUB_SUB` – Subscribe to local publish/subscribe messages. This event source type doesn't support MQTT wildcards ( `+` and `#` ) in the event source topic.
               - `IOT_CORE` – Subscribe to AWS IoT Core MQTT messages. This event source type supports MQTT wildcards ( `+` and `#` ) in the event source topic.
        """
        if topic is not None:
            pulumi.set(__self__, "topic", topic)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def topic(self) -> Optional[pulumi.Input[str]]:
        """
        The topic to which to subscribe to receive event messages.
        """
        return pulumi.get(self, "topic")

    @topic.setter
    def topic(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "topic", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input['ComponentVersionLambdaEventSourceType']]:
        """
        The type of event source. Choose from the following options:

        - `PUB_SUB` – Subscribe to local publish/subscribe messages. This event source type doesn't support MQTT wildcards ( `+` and `#` ) in the event source topic.
        - `IOT_CORE` – Subscribe to AWS IoT Core MQTT messages. This event source type supports MQTT wildcards ( `+` and `#` ) in the event source topic.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input['ComponentVersionLambdaEventSourceType']]):
        pulumi.set(self, "type", value)


if not MYPY:
    class ComponentVersionLambdaExecutionParametersArgsDict(TypedDict):
        environment_variables: NotRequired[pulumi.Input[Mapping[str, pulumi.Input[str]]]]
        """
        The map of environment variables that are available to the Lambda function when it runs.
        """
        event_sources: NotRequired[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaEventSourceArgsDict']]]]
        """
        The list of event sources to which to subscribe to receive work messages. The Lambda function runs when it receives a message from an event source. You can subscribe this function to local publish/subscribe messages and AWS IoT Core MQTT messages.
        """
        exec_args: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        The list of arguments to pass to the Lambda function when it runs.
        """
        input_payload_encoding_type: NotRequired[pulumi.Input['ComponentVersionLambdaExecutionParametersInputPayloadEncodingType']]
        """
        The encoding type that the Lambda function supports.

        Default: `json`
        """
        linux_process_params: NotRequired[pulumi.Input['ComponentVersionLambdaLinuxProcessParamsArgsDict']]
        """
        The parameters for the Linux process that contains the Lambda function.
        """
        max_idle_time_in_seconds: NotRequired[pulumi.Input[int]]
        """
        The maximum amount of time in seconds that a non-pinned Lambda function can idle before the AWS IoT Greengrass Core software stops its process.
        """
        max_instances_count: NotRequired[pulumi.Input[int]]
        """
        The maximum number of instances that a non-pinned Lambda function can run at the same time.
        """
        max_queue_size: NotRequired[pulumi.Input[int]]
        """
        The maximum size of the message queue for the Lambda function component. The AWS IoT Greengrass core device stores messages in a FIFO (first-in-first-out) queue until it can run the Lambda function to consume each message.
        """
        pinned: NotRequired[pulumi.Input[bool]]
        """
        Whether or not the Lambda function is pinned, or long-lived.

        - A pinned Lambda function starts when the AWS IoT Greengrass Core starts and keeps running in its own container.
        - A non-pinned Lambda function starts only when it receives a work item and exists after it idles for `maxIdleTimeInSeconds` . If the function has multiple work items, the AWS IoT Greengrass Core software creates multiple instances of the function.

        Default: `true`
        """
        status_timeout_in_seconds: NotRequired[pulumi.Input[int]]
        """
        The interval in seconds at which a pinned (also known as long-lived) Lambda function component sends status updates to the Lambda manager component.
        """
        timeout_in_seconds: NotRequired[pulumi.Input[int]]
        """
        The maximum amount of time in seconds that the Lambda function can process a work item.
        """
elif False:
    ComponentVersionLambdaExecutionParametersArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ComponentVersionLambdaExecutionParametersArgs:
    def __init__(__self__, *,
                 environment_variables: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 event_sources: Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaEventSourceArgs']]]] = None,
                 exec_args: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 input_payload_encoding_type: Optional[pulumi.Input['ComponentVersionLambdaExecutionParametersInputPayloadEncodingType']] = None,
                 linux_process_params: Optional[pulumi.Input['ComponentVersionLambdaLinuxProcessParamsArgs']] = None,
                 max_idle_time_in_seconds: Optional[pulumi.Input[int]] = None,
                 max_instances_count: Optional[pulumi.Input[int]] = None,
                 max_queue_size: Optional[pulumi.Input[int]] = None,
                 pinned: Optional[pulumi.Input[bool]] = None,
                 status_timeout_in_seconds: Optional[pulumi.Input[int]] = None,
                 timeout_in_seconds: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] environment_variables: The map of environment variables that are available to the Lambda function when it runs.
        :param pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaEventSourceArgs']]] event_sources: The list of event sources to which to subscribe to receive work messages. The Lambda function runs when it receives a message from an event source. You can subscribe this function to local publish/subscribe messages and AWS IoT Core MQTT messages.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] exec_args: The list of arguments to pass to the Lambda function when it runs.
        :param pulumi.Input['ComponentVersionLambdaExecutionParametersInputPayloadEncodingType'] input_payload_encoding_type: The encoding type that the Lambda function supports.
               
               Default: `json`
        :param pulumi.Input['ComponentVersionLambdaLinuxProcessParamsArgs'] linux_process_params: The parameters for the Linux process that contains the Lambda function.
        :param pulumi.Input[int] max_idle_time_in_seconds: The maximum amount of time in seconds that a non-pinned Lambda function can idle before the AWS IoT Greengrass Core software stops its process.
        :param pulumi.Input[int] max_instances_count: The maximum number of instances that a non-pinned Lambda function can run at the same time.
        :param pulumi.Input[int] max_queue_size: The maximum size of the message queue for the Lambda function component. The AWS IoT Greengrass core device stores messages in a FIFO (first-in-first-out) queue until it can run the Lambda function to consume each message.
        :param pulumi.Input[bool] pinned: Whether or not the Lambda function is pinned, or long-lived.
               
               - A pinned Lambda function starts when the AWS IoT Greengrass Core starts and keeps running in its own container.
               - A non-pinned Lambda function starts only when it receives a work item and exists after it idles for `maxIdleTimeInSeconds` . If the function has multiple work items, the AWS IoT Greengrass Core software creates multiple instances of the function.
               
               Default: `true`
        :param pulumi.Input[int] status_timeout_in_seconds: The interval in seconds at which a pinned (also known as long-lived) Lambda function component sends status updates to the Lambda manager component.
        :param pulumi.Input[int] timeout_in_seconds: The maximum amount of time in seconds that the Lambda function can process a work item.
        """
        if environment_variables is not None:
            pulumi.set(__self__, "environment_variables", environment_variables)
        if event_sources is not None:
            pulumi.set(__self__, "event_sources", event_sources)
        if exec_args is not None:
            pulumi.set(__self__, "exec_args", exec_args)
        if input_payload_encoding_type is not None:
            pulumi.set(__self__, "input_payload_encoding_type", input_payload_encoding_type)
        if linux_process_params is not None:
            pulumi.set(__self__, "linux_process_params", linux_process_params)
        if max_idle_time_in_seconds is not None:
            pulumi.set(__self__, "max_idle_time_in_seconds", max_idle_time_in_seconds)
        if max_instances_count is not None:
            pulumi.set(__self__, "max_instances_count", max_instances_count)
        if max_queue_size is not None:
            pulumi.set(__self__, "max_queue_size", max_queue_size)
        if pinned is not None:
            pulumi.set(__self__, "pinned", pinned)
        if status_timeout_in_seconds is not None:
            pulumi.set(__self__, "status_timeout_in_seconds", status_timeout_in_seconds)
        if timeout_in_seconds is not None:
            pulumi.set(__self__, "timeout_in_seconds", timeout_in_seconds)

    @property
    @pulumi.getter(name="environmentVariables")
    def environment_variables(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The map of environment variables that are available to the Lambda function when it runs.
        """
        return pulumi.get(self, "environment_variables")

    @environment_variables.setter
    def environment_variables(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "environment_variables", value)

    @property
    @pulumi.getter(name="eventSources")
    def event_sources(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaEventSourceArgs']]]]:
        """
        The list of event sources to which to subscribe to receive work messages. The Lambda function runs when it receives a message from an event source. You can subscribe this function to local publish/subscribe messages and AWS IoT Core MQTT messages.
        """
        return pulumi.get(self, "event_sources")

    @event_sources.setter
    def event_sources(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionLambdaEventSourceArgs']]]]):
        pulumi.set(self, "event_sources", value)

    @property
    @pulumi.getter(name="execArgs")
    def exec_args(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of arguments to pass to the Lambda function when it runs.
        """
        return pulumi.get(self, "exec_args")

    @exec_args.setter
    def exec_args(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "exec_args", value)

    @property
    @pulumi.getter(name="inputPayloadEncodingType")
    def input_payload_encoding_type(self) -> Optional[pulumi.Input['ComponentVersionLambdaExecutionParametersInputPayloadEncodingType']]:
        """
        The encoding type that the Lambda function supports.

        Default: `json`
        """
        return pulumi.get(self, "input_payload_encoding_type")

    @input_payload_encoding_type.setter
    def input_payload_encoding_type(self, value: Optional[pulumi.Input['ComponentVersionLambdaExecutionParametersInputPayloadEncodingType']]):
        pulumi.set(self, "input_payload_encoding_type", value)

    @property
    @pulumi.getter(name="linuxProcessParams")
    def linux_process_params(self) -> Optional[pulumi.Input['ComponentVersionLambdaLinuxProcessParamsArgs']]:
        """
        The parameters for the Linux process that contains the Lambda function.
        """
        return pulumi.get(self, "linux_process_params")

    @linux_process_params.setter
    def linux_process_params(self, value: Optional[pulumi.Input['ComponentVersionLambdaLinuxProcessParamsArgs']]):
        pulumi.set(self, "linux_process_params", value)

    @property
    @pulumi.getter(name="maxIdleTimeInSeconds")
    def max_idle_time_in_seconds(self) -> Optional[pulumi.Input[int]]:
        """
        The maximum amount of time in seconds that a non-pinned Lambda function can idle before the AWS IoT Greengrass Core software stops its process.
        """
        return pulumi.get(self, "max_idle_time_in_seconds")

    @max_idle_time_in_seconds.setter
    def max_idle_time_in_seconds(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "max_idle_time_in_seconds", value)

    @property
    @pulumi.getter(name="maxInstancesCount")
    def max_instances_count(self) -> Optional[pulumi.Input[int]]:
        """
        The maximum number of instances that a non-pinned Lambda function can run at the same time.
        """
        return pulumi.get(self, "max_instances_count")

    @max_instances_count.setter
    def max_instances_count(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "max_instances_count", value)

    @property
    @pulumi.getter(name="maxQueueSize")
    def max_queue_size(self) -> Optional[pulumi.Input[int]]:
        """
        The maximum size of the message queue for the Lambda function component. The AWS IoT Greengrass core device stores messages in a FIFO (first-in-first-out) queue until it can run the Lambda function to consume each message.
        """
        return pulumi.get(self, "max_queue_size")

    @max_queue_size.setter
    def max_queue_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "max_queue_size", value)

    @property
    @pulumi.getter
    def pinned(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether or not the Lambda function is pinned, or long-lived.

        - A pinned Lambda function starts when the AWS IoT Greengrass Core starts and keeps running in its own container.
        - A non-pinned Lambda function starts only when it receives a work item and exists after it idles for `maxIdleTimeInSeconds` . If the function has multiple work items, the AWS IoT Greengrass Core software creates multiple instances of the function.

        Default: `true`
        """
        return pulumi.get(self, "pinned")

    @pinned.setter
    def pinned(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "pinned", value)

    @property
    @pulumi.getter(name="statusTimeoutInSeconds")
    def status_timeout_in_seconds(self) -> Optional[pulumi.Input[int]]:
        """
        The interval in seconds at which a pinned (also known as long-lived) Lambda function component sends status updates to the Lambda manager component.
        """
        return pulumi.get(self, "status_timeout_in_seconds")

    @status_timeout_in_seconds.setter
    def status_timeout_in_seconds(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "status_timeout_in_seconds", value)

    @property
    @pulumi.getter(name="timeoutInSeconds")
    def timeout_in_seconds(self) -> Optional[pulumi.Input[int]]:
        """
        The maximum amount of time in seconds that the Lambda function can process a work item.
        """
        return pulumi.get(self, "timeout_in_seconds")

    @timeout_in_seconds.setter
    def timeout_in_seconds(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "timeout_in_seconds", value)


if not MYPY:
    class ComponentVersionLambdaFunctionRecipeSourceArgsDict(TypedDict):
        component_dependencies: NotRequired[pulumi.Input[Mapping[str, pulumi.Input['ComponentVersionComponentDependencyRequirementArgsDict']]]]
        """
        The component versions on which this Lambda function component depends.
        """
        component_lambda_parameters: NotRequired[pulumi.Input['ComponentVersionLambdaExecutionParametersArgsDict']]
        """
        The system and runtime parameters for the Lambda function as it runs on the AWS IoT Greengrass core device.
        """
        component_name: NotRequired[pulumi.Input[str]]
        """
        The name of the component.

        Defaults to the name of the Lambda function.
        """
        component_platforms: NotRequired[pulumi.Input[Sequence[pulumi.Input['ComponentVersionComponentPlatformArgsDict']]]]
        """
        The platforms that the component version supports.
        """
        component_version: NotRequired[pulumi.Input[str]]
        """
        The version of the component.

        Defaults to the version of the Lambda function as a semantic version. For example, if your function version is `3` , the component version becomes `3.0.0` .
        """
        lambda_arn: NotRequired[pulumi.Input[str]]
        """
        The ARN of the Lambda function. The ARN must include the version of the function to import. You can't use version aliases like `$LATEST` .
        """
elif False:
    ComponentVersionLambdaFunctionRecipeSourceArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ComponentVersionLambdaFunctionRecipeSourceArgs:
    def __init__(__self__, *,
                 component_dependencies: Optional[pulumi.Input[Mapping[str, pulumi.Input['ComponentVersionComponentDependencyRequirementArgs']]]] = None,
                 component_lambda_parameters: Optional[pulumi.Input['ComponentVersionLambdaExecutionParametersArgs']] = None,
                 component_name: Optional[pulumi.Input[str]] = None,
                 component_platforms: Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionComponentPlatformArgs']]]] = None,
                 component_version: Optional[pulumi.Input[str]] = None,
                 lambda_arn: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[Mapping[str, pulumi.Input['ComponentVersionComponentDependencyRequirementArgs']]] component_dependencies: The component versions on which this Lambda function component depends.
        :param pulumi.Input['ComponentVersionLambdaExecutionParametersArgs'] component_lambda_parameters: The system and runtime parameters for the Lambda function as it runs on the AWS IoT Greengrass core device.
        :param pulumi.Input[str] component_name: The name of the component.
               
               Defaults to the name of the Lambda function.
        :param pulumi.Input[Sequence[pulumi.Input['ComponentVersionComponentPlatformArgs']]] component_platforms: The platforms that the component version supports.
        :param pulumi.Input[str] component_version: The version of the component.
               
               Defaults to the version of the Lambda function as a semantic version. For example, if your function version is `3` , the component version becomes `3.0.0` .
        :param pulumi.Input[str] lambda_arn: The ARN of the Lambda function. The ARN must include the version of the function to import. You can't use version aliases like `$LATEST` .
        """
        if component_dependencies is not None:
            pulumi.set(__self__, "component_dependencies", component_dependencies)
        if component_lambda_parameters is not None:
            pulumi.set(__self__, "component_lambda_parameters", component_lambda_parameters)
        if component_name is not None:
            pulumi.set(__self__, "component_name", component_name)
        if component_platforms is not None:
            pulumi.set(__self__, "component_platforms", component_platforms)
        if component_version is not None:
            pulumi.set(__self__, "component_version", component_version)
        if lambda_arn is not None:
            pulumi.set(__self__, "lambda_arn", lambda_arn)

    @property
    @pulumi.getter(name="componentDependencies")
    def component_dependencies(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input['ComponentVersionComponentDependencyRequirementArgs']]]]:
        """
        The component versions on which this Lambda function component depends.
        """
        return pulumi.get(self, "component_dependencies")

    @component_dependencies.setter
    def component_dependencies(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input['ComponentVersionComponentDependencyRequirementArgs']]]]):
        pulumi.set(self, "component_dependencies", value)

    @property
    @pulumi.getter(name="componentLambdaParameters")
    def component_lambda_parameters(self) -> Optional[pulumi.Input['ComponentVersionLambdaExecutionParametersArgs']]:
        """
        The system and runtime parameters for the Lambda function as it runs on the AWS IoT Greengrass core device.
        """
        return pulumi.get(self, "component_lambda_parameters")

    @component_lambda_parameters.setter
    def component_lambda_parameters(self, value: Optional[pulumi.Input['ComponentVersionLambdaExecutionParametersArgs']]):
        pulumi.set(self, "component_lambda_parameters", value)

    @property
    @pulumi.getter(name="componentName")
    def component_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the component.

        Defaults to the name of the Lambda function.
        """
        return pulumi.get(self, "component_name")

    @component_name.setter
    def component_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "component_name", value)

    @property
    @pulumi.getter(name="componentPlatforms")
    def component_platforms(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionComponentPlatformArgs']]]]:
        """
        The platforms that the component version supports.
        """
        return pulumi.get(self, "component_platforms")

    @component_platforms.setter
    def component_platforms(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ComponentVersionComponentPlatformArgs']]]]):
        pulumi.set(self, "component_platforms", value)

    @property
    @pulumi.getter(name="componentVersion")
    def component_version(self) -> Optional[pulumi.Input[str]]:
        """
        The version of the component.

        Defaults to the version of the Lambda function as a semantic version. For example, if your function version is `3` , the component version becomes `3.0.0` .
        """
        return pulumi.get(self, "component_version")

    @component_version.setter
    def component_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "component_version", value)

    @property
    @pulumi.getter(name="lambdaArn")
    def lambda_arn(self) -> Optional[pulumi.Input[str]]:
        """
        The ARN of the Lambda function. The ARN must include the version of the function to import. You can't use version aliases like `$LATEST` .
        """
        return pulumi.get(self, "lambda_arn")

    @lambda_arn.setter
    def lambda_arn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "lambda_arn", value)


if not MYPY:
    class ComponentVersionLambdaLinuxProcessParamsArgsDict(TypedDict):
        container_params: NotRequired[pulumi.Input['ComponentVersionLambdaContainerParamsArgsDict']]
        """
        The parameters for the container in which the Lambda function runs.
        """
        isolation_mode: NotRequired[pulumi.Input['ComponentVersionLambdaLinuxProcessParamsIsolationMode']]
        """
        The isolation mode for the process that contains the Lambda function. The process can run in an isolated runtime environment inside the AWS IoT Greengrass container, or as a regular process outside any container.

        Default: `GreengrassContainer`
        """
elif False:
    ComponentVersionLambdaLinuxProcessParamsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ComponentVersionLambdaLinuxProcessParamsArgs:
    def __init__(__self__, *,
                 container_params: Optional[pulumi.Input['ComponentVersionLambdaContainerParamsArgs']] = None,
                 isolation_mode: Optional[pulumi.Input['ComponentVersionLambdaLinuxProcessParamsIsolationMode']] = None):
        """
        :param pulumi.Input['ComponentVersionLambdaContainerParamsArgs'] container_params: The parameters for the container in which the Lambda function runs.
        :param pulumi.Input['ComponentVersionLambdaLinuxProcessParamsIsolationMode'] isolation_mode: The isolation mode for the process that contains the Lambda function. The process can run in an isolated runtime environment inside the AWS IoT Greengrass container, or as a regular process outside any container.
               
               Default: `GreengrassContainer`
        """
        if container_params is not None:
            pulumi.set(__self__, "container_params", container_params)
        if isolation_mode is not None:
            pulumi.set(__self__, "isolation_mode", isolation_mode)

    @property
    @pulumi.getter(name="containerParams")
    def container_params(self) -> Optional[pulumi.Input['ComponentVersionLambdaContainerParamsArgs']]:
        """
        The parameters for the container in which the Lambda function runs.
        """
        return pulumi.get(self, "container_params")

    @container_params.setter
    def container_params(self, value: Optional[pulumi.Input['ComponentVersionLambdaContainerParamsArgs']]):
        pulumi.set(self, "container_params", value)

    @property
    @pulumi.getter(name="isolationMode")
    def isolation_mode(self) -> Optional[pulumi.Input['ComponentVersionLambdaLinuxProcessParamsIsolationMode']]:
        """
        The isolation mode for the process that contains the Lambda function. The process can run in an isolated runtime environment inside the AWS IoT Greengrass container, or as a regular process outside any container.

        Default: `GreengrassContainer`
        """
        return pulumi.get(self, "isolation_mode")

    @isolation_mode.setter
    def isolation_mode(self, value: Optional[pulumi.Input['ComponentVersionLambdaLinuxProcessParamsIsolationMode']]):
        pulumi.set(self, "isolation_mode", value)


if not MYPY:
    class ComponentVersionLambdaVolumeMountArgsDict(TypedDict):
        add_group_owner: NotRequired[pulumi.Input[bool]]
        """
        Whether or not to add the AWS IoT Greengrass user group as an owner of the volume.

        Default: `false`
        """
        destination_path: NotRequired[pulumi.Input[str]]
        """
        The path to the logical volume in the file system.
        """
        permission: NotRequired[pulumi.Input['ComponentVersionLambdaFilesystemPermission']]
        """
        The permission to access the volume: read/only ( `ro` ) or read/write ( `rw` ).

        Default: `ro`
        """
        source_path: NotRequired[pulumi.Input[str]]
        """
        The path to the physical volume in the file system.
        """
elif False:
    ComponentVersionLambdaVolumeMountArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ComponentVersionLambdaVolumeMountArgs:
    def __init__(__self__, *,
                 add_group_owner: Optional[pulumi.Input[bool]] = None,
                 destination_path: Optional[pulumi.Input[str]] = None,
                 permission: Optional[pulumi.Input['ComponentVersionLambdaFilesystemPermission']] = None,
                 source_path: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[bool] add_group_owner: Whether or not to add the AWS IoT Greengrass user group as an owner of the volume.
               
               Default: `false`
        :param pulumi.Input[str] destination_path: The path to the logical volume in the file system.
        :param pulumi.Input['ComponentVersionLambdaFilesystemPermission'] permission: The permission to access the volume: read/only ( `ro` ) or read/write ( `rw` ).
               
               Default: `ro`
        :param pulumi.Input[str] source_path: The path to the physical volume in the file system.
        """
        if add_group_owner is not None:
            pulumi.set(__self__, "add_group_owner", add_group_owner)
        if destination_path is not None:
            pulumi.set(__self__, "destination_path", destination_path)
        if permission is not None:
            pulumi.set(__self__, "permission", permission)
        if source_path is not None:
            pulumi.set(__self__, "source_path", source_path)

    @property
    @pulumi.getter(name="addGroupOwner")
    def add_group_owner(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether or not to add the AWS IoT Greengrass user group as an owner of the volume.

        Default: `false`
        """
        return pulumi.get(self, "add_group_owner")

    @add_group_owner.setter
    def add_group_owner(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "add_group_owner", value)

    @property
    @pulumi.getter(name="destinationPath")
    def destination_path(self) -> Optional[pulumi.Input[str]]:
        """
        The path to the logical volume in the file system.
        """
        return pulumi.get(self, "destination_path")

    @destination_path.setter
    def destination_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "destination_path", value)

    @property
    @pulumi.getter
    def permission(self) -> Optional[pulumi.Input['ComponentVersionLambdaFilesystemPermission']]:
        """
        The permission to access the volume: read/only ( `ro` ) or read/write ( `rw` ).

        Default: `ro`
        """
        return pulumi.get(self, "permission")

    @permission.setter
    def permission(self, value: Optional[pulumi.Input['ComponentVersionLambdaFilesystemPermission']]):
        pulumi.set(self, "permission", value)

    @property
    @pulumi.getter(name="sourcePath")
    def source_path(self) -> Optional[pulumi.Input[str]]:
        """
        The path to the physical volume in the file system.
        """
        return pulumi.get(self, "source_path")

    @source_path.setter
    def source_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_path", value)


if not MYPY:
    class DeploymentComponentConfigurationUpdateArgsDict(TypedDict):
        merge: NotRequired[pulumi.Input[str]]
        reset: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
elif False:
    DeploymentComponentConfigurationUpdateArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentComponentConfigurationUpdateArgs:
    def __init__(__self__, *,
                 merge: Optional[pulumi.Input[str]] = None,
                 reset: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        if merge is not None:
            pulumi.set(__self__, "merge", merge)
        if reset is not None:
            pulumi.set(__self__, "reset", reset)

    @property
    @pulumi.getter
    def merge(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "merge")

    @merge.setter
    def merge(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "merge", value)

    @property
    @pulumi.getter
    def reset(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        return pulumi.get(self, "reset")

    @reset.setter
    def reset(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "reset", value)


if not MYPY:
    class DeploymentComponentDeploymentSpecificationArgsDict(TypedDict):
        component_version: NotRequired[pulumi.Input[str]]
        configuration_update: NotRequired[pulumi.Input['DeploymentComponentConfigurationUpdateArgsDict']]
        run_with: NotRequired[pulumi.Input['DeploymentComponentRunWithArgsDict']]
elif False:
    DeploymentComponentDeploymentSpecificationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentComponentDeploymentSpecificationArgs:
    def __init__(__self__, *,
                 component_version: Optional[pulumi.Input[str]] = None,
                 configuration_update: Optional[pulumi.Input['DeploymentComponentConfigurationUpdateArgs']] = None,
                 run_with: Optional[pulumi.Input['DeploymentComponentRunWithArgs']] = None):
        if component_version is not None:
            pulumi.set(__self__, "component_version", component_version)
        if configuration_update is not None:
            pulumi.set(__self__, "configuration_update", configuration_update)
        if run_with is not None:
            pulumi.set(__self__, "run_with", run_with)

    @property
    @pulumi.getter(name="componentVersion")
    def component_version(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "component_version")

    @component_version.setter
    def component_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "component_version", value)

    @property
    @pulumi.getter(name="configurationUpdate")
    def configuration_update(self) -> Optional[pulumi.Input['DeploymentComponentConfigurationUpdateArgs']]:
        return pulumi.get(self, "configuration_update")

    @configuration_update.setter
    def configuration_update(self, value: Optional[pulumi.Input['DeploymentComponentConfigurationUpdateArgs']]):
        pulumi.set(self, "configuration_update", value)

    @property
    @pulumi.getter(name="runWith")
    def run_with(self) -> Optional[pulumi.Input['DeploymentComponentRunWithArgs']]:
        return pulumi.get(self, "run_with")

    @run_with.setter
    def run_with(self, value: Optional[pulumi.Input['DeploymentComponentRunWithArgs']]):
        pulumi.set(self, "run_with", value)


if not MYPY:
    class DeploymentComponentRunWithArgsDict(TypedDict):
        posix_user: NotRequired[pulumi.Input[str]]
        system_resource_limits: NotRequired[pulumi.Input['DeploymentSystemResourceLimitsArgsDict']]
        windows_user: NotRequired[pulumi.Input[str]]
elif False:
    DeploymentComponentRunWithArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentComponentRunWithArgs:
    def __init__(__self__, *,
                 posix_user: Optional[pulumi.Input[str]] = None,
                 system_resource_limits: Optional[pulumi.Input['DeploymentSystemResourceLimitsArgs']] = None,
                 windows_user: Optional[pulumi.Input[str]] = None):
        if posix_user is not None:
            pulumi.set(__self__, "posix_user", posix_user)
        if system_resource_limits is not None:
            pulumi.set(__self__, "system_resource_limits", system_resource_limits)
        if windows_user is not None:
            pulumi.set(__self__, "windows_user", windows_user)

    @property
    @pulumi.getter(name="posixUser")
    def posix_user(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "posix_user")

    @posix_user.setter
    def posix_user(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "posix_user", value)

    @property
    @pulumi.getter(name="systemResourceLimits")
    def system_resource_limits(self) -> Optional[pulumi.Input['DeploymentSystemResourceLimitsArgs']]:
        return pulumi.get(self, "system_resource_limits")

    @system_resource_limits.setter
    def system_resource_limits(self, value: Optional[pulumi.Input['DeploymentSystemResourceLimitsArgs']]):
        pulumi.set(self, "system_resource_limits", value)

    @property
    @pulumi.getter(name="windowsUser")
    def windows_user(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "windows_user")

    @windows_user.setter
    def windows_user(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "windows_user", value)


if not MYPY:
    class DeploymentComponentUpdatePolicyArgsDict(TypedDict):
        action: NotRequired[pulumi.Input['DeploymentComponentUpdatePolicyAction']]
        """
        Whether or not to notify components and wait for components to become safe to update. Choose from the following options:

        - `NOTIFY_COMPONENTS` – The deployment notifies each component before it stops and updates that component. Components can use the [SubscribeToComponentUpdates](https://docs.aws.amazon.com/greengrass/v2/developerguide/interprocess-communication.html#ipc-operation-subscribetocomponentupdates) IPC operation to receive these notifications. Then, components can respond with the [DeferComponentUpdate](https://docs.aws.amazon.com/greengrass/v2/developerguide/interprocess-communication.html#ipc-operation-defercomponentupdate) IPC operation. For more information, see the [Create deployments](https://docs.aws.amazon.com/greengrass/v2/developerguide/create-deployments.html) in the *AWS IoT Greengrass V2 Developer Guide* .
        - `SKIP_NOTIFY_COMPONENTS` – The deployment doesn't notify components or wait for them to be safe to update.

        Default: `NOTIFY_COMPONENTS`
        """
        timeout_in_seconds: NotRequired[pulumi.Input[int]]
        """
        The amount of time in seconds that each component on a device has to report that it's safe to update. If the component waits for longer than this timeout, then the deployment proceeds on the device.

        Default: `60`
        """
elif False:
    DeploymentComponentUpdatePolicyArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentComponentUpdatePolicyArgs:
    def __init__(__self__, *,
                 action: Optional[pulumi.Input['DeploymentComponentUpdatePolicyAction']] = None,
                 timeout_in_seconds: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input['DeploymentComponentUpdatePolicyAction'] action: Whether or not to notify components and wait for components to become safe to update. Choose from the following options:
               
               - `NOTIFY_COMPONENTS` – The deployment notifies each component before it stops and updates that component. Components can use the [SubscribeToComponentUpdates](https://docs.aws.amazon.com/greengrass/v2/developerguide/interprocess-communication.html#ipc-operation-subscribetocomponentupdates) IPC operation to receive these notifications. Then, components can respond with the [DeferComponentUpdate](https://docs.aws.amazon.com/greengrass/v2/developerguide/interprocess-communication.html#ipc-operation-defercomponentupdate) IPC operation. For more information, see the [Create deployments](https://docs.aws.amazon.com/greengrass/v2/developerguide/create-deployments.html) in the *AWS IoT Greengrass V2 Developer Guide* .
               - `SKIP_NOTIFY_COMPONENTS` – The deployment doesn't notify components or wait for them to be safe to update.
               
               Default: `NOTIFY_COMPONENTS`
        :param pulumi.Input[int] timeout_in_seconds: The amount of time in seconds that each component on a device has to report that it's safe to update. If the component waits for longer than this timeout, then the deployment proceeds on the device.
               
               Default: `60`
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if timeout_in_seconds is not None:
            pulumi.set(__self__, "timeout_in_seconds", timeout_in_seconds)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input['DeploymentComponentUpdatePolicyAction']]:
        """
        Whether or not to notify components and wait for components to become safe to update. Choose from the following options:

        - `NOTIFY_COMPONENTS` – The deployment notifies each component before it stops and updates that component. Components can use the [SubscribeToComponentUpdates](https://docs.aws.amazon.com/greengrass/v2/developerguide/interprocess-communication.html#ipc-operation-subscribetocomponentupdates) IPC operation to receive these notifications. Then, components can respond with the [DeferComponentUpdate](https://docs.aws.amazon.com/greengrass/v2/developerguide/interprocess-communication.html#ipc-operation-defercomponentupdate) IPC operation. For more information, see the [Create deployments](https://docs.aws.amazon.com/greengrass/v2/developerguide/create-deployments.html) in the *AWS IoT Greengrass V2 Developer Guide* .
        - `SKIP_NOTIFY_COMPONENTS` – The deployment doesn't notify components or wait for them to be safe to update.

        Default: `NOTIFY_COMPONENTS`
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input['DeploymentComponentUpdatePolicyAction']]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter(name="timeoutInSeconds")
    def timeout_in_seconds(self) -> Optional[pulumi.Input[int]]:
        """
        The amount of time in seconds that each component on a device has to report that it's safe to update. If the component waits for longer than this timeout, then the deployment proceeds on the device.

        Default: `60`
        """
        return pulumi.get(self, "timeout_in_seconds")

    @timeout_in_seconds.setter
    def timeout_in_seconds(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "timeout_in_seconds", value)


if not MYPY:
    class DeploymentConfigurationValidationPolicyArgsDict(TypedDict):
        timeout_in_seconds: NotRequired[pulumi.Input[int]]
        """
        The amount of time in seconds that a component can validate its configuration updates. If the validation time exceeds this timeout, then the deployment proceeds for the device.

        Default: `30`
        """
elif False:
    DeploymentConfigurationValidationPolicyArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentConfigurationValidationPolicyArgs:
    def __init__(__self__, *,
                 timeout_in_seconds: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input[int] timeout_in_seconds: The amount of time in seconds that a component can validate its configuration updates. If the validation time exceeds this timeout, then the deployment proceeds for the device.
               
               Default: `30`
        """
        if timeout_in_seconds is not None:
            pulumi.set(__self__, "timeout_in_seconds", timeout_in_seconds)

    @property
    @pulumi.getter(name="timeoutInSeconds")
    def timeout_in_seconds(self) -> Optional[pulumi.Input[int]]:
        """
        The amount of time in seconds that a component can validate its configuration updates. If the validation time exceeds this timeout, then the deployment proceeds for the device.

        Default: `30`
        """
        return pulumi.get(self, "timeout_in_seconds")

    @timeout_in_seconds.setter
    def timeout_in_seconds(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "timeout_in_seconds", value)


if not MYPY:
    class DeploymentIoTJobAbortConfigArgsDict(TypedDict):
        criteria_list: pulumi.Input[Sequence[pulumi.Input['DeploymentIoTJobAbortCriteriaArgsDict']]]
        """
        The list of criteria that define when and how to cancel the configuration deployment.
        """
elif False:
    DeploymentIoTJobAbortConfigArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentIoTJobAbortConfigArgs:
    def __init__(__self__, *,
                 criteria_list: pulumi.Input[Sequence[pulumi.Input['DeploymentIoTJobAbortCriteriaArgs']]]):
        """
        :param pulumi.Input[Sequence[pulumi.Input['DeploymentIoTJobAbortCriteriaArgs']]] criteria_list: The list of criteria that define when and how to cancel the configuration deployment.
        """
        pulumi.set(__self__, "criteria_list", criteria_list)

    @property
    @pulumi.getter(name="criteriaList")
    def criteria_list(self) -> pulumi.Input[Sequence[pulumi.Input['DeploymentIoTJobAbortCriteriaArgs']]]:
        """
        The list of criteria that define when and how to cancel the configuration deployment.
        """
        return pulumi.get(self, "criteria_list")

    @criteria_list.setter
    def criteria_list(self, value: pulumi.Input[Sequence[pulumi.Input['DeploymentIoTJobAbortCriteriaArgs']]]):
        pulumi.set(self, "criteria_list", value)


if not MYPY:
    class DeploymentIoTJobAbortCriteriaArgsDict(TypedDict):
        action: pulumi.Input['DeploymentIoTJobAbortCriteriaAction']
        """
        The action to perform when the criteria are met.
        """
        failure_type: pulumi.Input['DeploymentIoTJobAbortCriteriaFailureType']
        """
        The type of job deployment failure that can cancel a job.
        """
        min_number_of_executed_things: pulumi.Input[int]
        """
        The minimum number of things that receive the configuration before the job can cancel.
        """
        threshold_percentage: pulumi.Input[float]
        """
        The minimum percentage of `failureType` failures that occur before the job can cancel.

        This parameter supports up to two digits after the decimal (for example, you can specify `10.9` or `10.99` , but not `10.999` ).
        """
elif False:
    DeploymentIoTJobAbortCriteriaArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentIoTJobAbortCriteriaArgs:
    def __init__(__self__, *,
                 action: pulumi.Input['DeploymentIoTJobAbortCriteriaAction'],
                 failure_type: pulumi.Input['DeploymentIoTJobAbortCriteriaFailureType'],
                 min_number_of_executed_things: pulumi.Input[int],
                 threshold_percentage: pulumi.Input[float]):
        """
        :param pulumi.Input['DeploymentIoTJobAbortCriteriaAction'] action: The action to perform when the criteria are met.
        :param pulumi.Input['DeploymentIoTJobAbortCriteriaFailureType'] failure_type: The type of job deployment failure that can cancel a job.
        :param pulumi.Input[int] min_number_of_executed_things: The minimum number of things that receive the configuration before the job can cancel.
        :param pulumi.Input[float] threshold_percentage: The minimum percentage of `failureType` failures that occur before the job can cancel.
               
               This parameter supports up to two digits after the decimal (for example, you can specify `10.9` or `10.99` , but not `10.999` ).
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "failure_type", failure_type)
        pulumi.set(__self__, "min_number_of_executed_things", min_number_of_executed_things)
        pulumi.set(__self__, "threshold_percentage", threshold_percentage)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Input['DeploymentIoTJobAbortCriteriaAction']:
        """
        The action to perform when the criteria are met.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: pulumi.Input['DeploymentIoTJobAbortCriteriaAction']):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter(name="failureType")
    def failure_type(self) -> pulumi.Input['DeploymentIoTJobAbortCriteriaFailureType']:
        """
        The type of job deployment failure that can cancel a job.
        """
        return pulumi.get(self, "failure_type")

    @failure_type.setter
    def failure_type(self, value: pulumi.Input['DeploymentIoTJobAbortCriteriaFailureType']):
        pulumi.set(self, "failure_type", value)

    @property
    @pulumi.getter(name="minNumberOfExecutedThings")
    def min_number_of_executed_things(self) -> pulumi.Input[int]:
        """
        The minimum number of things that receive the configuration before the job can cancel.
        """
        return pulumi.get(self, "min_number_of_executed_things")

    @min_number_of_executed_things.setter
    def min_number_of_executed_things(self, value: pulumi.Input[int]):
        pulumi.set(self, "min_number_of_executed_things", value)

    @property
    @pulumi.getter(name="thresholdPercentage")
    def threshold_percentage(self) -> pulumi.Input[float]:
        """
        The minimum percentage of `failureType` failures that occur before the job can cancel.

        This parameter supports up to two digits after the decimal (for example, you can specify `10.9` or `10.99` , but not `10.999` ).
        """
        return pulumi.get(self, "threshold_percentage")

    @threshold_percentage.setter
    def threshold_percentage(self, value: pulumi.Input[float]):
        pulumi.set(self, "threshold_percentage", value)


if not MYPY:
    class DeploymentIoTJobConfigurationArgsDict(TypedDict):
        abort_config: NotRequired[pulumi.Input['DeploymentIoTJobAbortConfigArgsDict']]
        """
        The stop configuration for the job. This configuration defines when and how to stop a job rollout.
        """
        job_executions_rollout_config: NotRequired[pulumi.Input['DeploymentIoTJobExecutionsRolloutConfigArgsDict']]
        """
        The rollout configuration for the job. This configuration defines the rate at which the job rolls out to the fleet of target devices.
        """
        timeout_config: NotRequired[pulumi.Input['DeploymentIoTJobTimeoutConfigArgsDict']]
        """
        The timeout configuration for the job. This configuration defines the amount of time each device has to complete the job.
        """
elif False:
    DeploymentIoTJobConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentIoTJobConfigurationArgs:
    def __init__(__self__, *,
                 abort_config: Optional[pulumi.Input['DeploymentIoTJobAbortConfigArgs']] = None,
                 job_executions_rollout_config: Optional[pulumi.Input['DeploymentIoTJobExecutionsRolloutConfigArgs']] = None,
                 timeout_config: Optional[pulumi.Input['DeploymentIoTJobTimeoutConfigArgs']] = None):
        """
        :param pulumi.Input['DeploymentIoTJobAbortConfigArgs'] abort_config: The stop configuration for the job. This configuration defines when and how to stop a job rollout.
        :param pulumi.Input['DeploymentIoTJobExecutionsRolloutConfigArgs'] job_executions_rollout_config: The rollout configuration for the job. This configuration defines the rate at which the job rolls out to the fleet of target devices.
        :param pulumi.Input['DeploymentIoTJobTimeoutConfigArgs'] timeout_config: The timeout configuration for the job. This configuration defines the amount of time each device has to complete the job.
        """
        if abort_config is not None:
            pulumi.set(__self__, "abort_config", abort_config)
        if job_executions_rollout_config is not None:
            pulumi.set(__self__, "job_executions_rollout_config", job_executions_rollout_config)
        if timeout_config is not None:
            pulumi.set(__self__, "timeout_config", timeout_config)

    @property
    @pulumi.getter(name="abortConfig")
    def abort_config(self) -> Optional[pulumi.Input['DeploymentIoTJobAbortConfigArgs']]:
        """
        The stop configuration for the job. This configuration defines when and how to stop a job rollout.
        """
        return pulumi.get(self, "abort_config")

    @abort_config.setter
    def abort_config(self, value: Optional[pulumi.Input['DeploymentIoTJobAbortConfigArgs']]):
        pulumi.set(self, "abort_config", value)

    @property
    @pulumi.getter(name="jobExecutionsRolloutConfig")
    def job_executions_rollout_config(self) -> Optional[pulumi.Input['DeploymentIoTJobExecutionsRolloutConfigArgs']]:
        """
        The rollout configuration for the job. This configuration defines the rate at which the job rolls out to the fleet of target devices.
        """
        return pulumi.get(self, "job_executions_rollout_config")

    @job_executions_rollout_config.setter
    def job_executions_rollout_config(self, value: Optional[pulumi.Input['DeploymentIoTJobExecutionsRolloutConfigArgs']]):
        pulumi.set(self, "job_executions_rollout_config", value)

    @property
    @pulumi.getter(name="timeoutConfig")
    def timeout_config(self) -> Optional[pulumi.Input['DeploymentIoTJobTimeoutConfigArgs']]:
        """
        The timeout configuration for the job. This configuration defines the amount of time each device has to complete the job.
        """
        return pulumi.get(self, "timeout_config")

    @timeout_config.setter
    def timeout_config(self, value: Optional[pulumi.Input['DeploymentIoTJobTimeoutConfigArgs']]):
        pulumi.set(self, "timeout_config", value)


if not MYPY:
    class DeploymentIoTJobExecutionsRolloutConfigArgsDict(TypedDict):
        exponential_rate: NotRequired[pulumi.Input['DeploymentIoTJobExponentialRolloutRateArgsDict']]
        """
        The exponential rate to increase the job rollout rate.
        """
        maximum_per_minute: NotRequired[pulumi.Input[int]]
        """
        The maximum number of devices that receive a pending job notification, per minute.
        """
elif False:
    DeploymentIoTJobExecutionsRolloutConfigArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentIoTJobExecutionsRolloutConfigArgs:
    def __init__(__self__, *,
                 exponential_rate: Optional[pulumi.Input['DeploymentIoTJobExponentialRolloutRateArgs']] = None,
                 maximum_per_minute: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input['DeploymentIoTJobExponentialRolloutRateArgs'] exponential_rate: The exponential rate to increase the job rollout rate.
        :param pulumi.Input[int] maximum_per_minute: The maximum number of devices that receive a pending job notification, per minute.
        """
        if exponential_rate is not None:
            pulumi.set(__self__, "exponential_rate", exponential_rate)
        if maximum_per_minute is not None:
            pulumi.set(__self__, "maximum_per_minute", maximum_per_minute)

    @property
    @pulumi.getter(name="exponentialRate")
    def exponential_rate(self) -> Optional[pulumi.Input['DeploymentIoTJobExponentialRolloutRateArgs']]:
        """
        The exponential rate to increase the job rollout rate.
        """
        return pulumi.get(self, "exponential_rate")

    @exponential_rate.setter
    def exponential_rate(self, value: Optional[pulumi.Input['DeploymentIoTJobExponentialRolloutRateArgs']]):
        pulumi.set(self, "exponential_rate", value)

    @property
    @pulumi.getter(name="maximumPerMinute")
    def maximum_per_minute(self) -> Optional[pulumi.Input[int]]:
        """
        The maximum number of devices that receive a pending job notification, per minute.
        """
        return pulumi.get(self, "maximum_per_minute")

    @maximum_per_minute.setter
    def maximum_per_minute(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "maximum_per_minute", value)


if not MYPY:
    class DeploymentIoTJobExponentialRolloutRateArgsDict(TypedDict):
        base_rate_per_minute: pulumi.Input[int]
        """
        The minimum number of devices that receive a pending job notification, per minute, when the job starts. This parameter defines the initial rollout rate of the job.
        """
        increment_factor: pulumi.Input[float]
        """
        The exponential factor to increase the rollout rate for the job.

        This parameter supports up to one digit after the decimal (for example, you can specify `1.5` , but not `1.55` ).
        """
        rate_increase_criteria: pulumi.Input['DeploymentIoTJobRateIncreaseCriteriaArgsDict']
        """
        The criteria to increase the rollout rate for the job.
        """
elif False:
    DeploymentIoTJobExponentialRolloutRateArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentIoTJobExponentialRolloutRateArgs:
    def __init__(__self__, *,
                 base_rate_per_minute: pulumi.Input[int],
                 increment_factor: pulumi.Input[float],
                 rate_increase_criteria: pulumi.Input['DeploymentIoTJobRateIncreaseCriteriaArgs']):
        """
        :param pulumi.Input[int] base_rate_per_minute: The minimum number of devices that receive a pending job notification, per minute, when the job starts. This parameter defines the initial rollout rate of the job.
        :param pulumi.Input[float] increment_factor: The exponential factor to increase the rollout rate for the job.
               
               This parameter supports up to one digit after the decimal (for example, you can specify `1.5` , but not `1.55` ).
        :param pulumi.Input['DeploymentIoTJobRateIncreaseCriteriaArgs'] rate_increase_criteria: The criteria to increase the rollout rate for the job.
        """
        pulumi.set(__self__, "base_rate_per_minute", base_rate_per_minute)
        pulumi.set(__self__, "increment_factor", increment_factor)
        pulumi.set(__self__, "rate_increase_criteria", rate_increase_criteria)

    @property
    @pulumi.getter(name="baseRatePerMinute")
    def base_rate_per_minute(self) -> pulumi.Input[int]:
        """
        The minimum number of devices that receive a pending job notification, per minute, when the job starts. This parameter defines the initial rollout rate of the job.
        """
        return pulumi.get(self, "base_rate_per_minute")

    @base_rate_per_minute.setter
    def base_rate_per_minute(self, value: pulumi.Input[int]):
        pulumi.set(self, "base_rate_per_minute", value)

    @property
    @pulumi.getter(name="incrementFactor")
    def increment_factor(self) -> pulumi.Input[float]:
        """
        The exponential factor to increase the rollout rate for the job.

        This parameter supports up to one digit after the decimal (for example, you can specify `1.5` , but not `1.55` ).
        """
        return pulumi.get(self, "increment_factor")

    @increment_factor.setter
    def increment_factor(self, value: pulumi.Input[float]):
        pulumi.set(self, "increment_factor", value)

    @property
    @pulumi.getter(name="rateIncreaseCriteria")
    def rate_increase_criteria(self) -> pulumi.Input['DeploymentIoTJobRateIncreaseCriteriaArgs']:
        """
        The criteria to increase the rollout rate for the job.
        """
        return pulumi.get(self, "rate_increase_criteria")

    @rate_increase_criteria.setter
    def rate_increase_criteria(self, value: pulumi.Input['DeploymentIoTJobRateIncreaseCriteriaArgs']):
        pulumi.set(self, "rate_increase_criteria", value)


if not MYPY:
    class DeploymentIoTJobRateIncreaseCriteriaArgsDict(TypedDict):
        pass
elif False:
    DeploymentIoTJobRateIncreaseCriteriaArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentIoTJobRateIncreaseCriteriaArgs:
    def __init__(__self__):
        pass


if not MYPY:
    class DeploymentIoTJobTimeoutConfigArgsDict(TypedDict):
        in_progress_timeout_in_minutes: NotRequired[pulumi.Input[int]]
        """
        The amount of time, in minutes, that devices have to complete the job. The timer starts when the job status is set to `IN_PROGRESS` . If the job status doesn't change to a terminal state before the time expires, then the job status is set to `TIMED_OUT` .

        The timeout interval must be between 1 minute and 7 days (10080 minutes).
        """
elif False:
    DeploymentIoTJobTimeoutConfigArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentIoTJobTimeoutConfigArgs:
    def __init__(__self__, *,
                 in_progress_timeout_in_minutes: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input[int] in_progress_timeout_in_minutes: The amount of time, in minutes, that devices have to complete the job. The timer starts when the job status is set to `IN_PROGRESS` . If the job status doesn't change to a terminal state before the time expires, then the job status is set to `TIMED_OUT` .
               
               The timeout interval must be between 1 minute and 7 days (10080 minutes).
        """
        if in_progress_timeout_in_minutes is not None:
            pulumi.set(__self__, "in_progress_timeout_in_minutes", in_progress_timeout_in_minutes)

    @property
    @pulumi.getter(name="inProgressTimeoutInMinutes")
    def in_progress_timeout_in_minutes(self) -> Optional[pulumi.Input[int]]:
        """
        The amount of time, in minutes, that devices have to complete the job. The timer starts when the job status is set to `IN_PROGRESS` . If the job status doesn't change to a terminal state before the time expires, then the job status is set to `TIMED_OUT` .

        The timeout interval must be between 1 minute and 7 days (10080 minutes).
        """
        return pulumi.get(self, "in_progress_timeout_in_minutes")

    @in_progress_timeout_in_minutes.setter
    def in_progress_timeout_in_minutes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "in_progress_timeout_in_minutes", value)


if not MYPY:
    class DeploymentPoliciesArgsDict(TypedDict):
        component_update_policy: NotRequired[pulumi.Input['DeploymentComponentUpdatePolicyArgsDict']]
        """
        The component update policy for the configuration deployment. This policy defines when it's safe to deploy the configuration to devices.
        """
        configuration_validation_policy: NotRequired[pulumi.Input['DeploymentConfigurationValidationPolicyArgsDict']]
        """
        The configuration validation policy for the configuration deployment. This policy defines how long each component has to validate its configure updates.
        """
        failure_handling_policy: NotRequired[pulumi.Input['DeploymentPoliciesFailureHandlingPolicy']]
        """
        The failure handling policy for the configuration deployment. This policy defines what to do if the deployment fails.

        Default: `ROLLBACK`
        """
elif False:
    DeploymentPoliciesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentPoliciesArgs:
    def __init__(__self__, *,
                 component_update_policy: Optional[pulumi.Input['DeploymentComponentUpdatePolicyArgs']] = None,
                 configuration_validation_policy: Optional[pulumi.Input['DeploymentConfigurationValidationPolicyArgs']] = None,
                 failure_handling_policy: Optional[pulumi.Input['DeploymentPoliciesFailureHandlingPolicy']] = None):
        """
        :param pulumi.Input['DeploymentComponentUpdatePolicyArgs'] component_update_policy: The component update policy for the configuration deployment. This policy defines when it's safe to deploy the configuration to devices.
        :param pulumi.Input['DeploymentConfigurationValidationPolicyArgs'] configuration_validation_policy: The configuration validation policy for the configuration deployment. This policy defines how long each component has to validate its configure updates.
        :param pulumi.Input['DeploymentPoliciesFailureHandlingPolicy'] failure_handling_policy: The failure handling policy for the configuration deployment. This policy defines what to do if the deployment fails.
               
               Default: `ROLLBACK`
        """
        if component_update_policy is not None:
            pulumi.set(__self__, "component_update_policy", component_update_policy)
        if configuration_validation_policy is not None:
            pulumi.set(__self__, "configuration_validation_policy", configuration_validation_policy)
        if failure_handling_policy is not None:
            pulumi.set(__self__, "failure_handling_policy", failure_handling_policy)

    @property
    @pulumi.getter(name="componentUpdatePolicy")
    def component_update_policy(self) -> Optional[pulumi.Input['DeploymentComponentUpdatePolicyArgs']]:
        """
        The component update policy for the configuration deployment. This policy defines when it's safe to deploy the configuration to devices.
        """
        return pulumi.get(self, "component_update_policy")

    @component_update_policy.setter
    def component_update_policy(self, value: Optional[pulumi.Input['DeploymentComponentUpdatePolicyArgs']]):
        pulumi.set(self, "component_update_policy", value)

    @property
    @pulumi.getter(name="configurationValidationPolicy")
    def configuration_validation_policy(self) -> Optional[pulumi.Input['DeploymentConfigurationValidationPolicyArgs']]:
        """
        The configuration validation policy for the configuration deployment. This policy defines how long each component has to validate its configure updates.
        """
        return pulumi.get(self, "configuration_validation_policy")

    @configuration_validation_policy.setter
    def configuration_validation_policy(self, value: Optional[pulumi.Input['DeploymentConfigurationValidationPolicyArgs']]):
        pulumi.set(self, "configuration_validation_policy", value)

    @property
    @pulumi.getter(name="failureHandlingPolicy")
    def failure_handling_policy(self) -> Optional[pulumi.Input['DeploymentPoliciesFailureHandlingPolicy']]:
        """
        The failure handling policy for the configuration deployment. This policy defines what to do if the deployment fails.

        Default: `ROLLBACK`
        """
        return pulumi.get(self, "failure_handling_policy")

    @failure_handling_policy.setter
    def failure_handling_policy(self, value: Optional[pulumi.Input['DeploymentPoliciesFailureHandlingPolicy']]):
        pulumi.set(self, "failure_handling_policy", value)


if not MYPY:
    class DeploymentSystemResourceLimitsArgsDict(TypedDict):
        cpus: NotRequired[pulumi.Input[float]]
        memory: NotRequired[pulumi.Input[int]]
elif False:
    DeploymentSystemResourceLimitsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentSystemResourceLimitsArgs:
    def __init__(__self__, *,
                 cpus: Optional[pulumi.Input[float]] = None,
                 memory: Optional[pulumi.Input[int]] = None):
        if cpus is not None:
            pulumi.set(__self__, "cpus", cpus)
        if memory is not None:
            pulumi.set(__self__, "memory", memory)

    @property
    @pulumi.getter
    def cpus(self) -> Optional[pulumi.Input[float]]:
        return pulumi.get(self, "cpus")

    @cpus.setter
    def cpus(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "cpus", value)

    @property
    @pulumi.getter
    def memory(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "memory")

    @memory.setter
    def memory(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "memory", value)


