# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'AccessPolicyIamRoleArgs',
    'AccessPolicyIamRoleArgsDict',
    'AccessPolicyIamUserArgs',
    'AccessPolicyIamUserArgsDict',
    'AccessPolicyIdentityArgs',
    'AccessPolicyIdentityArgsDict',
    'AccessPolicyPortalArgs',
    'AccessPolicyPortalArgsDict',
    'AccessPolicyProjectArgs',
    'AccessPolicyProjectArgsDict',
    'AccessPolicyResourceArgs',
    'AccessPolicyResourceArgsDict',
    'AccessPolicyUserArgs',
    'AccessPolicyUserArgsDict',
    'AlarmsPropertiesArgs',
    'AlarmsPropertiesArgsDict',
    'AssetHierarchyArgs',
    'AssetHierarchyArgsDict',
    'AssetModelAttributeArgs',
    'AssetModelAttributeArgsDict',
    'AssetModelCompositeModelArgs',
    'AssetModelCompositeModelArgsDict',
    'AssetModelExpressionVariableArgs',
    'AssetModelExpressionVariableArgsDict',
    'AssetModelHierarchyArgs',
    'AssetModelHierarchyArgsDict',
    'AssetModelMetricWindowArgs',
    'AssetModelMetricWindowArgsDict',
    'AssetModelMetricArgs',
    'AssetModelMetricArgsDict',
    'AssetModelPropertyPathDefinitionArgs',
    'AssetModelPropertyPathDefinitionArgsDict',
    'AssetModelPropertyTypeArgs',
    'AssetModelPropertyTypeArgsDict',
    'AssetModelPropertyArgs',
    'AssetModelPropertyArgsDict',
    'AssetModelTransformArgs',
    'AssetModelTransformArgsDict',
    'AssetModelTumblingWindowArgs',
    'AssetModelTumblingWindowArgsDict',
    'AssetModelVariableValueArgs',
    'AssetModelVariableValueArgsDict',
    'AssetPropertyArgs',
    'AssetPropertyArgsDict',
    'GatewayCapabilitySummaryArgs',
    'GatewayCapabilitySummaryArgsDict',
    'GatewayGreengrassV2Args',
    'GatewayGreengrassV2ArgsDict',
    'GatewayGreengrassArgs',
    'GatewayGreengrassArgsDict',
    'GatewayPlatformArgs',
    'GatewayPlatformArgsDict',
    'GatewaySiemensIeArgs',
    'GatewaySiemensIeArgsDict',
    'PortalTypeEntryArgs',
    'PortalTypeEntryArgsDict',
]

MYPY = False

if not MYPY:
    class AccessPolicyIamRoleArgsDict(TypedDict):
        """
        Contains information for an IAM role identity in an access policy.
        """
        arn: NotRequired[pulumi.Input[str]]
        """
        The ARN of the IAM role.
        """
elif False:
    AccessPolicyIamRoleArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AccessPolicyIamRoleArgs:
    def __init__(__self__, *,
                 arn: Optional[pulumi.Input[str]] = None):
        """
        Contains information for an IAM role identity in an access policy.
        :param pulumi.Input[str] arn: The ARN of the IAM role.
        """
        if arn is not None:
            pulumi.set(__self__, "arn", arn)

    @property
    @pulumi.getter
    def arn(self) -> Optional[pulumi.Input[str]]:
        """
        The ARN of the IAM role.
        """
        return pulumi.get(self, "arn")

    @arn.setter
    def arn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "arn", value)


if not MYPY:
    class AccessPolicyIamUserArgsDict(TypedDict):
        """
        Contains information for an IAM user identity in an access policy.
        """
        arn: NotRequired[pulumi.Input[str]]
        """
        The ARN of the IAM user.
        """
elif False:
    AccessPolicyIamUserArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AccessPolicyIamUserArgs:
    def __init__(__self__, *,
                 arn: Optional[pulumi.Input[str]] = None):
        """
        Contains information for an IAM user identity in an access policy.
        :param pulumi.Input[str] arn: The ARN of the IAM user.
        """
        if arn is not None:
            pulumi.set(__self__, "arn", arn)

    @property
    @pulumi.getter
    def arn(self) -> Optional[pulumi.Input[str]]:
        """
        The ARN of the IAM user.
        """
        return pulumi.get(self, "arn")

    @arn.setter
    def arn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "arn", value)


if not MYPY:
    class AccessPolicyIdentityArgsDict(TypedDict):
        """
        The identity for this access policy. Choose either an SSO user or group or an IAM user or role.
        """
        iam_role: NotRequired[pulumi.Input['AccessPolicyIamRoleArgsDict']]
        """
        An IAM role identity.
        """
        iam_user: NotRequired[pulumi.Input['AccessPolicyIamUserArgsDict']]
        """
        An IAM user identity.
        """
        user: NotRequired[pulumi.Input['AccessPolicyUserArgsDict']]
        """
        An IAM Identity Center user identity.
        """
elif False:
    AccessPolicyIdentityArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AccessPolicyIdentityArgs:
    def __init__(__self__, *,
                 iam_role: Optional[pulumi.Input['AccessPolicyIamRoleArgs']] = None,
                 iam_user: Optional[pulumi.Input['AccessPolicyIamUserArgs']] = None,
                 user: Optional[pulumi.Input['AccessPolicyUserArgs']] = None):
        """
        The identity for this access policy. Choose either an SSO user or group or an IAM user or role.
        :param pulumi.Input['AccessPolicyIamRoleArgs'] iam_role: An IAM role identity.
        :param pulumi.Input['AccessPolicyIamUserArgs'] iam_user: An IAM user identity.
        :param pulumi.Input['AccessPolicyUserArgs'] user: An IAM Identity Center user identity.
        """
        if iam_role is not None:
            pulumi.set(__self__, "iam_role", iam_role)
        if iam_user is not None:
            pulumi.set(__self__, "iam_user", iam_user)
        if user is not None:
            pulumi.set(__self__, "user", user)

    @property
    @pulumi.getter(name="iamRole")
    def iam_role(self) -> Optional[pulumi.Input['AccessPolicyIamRoleArgs']]:
        """
        An IAM role identity.
        """
        return pulumi.get(self, "iam_role")

    @iam_role.setter
    def iam_role(self, value: Optional[pulumi.Input['AccessPolicyIamRoleArgs']]):
        pulumi.set(self, "iam_role", value)

    @property
    @pulumi.getter(name="iamUser")
    def iam_user(self) -> Optional[pulumi.Input['AccessPolicyIamUserArgs']]:
        """
        An IAM user identity.
        """
        return pulumi.get(self, "iam_user")

    @iam_user.setter
    def iam_user(self, value: Optional[pulumi.Input['AccessPolicyIamUserArgs']]):
        pulumi.set(self, "iam_user", value)

    @property
    @pulumi.getter
    def user(self) -> Optional[pulumi.Input['AccessPolicyUserArgs']]:
        """
        An IAM Identity Center user identity.
        """
        return pulumi.get(self, "user")

    @user.setter
    def user(self, value: Optional[pulumi.Input['AccessPolicyUserArgs']]):
        pulumi.set(self, "user", value)


if not MYPY:
    class AccessPolicyPortalArgsDict(TypedDict):
        """
        A portal resource.
        """
        id: NotRequired[pulumi.Input[str]]
        """
        The ID of the portal.
        """
elif False:
    AccessPolicyPortalArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AccessPolicyPortalArgs:
    def __init__(__self__, *,
                 id: Optional[pulumi.Input[str]] = None):
        """
        A portal resource.
        :param pulumi.Input[str] id: The ID of the portal.
        """
        if id is not None:
            pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the portal.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)


if not MYPY:
    class AccessPolicyProjectArgsDict(TypedDict):
        """
        A project resource.
        """
        id: NotRequired[pulumi.Input[str]]
        """
        The ID of the project.
        """
elif False:
    AccessPolicyProjectArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AccessPolicyProjectArgs:
    def __init__(__self__, *,
                 id: Optional[pulumi.Input[str]] = None):
        """
        A project resource.
        :param pulumi.Input[str] id: The ID of the project.
        """
        if id is not None:
            pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the project.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)


if not MYPY:
    class AccessPolicyResourceArgsDict(TypedDict):
        """
        The AWS IoT SiteWise Monitor resource for this access policy. Choose either portal or project but not both.
        """
        portal: NotRequired[pulumi.Input['AccessPolicyPortalArgsDict']]
        """
        Identifies an AWS IoT SiteWise Monitor portal.
        """
        project: NotRequired[pulumi.Input['AccessPolicyProjectArgsDict']]
        """
        Identifies a specific AWS IoT SiteWise Monitor project.
        """
elif False:
    AccessPolicyResourceArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AccessPolicyResourceArgs:
    def __init__(__self__, *,
                 portal: Optional[pulumi.Input['AccessPolicyPortalArgs']] = None,
                 project: Optional[pulumi.Input['AccessPolicyProjectArgs']] = None):
        """
        The AWS IoT SiteWise Monitor resource for this access policy. Choose either portal or project but not both.
        :param pulumi.Input['AccessPolicyPortalArgs'] portal: Identifies an AWS IoT SiteWise Monitor portal.
        :param pulumi.Input['AccessPolicyProjectArgs'] project: Identifies a specific AWS IoT SiteWise Monitor project.
        """
        if portal is not None:
            pulumi.set(__self__, "portal", portal)
        if project is not None:
            pulumi.set(__self__, "project", project)

    @property
    @pulumi.getter
    def portal(self) -> Optional[pulumi.Input['AccessPolicyPortalArgs']]:
        """
        Identifies an AWS IoT SiteWise Monitor portal.
        """
        return pulumi.get(self, "portal")

    @portal.setter
    def portal(self, value: Optional[pulumi.Input['AccessPolicyPortalArgs']]):
        pulumi.set(self, "portal", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input['AccessPolicyProjectArgs']]:
        """
        Identifies a specific AWS IoT SiteWise Monitor project.
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input['AccessPolicyProjectArgs']]):
        pulumi.set(self, "project", value)


if not MYPY:
    class AccessPolicyUserArgsDict(TypedDict):
        """
        Contains information for a user identity in an access policy.
        """
        id: NotRequired[pulumi.Input[str]]
        """
        The AWS SSO ID of the user.
        """
elif False:
    AccessPolicyUserArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AccessPolicyUserArgs:
    def __init__(__self__, *,
                 id: Optional[pulumi.Input[str]] = None):
        """
        Contains information for a user identity in an access policy.
        :param pulumi.Input[str] id: The AWS SSO ID of the user.
        """
        if id is not None:
            pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        The AWS SSO ID of the user.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)


if not MYPY:
    class AlarmsPropertiesArgsDict(TypedDict):
        """
        Contains the configuration information of an alarm created in an AWS IoT SiteWise Monitor portal. You can use the alarm to monitor an asset property and get notified when the asset property value is outside a specified range.
        """
        alarm_role_arn: NotRequired[pulumi.Input[str]]
        """
        The ARN of the IAM role that allows the alarm to perform actions and access AWS resources and services, such as AWS IoT Events.
        """
        notification_lambda_arn: NotRequired[pulumi.Input[str]]
        """
        The ARN of the AWS Lambda function that manages alarm notifications. For more information, see Managing alarm notifications in the AWS IoT Events Developer Guide.
        """
elif False:
    AlarmsPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AlarmsPropertiesArgs:
    def __init__(__self__, *,
                 alarm_role_arn: Optional[pulumi.Input[str]] = None,
                 notification_lambda_arn: Optional[pulumi.Input[str]] = None):
        """
        Contains the configuration information of an alarm created in an AWS IoT SiteWise Monitor portal. You can use the alarm to monitor an asset property and get notified when the asset property value is outside a specified range.
        :param pulumi.Input[str] alarm_role_arn: The ARN of the IAM role that allows the alarm to perform actions and access AWS resources and services, such as AWS IoT Events.
        :param pulumi.Input[str] notification_lambda_arn: The ARN of the AWS Lambda function that manages alarm notifications. For more information, see Managing alarm notifications in the AWS IoT Events Developer Guide.
        """
        if alarm_role_arn is not None:
            pulumi.set(__self__, "alarm_role_arn", alarm_role_arn)
        if notification_lambda_arn is not None:
            pulumi.set(__self__, "notification_lambda_arn", notification_lambda_arn)

    @property
    @pulumi.getter(name="alarmRoleArn")
    def alarm_role_arn(self) -> Optional[pulumi.Input[str]]:
        """
        The ARN of the IAM role that allows the alarm to perform actions and access AWS resources and services, such as AWS IoT Events.
        """
        return pulumi.get(self, "alarm_role_arn")

    @alarm_role_arn.setter
    def alarm_role_arn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "alarm_role_arn", value)

    @property
    @pulumi.getter(name="notificationLambdaArn")
    def notification_lambda_arn(self) -> Optional[pulumi.Input[str]]:
        """
        The ARN of the AWS Lambda function that manages alarm notifications. For more information, see Managing alarm notifications in the AWS IoT Events Developer Guide.
        """
        return pulumi.get(self, "notification_lambda_arn")

    @notification_lambda_arn.setter
    def notification_lambda_arn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "notification_lambda_arn", value)


if not MYPY:
    class AssetHierarchyArgsDict(TypedDict):
        """
        A hierarchy specifies allowed parent/child asset relationships.
        """
        child_asset_id: pulumi.Input[str]
        """
        The ID of the child asset to be associated.
        """
        external_id: NotRequired[pulumi.Input[str]]
        """
        String-friendly customer provided external ID
        """
        id: NotRequired[pulumi.Input[str]]
        """
        Customer provided actual UUID for property
        """
        logical_id: NotRequired[pulumi.Input[str]]
        """
        The LogicalID of a hierarchy in the parent asset's model.
        """
elif False:
    AssetHierarchyArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetHierarchyArgs:
    def __init__(__self__, *,
                 child_asset_id: pulumi.Input[str],
                 external_id: Optional[pulumi.Input[str]] = None,
                 id: Optional[pulumi.Input[str]] = None,
                 logical_id: Optional[pulumi.Input[str]] = None):
        """
        A hierarchy specifies allowed parent/child asset relationships.
        :param pulumi.Input[str] child_asset_id: The ID of the child asset to be associated.
        :param pulumi.Input[str] external_id: String-friendly customer provided external ID
        :param pulumi.Input[str] id: Customer provided actual UUID for property
        :param pulumi.Input[str] logical_id: The LogicalID of a hierarchy in the parent asset's model.
        """
        pulumi.set(__self__, "child_asset_id", child_asset_id)
        if external_id is not None:
            pulumi.set(__self__, "external_id", external_id)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if logical_id is not None:
            pulumi.set(__self__, "logical_id", logical_id)

    @property
    @pulumi.getter(name="childAssetId")
    def child_asset_id(self) -> pulumi.Input[str]:
        """
        The ID of the child asset to be associated.
        """
        return pulumi.get(self, "child_asset_id")

    @child_asset_id.setter
    def child_asset_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "child_asset_id", value)

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> Optional[pulumi.Input[str]]:
        """
        String-friendly customer provided external ID
        """
        return pulumi.get(self, "external_id")

    @external_id.setter
    def external_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "external_id", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        Customer provided actual UUID for property
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="logicalId")
    def logical_id(self) -> Optional[pulumi.Input[str]]:
        """
        The LogicalID of a hierarchy in the parent asset's model.
        """
        return pulumi.get(self, "logical_id")

    @logical_id.setter
    def logical_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "logical_id", value)


if not MYPY:
    class AssetModelAttributeArgsDict(TypedDict):
        default_value: NotRequired[pulumi.Input[str]]
        """
        The default value of the asset model property attribute. All assets that you create from the asset model contain this attribute value. You can update an attribute's value after you create an asset. For more information, see [Updating attribute values](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/update-attribute-values.html) in the *AWS IoT SiteWise User Guide* .
        """
elif False:
    AssetModelAttributeArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelAttributeArgs:
    def __init__(__self__, *,
                 default_value: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] default_value: The default value of the asset model property attribute. All assets that you create from the asset model contain this attribute value. You can update an attribute's value after you create an asset. For more information, see [Updating attribute values](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/update-attribute-values.html) in the *AWS IoT SiteWise User Guide* .
        """
        if default_value is not None:
            pulumi.set(__self__, "default_value", default_value)

    @property
    @pulumi.getter(name="defaultValue")
    def default_value(self) -> Optional[pulumi.Input[str]]:
        """
        The default value of the asset model property attribute. All assets that you create from the asset model contain this attribute value. You can update an attribute's value after you create an asset. For more information, see [Updating attribute values](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/update-attribute-values.html) in the *AWS IoT SiteWise User Guide* .
        """
        return pulumi.get(self, "default_value")

    @default_value.setter
    def default_value(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default_value", value)


if not MYPY:
    class AssetModelCompositeModelArgsDict(TypedDict):
        """
        Contains a composite model definition in an asset model. This composite model definition is applied to all assets created from the asset model.
        """
        name: pulumi.Input[str]
        """
        A unique, friendly name for the asset composite model.
        """
        type: pulumi.Input[str]
        """
        The type of the composite model. For alarm composite models, this type is AWS/ALARM
        """
        composed_asset_model_id: NotRequired[pulumi.Input[str]]
        """
        The component model ID for which the composite model is composed of
        """
        composite_model_properties: NotRequired[pulumi.Input[Sequence[pulumi.Input['AssetModelPropertyArgsDict']]]]
        """
        The property definitions of the asset model. You can specify up to 200 properties per asset model.
        """
        description: NotRequired[pulumi.Input[str]]
        """
        A description for the asset composite model.
        """
        external_id: NotRequired[pulumi.Input[str]]
        """
        The External ID of the composite model
        """
        id: NotRequired[pulumi.Input[str]]
        """
        The Actual ID of the composite model
        """
        parent_asset_model_composite_model_external_id: NotRequired[pulumi.Input[str]]
        """
        The parent composite model External ID
        """
        path: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        The path of the composite model. This is only for derived composite models
        """
elif False:
    AssetModelCompositeModelArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelCompositeModelArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[str],
                 type: pulumi.Input[str],
                 composed_asset_model_id: Optional[pulumi.Input[str]] = None,
                 composite_model_properties: Optional[pulumi.Input[Sequence[pulumi.Input['AssetModelPropertyArgs']]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 external_id: Optional[pulumi.Input[str]] = None,
                 id: Optional[pulumi.Input[str]] = None,
                 parent_asset_model_composite_model_external_id: Optional[pulumi.Input[str]] = None,
                 path: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Contains a composite model definition in an asset model. This composite model definition is applied to all assets created from the asset model.
        :param pulumi.Input[str] name: A unique, friendly name for the asset composite model.
        :param pulumi.Input[str] type: The type of the composite model. For alarm composite models, this type is AWS/ALARM
        :param pulumi.Input[str] composed_asset_model_id: The component model ID for which the composite model is composed of
        :param pulumi.Input[Sequence[pulumi.Input['AssetModelPropertyArgs']]] composite_model_properties: The property definitions of the asset model. You can specify up to 200 properties per asset model.
        :param pulumi.Input[str] description: A description for the asset composite model.
        :param pulumi.Input[str] external_id: The External ID of the composite model
        :param pulumi.Input[str] id: The Actual ID of the composite model
        :param pulumi.Input[str] parent_asset_model_composite_model_external_id: The parent composite model External ID
        :param pulumi.Input[Sequence[pulumi.Input[str]]] path: The path of the composite model. This is only for derived composite models
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)
        if composed_asset_model_id is not None:
            pulumi.set(__self__, "composed_asset_model_id", composed_asset_model_id)
        if composite_model_properties is not None:
            pulumi.set(__self__, "composite_model_properties", composite_model_properties)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if external_id is not None:
            pulumi.set(__self__, "external_id", external_id)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if parent_asset_model_composite_model_external_id is not None:
            pulumi.set(__self__, "parent_asset_model_composite_model_external_id", parent_asset_model_composite_model_external_id)
        if path is not None:
            pulumi.set(__self__, "path", path)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        A unique, friendly name for the asset composite model.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        The type of the composite model. For alarm composite models, this type is AWS/ALARM
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="composedAssetModelId")
    def composed_asset_model_id(self) -> Optional[pulumi.Input[str]]:
        """
        The component model ID for which the composite model is composed of
        """
        return pulumi.get(self, "composed_asset_model_id")

    @composed_asset_model_id.setter
    def composed_asset_model_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "composed_asset_model_id", value)

    @property
    @pulumi.getter(name="compositeModelProperties")
    def composite_model_properties(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AssetModelPropertyArgs']]]]:
        """
        The property definitions of the asset model. You can specify up to 200 properties per asset model.
        """
        return pulumi.get(self, "composite_model_properties")

    @composite_model_properties.setter
    def composite_model_properties(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AssetModelPropertyArgs']]]]):
        pulumi.set(self, "composite_model_properties", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        A description for the asset composite model.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> Optional[pulumi.Input[str]]:
        """
        The External ID of the composite model
        """
        return pulumi.get(self, "external_id")

    @external_id.setter
    def external_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "external_id", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        The Actual ID of the composite model
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="parentAssetModelCompositeModelExternalId")
    def parent_asset_model_composite_model_external_id(self) -> Optional[pulumi.Input[str]]:
        """
        The parent composite model External ID
        """
        return pulumi.get(self, "parent_asset_model_composite_model_external_id")

    @parent_asset_model_composite_model_external_id.setter
    def parent_asset_model_composite_model_external_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "parent_asset_model_composite_model_external_id", value)

    @property
    @pulumi.getter
    def path(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The path of the composite model. This is only for derived composite models
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "path", value)


if not MYPY:
    class AssetModelExpressionVariableArgsDict(TypedDict):
        name: pulumi.Input[str]
        """
        The friendly name of the variable to be used in the expression.
        """
        value: pulumi.Input['AssetModelVariableValueArgsDict']
        """
        The variable that identifies an asset property from which to use values.
        """
elif False:
    AssetModelExpressionVariableArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelExpressionVariableArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[str],
                 value: pulumi.Input['AssetModelVariableValueArgs']):
        """
        :param pulumi.Input[str] name: The friendly name of the variable to be used in the expression.
        :param pulumi.Input['AssetModelVariableValueArgs'] value: The variable that identifies an asset property from which to use values.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        The friendly name of the variable to be used in the expression.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input['AssetModelVariableValueArgs']:
        """
        The variable that identifies an asset property from which to use values.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input['AssetModelVariableValueArgs']):
        pulumi.set(self, "value", value)


if not MYPY:
    class AssetModelHierarchyArgsDict(TypedDict):
        """
        Contains information about an asset model hierarchy.
        """
        child_asset_model_id: pulumi.Input[str]
        """
        The ID of the asset model. All assets in this hierarchy must be instances of the child AssetModelId asset model.
        """
        name: pulumi.Input[str]
        """
        The name of the asset model hierarchy.
        """
        external_id: NotRequired[pulumi.Input[str]]
        """
        Customer provided external ID for hierarchy
        """
        id: NotRequired[pulumi.Input[str]]
        """
        Customer provided actual ID for hierarchy
        """
        logical_id: NotRequired[pulumi.Input[str]]
        """
        Customer provided logical ID for hierarchy.
        """
elif False:
    AssetModelHierarchyArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelHierarchyArgs:
    def __init__(__self__, *,
                 child_asset_model_id: pulumi.Input[str],
                 name: pulumi.Input[str],
                 external_id: Optional[pulumi.Input[str]] = None,
                 id: Optional[pulumi.Input[str]] = None,
                 logical_id: Optional[pulumi.Input[str]] = None):
        """
        Contains information about an asset model hierarchy.
        :param pulumi.Input[str] child_asset_model_id: The ID of the asset model. All assets in this hierarchy must be instances of the child AssetModelId asset model.
        :param pulumi.Input[str] name: The name of the asset model hierarchy.
        :param pulumi.Input[str] external_id: Customer provided external ID for hierarchy
        :param pulumi.Input[str] id: Customer provided actual ID for hierarchy
        :param pulumi.Input[str] logical_id: Customer provided logical ID for hierarchy.
        """
        pulumi.set(__self__, "child_asset_model_id", child_asset_model_id)
        pulumi.set(__self__, "name", name)
        if external_id is not None:
            pulumi.set(__self__, "external_id", external_id)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if logical_id is not None:
            pulumi.set(__self__, "logical_id", logical_id)

    @property
    @pulumi.getter(name="childAssetModelId")
    def child_asset_model_id(self) -> pulumi.Input[str]:
        """
        The ID of the asset model. All assets in this hierarchy must be instances of the child AssetModelId asset model.
        """
        return pulumi.get(self, "child_asset_model_id")

    @child_asset_model_id.setter
    def child_asset_model_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "child_asset_model_id", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        The name of the asset model hierarchy.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> Optional[pulumi.Input[str]]:
        """
        Customer provided external ID for hierarchy
        """
        return pulumi.get(self, "external_id")

    @external_id.setter
    def external_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "external_id", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        Customer provided actual ID for hierarchy
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="logicalId")
    def logical_id(self) -> Optional[pulumi.Input[str]]:
        """
        Customer provided logical ID for hierarchy.
        """
        return pulumi.get(self, "logical_id")

    @logical_id.setter
    def logical_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "logical_id", value)


if not MYPY:
    class AssetModelMetricWindowArgsDict(TypedDict):
        """
        Contains a time interval window used for data aggregate computations (for example, average, sum, count, and so on).
        """
        tumbling: NotRequired[pulumi.Input['AssetModelTumblingWindowArgsDict']]
        """
        The tumbling time interval window.
        """
elif False:
    AssetModelMetricWindowArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelMetricWindowArgs:
    def __init__(__self__, *,
                 tumbling: Optional[pulumi.Input['AssetModelTumblingWindowArgs']] = None):
        """
        Contains a time interval window used for data aggregate computations (for example, average, sum, count, and so on).
        :param pulumi.Input['AssetModelTumblingWindowArgs'] tumbling: The tumbling time interval window.
        """
        if tumbling is not None:
            pulumi.set(__self__, "tumbling", tumbling)

    @property
    @pulumi.getter
    def tumbling(self) -> Optional[pulumi.Input['AssetModelTumblingWindowArgs']]:
        """
        The tumbling time interval window.
        """
        return pulumi.get(self, "tumbling")

    @tumbling.setter
    def tumbling(self, value: Optional[pulumi.Input['AssetModelTumblingWindowArgs']]):
        pulumi.set(self, "tumbling", value)


if not MYPY:
    class AssetModelMetricArgsDict(TypedDict):
        expression: pulumi.Input[str]
        """
        The mathematical expression that defines the metric aggregation function. You can specify up to 10 functions per expression.
        """
        variables: pulumi.Input[Sequence[pulumi.Input['AssetModelExpressionVariableArgsDict']]]
        """
        The list of variables used in the expression.
        """
        window: pulumi.Input['AssetModelMetricWindowArgsDict']
        """
        The window (time interval) over which AWS IoT SiteWise computes the metric's aggregation expression
        """
elif False:
    AssetModelMetricArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelMetricArgs:
    def __init__(__self__, *,
                 expression: pulumi.Input[str],
                 variables: pulumi.Input[Sequence[pulumi.Input['AssetModelExpressionVariableArgs']]],
                 window: pulumi.Input['AssetModelMetricWindowArgs']):
        """
        :param pulumi.Input[str] expression: The mathematical expression that defines the metric aggregation function. You can specify up to 10 functions per expression.
        :param pulumi.Input[Sequence[pulumi.Input['AssetModelExpressionVariableArgs']]] variables: The list of variables used in the expression.
        :param pulumi.Input['AssetModelMetricWindowArgs'] window: The window (time interval) over which AWS IoT SiteWise computes the metric's aggregation expression
        """
        pulumi.set(__self__, "expression", expression)
        pulumi.set(__self__, "variables", variables)
        pulumi.set(__self__, "window", window)

    @property
    @pulumi.getter
    def expression(self) -> pulumi.Input[str]:
        """
        The mathematical expression that defines the metric aggregation function. You can specify up to 10 functions per expression.
        """
        return pulumi.get(self, "expression")

    @expression.setter
    def expression(self, value: pulumi.Input[str]):
        pulumi.set(self, "expression", value)

    @property
    @pulumi.getter
    def variables(self) -> pulumi.Input[Sequence[pulumi.Input['AssetModelExpressionVariableArgs']]]:
        """
        The list of variables used in the expression.
        """
        return pulumi.get(self, "variables")

    @variables.setter
    def variables(self, value: pulumi.Input[Sequence[pulumi.Input['AssetModelExpressionVariableArgs']]]):
        pulumi.set(self, "variables", value)

    @property
    @pulumi.getter
    def window(self) -> pulumi.Input['AssetModelMetricWindowArgs']:
        """
        The window (time interval) over which AWS IoT SiteWise computes the metric's aggregation expression
        """
        return pulumi.get(self, "window")

    @window.setter
    def window(self, value: pulumi.Input['AssetModelMetricWindowArgs']):
        pulumi.set(self, "window", value)


if not MYPY:
    class AssetModelPropertyPathDefinitionArgsDict(TypedDict):
        """
        The definition for property path which is used to reference properties in transforms/metrics
        """
        name: pulumi.Input[str]
        """
        The name of the property
        """
elif False:
    AssetModelPropertyPathDefinitionArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelPropertyPathDefinitionArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[str]):
        """
        The definition for property path which is used to reference properties in transforms/metrics
        :param pulumi.Input[str] name: The name of the property
        """
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        The name of the property
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)


if not MYPY:
    class AssetModelPropertyTypeArgsDict(TypedDict):
        """
        Contains a property type, which can be one of attribute, measurement, metric, or transform.
        """
        type_name: pulumi.Input['AssetModelTypeName']
        """
        The type of property type, which can be one of `Attribute` , `Measurement` , `Metric` , or `Transform` .
        """
        attribute: NotRequired[pulumi.Input['AssetModelAttributeArgsDict']]
        """
        Specifies an asset attribute property. An attribute generally contains static information, such as the serial number of an [IIoT](https://docs.aws.amazon.com/https://en.wikipedia.org/wiki/Internet_of_things#Industrial_applications) wind turbine.
        """
        metric: NotRequired[pulumi.Input['AssetModelMetricArgsDict']]
        """
        Specifies an asset metric property. A metric contains a mathematical expression that uses aggregate functions to process all input data points over a time interval and output a single data point, such as to calculate the average hourly temperature.
        """
        transform: NotRequired[pulumi.Input['AssetModelTransformArgsDict']]
        """
        Specifies an asset transform property. A transform contains a mathematical expression that maps a property's data points from one form to another, such as a unit conversion from Celsius to Fahrenheit.
        """
elif False:
    AssetModelPropertyTypeArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelPropertyTypeArgs:
    def __init__(__self__, *,
                 type_name: pulumi.Input['AssetModelTypeName'],
                 attribute: Optional[pulumi.Input['AssetModelAttributeArgs']] = None,
                 metric: Optional[pulumi.Input['AssetModelMetricArgs']] = None,
                 transform: Optional[pulumi.Input['AssetModelTransformArgs']] = None):
        """
        Contains a property type, which can be one of attribute, measurement, metric, or transform.
        :param pulumi.Input['AssetModelTypeName'] type_name: The type of property type, which can be one of `Attribute` , `Measurement` , `Metric` , or `Transform` .
        :param pulumi.Input['AssetModelAttributeArgs'] attribute: Specifies an asset attribute property. An attribute generally contains static information, such as the serial number of an [IIoT](https://docs.aws.amazon.com/https://en.wikipedia.org/wiki/Internet_of_things#Industrial_applications) wind turbine.
        :param pulumi.Input['AssetModelMetricArgs'] metric: Specifies an asset metric property. A metric contains a mathematical expression that uses aggregate functions to process all input data points over a time interval and output a single data point, such as to calculate the average hourly temperature.
        :param pulumi.Input['AssetModelTransformArgs'] transform: Specifies an asset transform property. A transform contains a mathematical expression that maps a property's data points from one form to another, such as a unit conversion from Celsius to Fahrenheit.
        """
        pulumi.set(__self__, "type_name", type_name)
        if attribute is not None:
            pulumi.set(__self__, "attribute", attribute)
        if metric is not None:
            pulumi.set(__self__, "metric", metric)
        if transform is not None:
            pulumi.set(__self__, "transform", transform)

    @property
    @pulumi.getter(name="typeName")
    def type_name(self) -> pulumi.Input['AssetModelTypeName']:
        """
        The type of property type, which can be one of `Attribute` , `Measurement` , `Metric` , or `Transform` .
        """
        return pulumi.get(self, "type_name")

    @type_name.setter
    def type_name(self, value: pulumi.Input['AssetModelTypeName']):
        pulumi.set(self, "type_name", value)

    @property
    @pulumi.getter
    def attribute(self) -> Optional[pulumi.Input['AssetModelAttributeArgs']]:
        """
        Specifies an asset attribute property. An attribute generally contains static information, such as the serial number of an [IIoT](https://docs.aws.amazon.com/https://en.wikipedia.org/wiki/Internet_of_things#Industrial_applications) wind turbine.
        """
        return pulumi.get(self, "attribute")

    @attribute.setter
    def attribute(self, value: Optional[pulumi.Input['AssetModelAttributeArgs']]):
        pulumi.set(self, "attribute", value)

    @property
    @pulumi.getter
    def metric(self) -> Optional[pulumi.Input['AssetModelMetricArgs']]:
        """
        Specifies an asset metric property. A metric contains a mathematical expression that uses aggregate functions to process all input data points over a time interval and output a single data point, such as to calculate the average hourly temperature.
        """
        return pulumi.get(self, "metric")

    @metric.setter
    def metric(self, value: Optional[pulumi.Input['AssetModelMetricArgs']]):
        pulumi.set(self, "metric", value)

    @property
    @pulumi.getter
    def transform(self) -> Optional[pulumi.Input['AssetModelTransformArgs']]:
        """
        Specifies an asset transform property. A transform contains a mathematical expression that maps a property's data points from one form to another, such as a unit conversion from Celsius to Fahrenheit.
        """
        return pulumi.get(self, "transform")

    @transform.setter
    def transform(self, value: Optional[pulumi.Input['AssetModelTransformArgs']]):
        pulumi.set(self, "transform", value)


if not MYPY:
    class AssetModelPropertyArgsDict(TypedDict):
        """
        Contains information about an asset model property.
        """
        data_type: pulumi.Input['AssetModelDataType']
        """
        The data type of the asset model property.
        """
        name: pulumi.Input[str]
        """
        The name of the asset model property.
        """
        type: pulumi.Input['AssetModelPropertyTypeArgsDict']
        """
        The property type
        """
        data_type_spec: NotRequired[pulumi.Input['AssetModelDataTypeSpec']]
        """
        The data type of the structure for this property.
        """
        external_id: NotRequired[pulumi.Input[str]]
        """
        The External ID of the Asset Model Property
        """
        id: NotRequired[pulumi.Input[str]]
        """
        The ID of the Asset Model Property
        """
        logical_id: NotRequired[pulumi.Input[str]]
        """
        Customer provided Logical ID for property.
        """
        unit: NotRequired[pulumi.Input[str]]
        """
        The unit of the asset model property, such as Newtons or RPM.
        """
elif False:
    AssetModelPropertyArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelPropertyArgs:
    def __init__(__self__, *,
                 data_type: pulumi.Input['AssetModelDataType'],
                 name: pulumi.Input[str],
                 type: pulumi.Input['AssetModelPropertyTypeArgs'],
                 data_type_spec: Optional[pulumi.Input['AssetModelDataTypeSpec']] = None,
                 external_id: Optional[pulumi.Input[str]] = None,
                 id: Optional[pulumi.Input[str]] = None,
                 logical_id: Optional[pulumi.Input[str]] = None,
                 unit: Optional[pulumi.Input[str]] = None):
        """
        Contains information about an asset model property.
        :param pulumi.Input['AssetModelDataType'] data_type: The data type of the asset model property.
        :param pulumi.Input[str] name: The name of the asset model property.
        :param pulumi.Input['AssetModelPropertyTypeArgs'] type: The property type
        :param pulumi.Input['AssetModelDataTypeSpec'] data_type_spec: The data type of the structure for this property.
        :param pulumi.Input[str] external_id: The External ID of the Asset Model Property
        :param pulumi.Input[str] id: The ID of the Asset Model Property
        :param pulumi.Input[str] logical_id: Customer provided Logical ID for property.
        :param pulumi.Input[str] unit: The unit of the asset model property, such as Newtons or RPM.
        """
        pulumi.set(__self__, "data_type", data_type)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)
        if data_type_spec is not None:
            pulumi.set(__self__, "data_type_spec", data_type_spec)
        if external_id is not None:
            pulumi.set(__self__, "external_id", external_id)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if logical_id is not None:
            pulumi.set(__self__, "logical_id", logical_id)
        if unit is not None:
            pulumi.set(__self__, "unit", unit)

    @property
    @pulumi.getter(name="dataType")
    def data_type(self) -> pulumi.Input['AssetModelDataType']:
        """
        The data type of the asset model property.
        """
        return pulumi.get(self, "data_type")

    @data_type.setter
    def data_type(self, value: pulumi.Input['AssetModelDataType']):
        pulumi.set(self, "data_type", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        The name of the asset model property.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input['AssetModelPropertyTypeArgs']:
        """
        The property type
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input['AssetModelPropertyTypeArgs']):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="dataTypeSpec")
    def data_type_spec(self) -> Optional[pulumi.Input['AssetModelDataTypeSpec']]:
        """
        The data type of the structure for this property.
        """
        return pulumi.get(self, "data_type_spec")

    @data_type_spec.setter
    def data_type_spec(self, value: Optional[pulumi.Input['AssetModelDataTypeSpec']]):
        pulumi.set(self, "data_type_spec", value)

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> Optional[pulumi.Input[str]]:
        """
        The External ID of the Asset Model Property
        """
        return pulumi.get(self, "external_id")

    @external_id.setter
    def external_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "external_id", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the Asset Model Property
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="logicalId")
    def logical_id(self) -> Optional[pulumi.Input[str]]:
        """
        Customer provided Logical ID for property.
        """
        return pulumi.get(self, "logical_id")

    @logical_id.setter
    def logical_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "logical_id", value)

    @property
    @pulumi.getter
    def unit(self) -> Optional[pulumi.Input[str]]:
        """
        The unit of the asset model property, such as Newtons or RPM.
        """
        return pulumi.get(self, "unit")

    @unit.setter
    def unit(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "unit", value)


if not MYPY:
    class AssetModelTransformArgsDict(TypedDict):
        expression: pulumi.Input[str]
        """
        The mathematical expression that defines the transformation function. You can specify up to 10 functions per expression.
        """
        variables: pulumi.Input[Sequence[pulumi.Input['AssetModelExpressionVariableArgsDict']]]
        """
        The list of variables used in the expression.
        """
elif False:
    AssetModelTransformArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelTransformArgs:
    def __init__(__self__, *,
                 expression: pulumi.Input[str],
                 variables: pulumi.Input[Sequence[pulumi.Input['AssetModelExpressionVariableArgs']]]):
        """
        :param pulumi.Input[str] expression: The mathematical expression that defines the transformation function. You can specify up to 10 functions per expression.
        :param pulumi.Input[Sequence[pulumi.Input['AssetModelExpressionVariableArgs']]] variables: The list of variables used in the expression.
        """
        pulumi.set(__self__, "expression", expression)
        pulumi.set(__self__, "variables", variables)

    @property
    @pulumi.getter
    def expression(self) -> pulumi.Input[str]:
        """
        The mathematical expression that defines the transformation function. You can specify up to 10 functions per expression.
        """
        return pulumi.get(self, "expression")

    @expression.setter
    def expression(self, value: pulumi.Input[str]):
        pulumi.set(self, "expression", value)

    @property
    @pulumi.getter
    def variables(self) -> pulumi.Input[Sequence[pulumi.Input['AssetModelExpressionVariableArgs']]]:
        """
        The list of variables used in the expression.
        """
        return pulumi.get(self, "variables")

    @variables.setter
    def variables(self, value: pulumi.Input[Sequence[pulumi.Input['AssetModelExpressionVariableArgs']]]):
        pulumi.set(self, "variables", value)


if not MYPY:
    class AssetModelTumblingWindowArgsDict(TypedDict):
        """
        Contains a tumbling window, which is a repeating fixed-sized, non-overlapping, and contiguous time interval. This window is used in metric and aggregation computations.
        """
        interval: pulumi.Input[str]
        """
        The time interval for the tumbling window. The interval time must be between 1 minute and 1 week.

        AWS IoT SiteWise computes the `1w` interval the end of Sunday at midnight each week (UTC), the `1d` interval at the end of each day at midnight (UTC), the `1h` interval at the end of each hour, and so on.

        When AWS IoT SiteWise aggregates data points for metric computations, the start of each interval is exclusive and the end of each interval is inclusive. AWS IoT SiteWise places the computed data point at the end of the interval.
        """
        offset: NotRequired[pulumi.Input[str]]
        """
        The offset for the tumbling window. The `offset` parameter accepts the following:

        - The offset time.

        For example, if you specify `18h` for `offset` and `1d` for `interval` , AWS IoT SiteWise aggregates data in one of the following ways:

        - If you create the metric before or at 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) on the day when you create the metric.
        - If you create the metric after 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) the next day.
        - The ISO 8601 format.

        For example, if you specify `PT18H` for `offset` and `1d` for `interval` , AWS IoT SiteWise aggregates data in one of the following ways:

        - If you create the metric before or at 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) on the day when you create the metric.
        - If you create the metric after 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) the next day.
        - The 24-hour clock.

        For example, if you specify `00:03:00` for `offset` , `5m` for `interval` , and you create the metric at 2 PM (UTC), you get the first aggregation result at 2:03 PM (UTC). You get the second aggregation result at 2:08 PM (UTC).
        - The offset time zone.

        For example, if you specify `2021-07-23T18:00-08` for `offset` and `1d` for `interval` , AWS IoT SiteWise aggregates data in one of the following ways:

        - If you create the metric before or at 6 PM (PST), you get the first aggregation result at 6 PM (PST) on the day when you create the metric.
        - If you create the metric after 6 PM (PST), you get the first aggregation result at 6 PM (PST) the next day.
        """
elif False:
    AssetModelTumblingWindowArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelTumblingWindowArgs:
    def __init__(__self__, *,
                 interval: pulumi.Input[str],
                 offset: Optional[pulumi.Input[str]] = None):
        """
        Contains a tumbling window, which is a repeating fixed-sized, non-overlapping, and contiguous time interval. This window is used in metric and aggregation computations.
        :param pulumi.Input[str] interval: The time interval for the tumbling window. The interval time must be between 1 minute and 1 week.
               
               AWS IoT SiteWise computes the `1w` interval the end of Sunday at midnight each week (UTC), the `1d` interval at the end of each day at midnight (UTC), the `1h` interval at the end of each hour, and so on.
               
               When AWS IoT SiteWise aggregates data points for metric computations, the start of each interval is exclusive and the end of each interval is inclusive. AWS IoT SiteWise places the computed data point at the end of the interval.
        :param pulumi.Input[str] offset: The offset for the tumbling window. The `offset` parameter accepts the following:
               
               - The offset time.
               
               For example, if you specify `18h` for `offset` and `1d` for `interval` , AWS IoT SiteWise aggregates data in one of the following ways:
               
               - If you create the metric before or at 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) on the day when you create the metric.
               - If you create the metric after 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) the next day.
               - The ISO 8601 format.
               
               For example, if you specify `PT18H` for `offset` and `1d` for `interval` , AWS IoT SiteWise aggregates data in one of the following ways:
               
               - If you create the metric before or at 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) on the day when you create the metric.
               - If you create the metric after 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) the next day.
               - The 24-hour clock.
               
               For example, if you specify `00:03:00` for `offset` , `5m` for `interval` , and you create the metric at 2 PM (UTC), you get the first aggregation result at 2:03 PM (UTC). You get the second aggregation result at 2:08 PM (UTC).
               - The offset time zone.
               
               For example, if you specify `2021-07-23T18:00-08` for `offset` and `1d` for `interval` , AWS IoT SiteWise aggregates data in one of the following ways:
               
               - If you create the metric before or at 6 PM (PST), you get the first aggregation result at 6 PM (PST) on the day when you create the metric.
               - If you create the metric after 6 PM (PST), you get the first aggregation result at 6 PM (PST) the next day.
        """
        pulumi.set(__self__, "interval", interval)
        if offset is not None:
            pulumi.set(__self__, "offset", offset)

    @property
    @pulumi.getter
    def interval(self) -> pulumi.Input[str]:
        """
        The time interval for the tumbling window. The interval time must be between 1 minute and 1 week.

        AWS IoT SiteWise computes the `1w` interval the end of Sunday at midnight each week (UTC), the `1d` interval at the end of each day at midnight (UTC), the `1h` interval at the end of each hour, and so on.

        When AWS IoT SiteWise aggregates data points for metric computations, the start of each interval is exclusive and the end of each interval is inclusive. AWS IoT SiteWise places the computed data point at the end of the interval.
        """
        return pulumi.get(self, "interval")

    @interval.setter
    def interval(self, value: pulumi.Input[str]):
        pulumi.set(self, "interval", value)

    @property
    @pulumi.getter
    def offset(self) -> Optional[pulumi.Input[str]]:
        """
        The offset for the tumbling window. The `offset` parameter accepts the following:

        - The offset time.

        For example, if you specify `18h` for `offset` and `1d` for `interval` , AWS IoT SiteWise aggregates data in one of the following ways:

        - If you create the metric before or at 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) on the day when you create the metric.
        - If you create the metric after 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) the next day.
        - The ISO 8601 format.

        For example, if you specify `PT18H` for `offset` and `1d` for `interval` , AWS IoT SiteWise aggregates data in one of the following ways:

        - If you create the metric before or at 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) on the day when you create the metric.
        - If you create the metric after 6 PM (UTC), you get the first aggregation result at 6 PM (UTC) the next day.
        - The 24-hour clock.

        For example, if you specify `00:03:00` for `offset` , `5m` for `interval` , and you create the metric at 2 PM (UTC), you get the first aggregation result at 2:03 PM (UTC). You get the second aggregation result at 2:08 PM (UTC).
        - The offset time zone.

        For example, if you specify `2021-07-23T18:00-08` for `offset` and `1d` for `interval` , AWS IoT SiteWise aggregates data in one of the following ways:

        - If you create the metric before or at 6 PM (PST), you get the first aggregation result at 6 PM (PST) on the day when you create the metric.
        - If you create the metric after 6 PM (PST), you get the first aggregation result at 6 PM (PST) the next day.
        """
        return pulumi.get(self, "offset")

    @offset.setter
    def offset(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "offset", value)


if not MYPY:
    class AssetModelVariableValueArgsDict(TypedDict):
        hierarchy_external_id: NotRequired[pulumi.Input[str]]
        """
        The External ID of the hierarchy that is trying to be referenced
        """
        hierarchy_id: NotRequired[pulumi.Input[str]]
        """
        The ID of the hierarchy that is trying to be referenced
        """
        hierarchy_logical_id: NotRequired[pulumi.Input[str]]
        """
        The `LogicalID` of the hierarchy to query for the `PropertyLogicalID` .

        You use a `hierarchyLogicalID` instead of a model ID because you can have several hierarchies using the same model and therefore the same property. For example, you might have separately grouped assets that come from the same asset model. For more information, see [Defining relationships between asset models (hierarchies)](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/asset-hierarchies.html) in the *AWS IoT SiteWise User Guide* .
        """
        property_external_id: NotRequired[pulumi.Input[str]]
        """
        The External ID of the property that is trying to be referenced
        """
        property_id: NotRequired[pulumi.Input[str]]
        """
        The ID of the property that is trying to be referenced
        """
        property_logical_id: NotRequired[pulumi.Input[str]]
        """
        The `LogicalID` of the property that is being referenced.
        """
        property_path: NotRequired[pulumi.Input[Sequence[pulumi.Input['AssetModelPropertyPathDefinitionArgsDict']]]]
        """
        The path of the property that is trying to be referenced
        """
elif False:
    AssetModelVariableValueArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetModelVariableValueArgs:
    def __init__(__self__, *,
                 hierarchy_external_id: Optional[pulumi.Input[str]] = None,
                 hierarchy_id: Optional[pulumi.Input[str]] = None,
                 hierarchy_logical_id: Optional[pulumi.Input[str]] = None,
                 property_external_id: Optional[pulumi.Input[str]] = None,
                 property_id: Optional[pulumi.Input[str]] = None,
                 property_logical_id: Optional[pulumi.Input[str]] = None,
                 property_path: Optional[pulumi.Input[Sequence[pulumi.Input['AssetModelPropertyPathDefinitionArgs']]]] = None):
        """
        :param pulumi.Input[str] hierarchy_external_id: The External ID of the hierarchy that is trying to be referenced
        :param pulumi.Input[str] hierarchy_id: The ID of the hierarchy that is trying to be referenced
        :param pulumi.Input[str] hierarchy_logical_id: The `LogicalID` of the hierarchy to query for the `PropertyLogicalID` .
               
               You use a `hierarchyLogicalID` instead of a model ID because you can have several hierarchies using the same model and therefore the same property. For example, you might have separately grouped assets that come from the same asset model. For more information, see [Defining relationships between asset models (hierarchies)](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/asset-hierarchies.html) in the *AWS IoT SiteWise User Guide* .
        :param pulumi.Input[str] property_external_id: The External ID of the property that is trying to be referenced
        :param pulumi.Input[str] property_id: The ID of the property that is trying to be referenced
        :param pulumi.Input[str] property_logical_id: The `LogicalID` of the property that is being referenced.
        :param pulumi.Input[Sequence[pulumi.Input['AssetModelPropertyPathDefinitionArgs']]] property_path: The path of the property that is trying to be referenced
        """
        if hierarchy_external_id is not None:
            pulumi.set(__self__, "hierarchy_external_id", hierarchy_external_id)
        if hierarchy_id is not None:
            pulumi.set(__self__, "hierarchy_id", hierarchy_id)
        if hierarchy_logical_id is not None:
            pulumi.set(__self__, "hierarchy_logical_id", hierarchy_logical_id)
        if property_external_id is not None:
            pulumi.set(__self__, "property_external_id", property_external_id)
        if property_id is not None:
            pulumi.set(__self__, "property_id", property_id)
        if property_logical_id is not None:
            pulumi.set(__self__, "property_logical_id", property_logical_id)
        if property_path is not None:
            pulumi.set(__self__, "property_path", property_path)

    @property
    @pulumi.getter(name="hierarchyExternalId")
    def hierarchy_external_id(self) -> Optional[pulumi.Input[str]]:
        """
        The External ID of the hierarchy that is trying to be referenced
        """
        return pulumi.get(self, "hierarchy_external_id")

    @hierarchy_external_id.setter
    def hierarchy_external_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hierarchy_external_id", value)

    @property
    @pulumi.getter(name="hierarchyId")
    def hierarchy_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the hierarchy that is trying to be referenced
        """
        return pulumi.get(self, "hierarchy_id")

    @hierarchy_id.setter
    def hierarchy_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hierarchy_id", value)

    @property
    @pulumi.getter(name="hierarchyLogicalId")
    def hierarchy_logical_id(self) -> Optional[pulumi.Input[str]]:
        """
        The `LogicalID` of the hierarchy to query for the `PropertyLogicalID` .

        You use a `hierarchyLogicalID` instead of a model ID because you can have several hierarchies using the same model and therefore the same property. For example, you might have separately grouped assets that come from the same asset model. For more information, see [Defining relationships between asset models (hierarchies)](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/asset-hierarchies.html) in the *AWS IoT SiteWise User Guide* .
        """
        return pulumi.get(self, "hierarchy_logical_id")

    @hierarchy_logical_id.setter
    def hierarchy_logical_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hierarchy_logical_id", value)

    @property
    @pulumi.getter(name="propertyExternalId")
    def property_external_id(self) -> Optional[pulumi.Input[str]]:
        """
        The External ID of the property that is trying to be referenced
        """
        return pulumi.get(self, "property_external_id")

    @property_external_id.setter
    def property_external_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "property_external_id", value)

    @property
    @pulumi.getter(name="propertyId")
    def property_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the property that is trying to be referenced
        """
        return pulumi.get(self, "property_id")

    @property_id.setter
    def property_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "property_id", value)

    @property
    @pulumi.getter(name="propertyLogicalId")
    def property_logical_id(self) -> Optional[pulumi.Input[str]]:
        """
        The `LogicalID` of the property that is being referenced.
        """
        return pulumi.get(self, "property_logical_id")

    @property_logical_id.setter
    def property_logical_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "property_logical_id", value)

    @property
    @pulumi.getter(name="propertyPath")
    def property_path(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AssetModelPropertyPathDefinitionArgs']]]]:
        """
        The path of the property that is trying to be referenced
        """
        return pulumi.get(self, "property_path")

    @property_path.setter
    def property_path(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AssetModelPropertyPathDefinitionArgs']]]]):
        pulumi.set(self, "property_path", value)


if not MYPY:
    class AssetPropertyArgsDict(TypedDict):
        """
        The asset property's definition, alias, unit, and notification state.
        """
        alias: NotRequired[pulumi.Input[str]]
        """
        The property alias that identifies the property.
        """
        external_id: NotRequired[pulumi.Input[str]]
        """
        String-friendly customer provided external ID
        """
        id: NotRequired[pulumi.Input[str]]
        """
        Customer provided actual UUID for property
        """
        logical_id: NotRequired[pulumi.Input[str]]
        """
        Customer provided ID for property.
        """
        notification_state: NotRequired[pulumi.Input['AssetPropertyNotificationState']]
        """
        The MQTT notification state (ENABLED or DISABLED) for this asset property.
        """
        unit: NotRequired[pulumi.Input[str]]
        """
        The unit of measure (such as Newtons or RPM) of the asset property. If you don't specify a value for this parameter, the service uses the value of the assetModelProperty in the asset model.
        """
elif False:
    AssetPropertyArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AssetPropertyArgs:
    def __init__(__self__, *,
                 alias: Optional[pulumi.Input[str]] = None,
                 external_id: Optional[pulumi.Input[str]] = None,
                 id: Optional[pulumi.Input[str]] = None,
                 logical_id: Optional[pulumi.Input[str]] = None,
                 notification_state: Optional[pulumi.Input['AssetPropertyNotificationState']] = None,
                 unit: Optional[pulumi.Input[str]] = None):
        """
        The asset property's definition, alias, unit, and notification state.
        :param pulumi.Input[str] alias: The property alias that identifies the property.
        :param pulumi.Input[str] external_id: String-friendly customer provided external ID
        :param pulumi.Input[str] id: Customer provided actual UUID for property
        :param pulumi.Input[str] logical_id: Customer provided ID for property.
        :param pulumi.Input['AssetPropertyNotificationState'] notification_state: The MQTT notification state (ENABLED or DISABLED) for this asset property.
        :param pulumi.Input[str] unit: The unit of measure (such as Newtons or RPM) of the asset property. If you don't specify a value for this parameter, the service uses the value of the assetModelProperty in the asset model.
        """
        if alias is not None:
            pulumi.set(__self__, "alias", alias)
        if external_id is not None:
            pulumi.set(__self__, "external_id", external_id)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if logical_id is not None:
            pulumi.set(__self__, "logical_id", logical_id)
        if notification_state is not None:
            pulumi.set(__self__, "notification_state", notification_state)
        if unit is not None:
            pulumi.set(__self__, "unit", unit)

    @property
    @pulumi.getter
    def alias(self) -> Optional[pulumi.Input[str]]:
        """
        The property alias that identifies the property.
        """
        return pulumi.get(self, "alias")

    @alias.setter
    def alias(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "alias", value)

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> Optional[pulumi.Input[str]]:
        """
        String-friendly customer provided external ID
        """
        return pulumi.get(self, "external_id")

    @external_id.setter
    def external_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "external_id", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        Customer provided actual UUID for property
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="logicalId")
    def logical_id(self) -> Optional[pulumi.Input[str]]:
        """
        Customer provided ID for property.
        """
        return pulumi.get(self, "logical_id")

    @logical_id.setter
    def logical_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "logical_id", value)

    @property
    @pulumi.getter(name="notificationState")
    def notification_state(self) -> Optional[pulumi.Input['AssetPropertyNotificationState']]:
        """
        The MQTT notification state (ENABLED or DISABLED) for this asset property.
        """
        return pulumi.get(self, "notification_state")

    @notification_state.setter
    def notification_state(self, value: Optional[pulumi.Input['AssetPropertyNotificationState']]):
        pulumi.set(self, "notification_state", value)

    @property
    @pulumi.getter
    def unit(self) -> Optional[pulumi.Input[str]]:
        """
        The unit of measure (such as Newtons or RPM) of the asset property. If you don't specify a value for this parameter, the service uses the value of the assetModelProperty in the asset model.
        """
        return pulumi.get(self, "unit")

    @unit.setter
    def unit(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "unit", value)


if not MYPY:
    class GatewayCapabilitySummaryArgsDict(TypedDict):
        """
        Contains a summary of a gateway capability configuration.
        """
        capability_namespace: pulumi.Input[str]
        """
        The namespace of the capability configuration. For example, if you configure OPC-UA sources from the AWS IoT SiteWise console, your OPC-UA capability configuration has the namespace `iotsitewise:opcuacollector:version` , where `version` is a number such as `1` .
        """
        capability_configuration: NotRequired[pulumi.Input[str]]
        """
        The JSON document that defines the configuration for the gateway capability. For more information, see [Configuring data sources (CLI)](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/configure-sources.html#configure-source-cli) in the *AWS IoT SiteWise User Guide* .
        """
elif False:
    GatewayCapabilitySummaryArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GatewayCapabilitySummaryArgs:
    def __init__(__self__, *,
                 capability_namespace: pulumi.Input[str],
                 capability_configuration: Optional[pulumi.Input[str]] = None):
        """
        Contains a summary of a gateway capability configuration.
        :param pulumi.Input[str] capability_namespace: The namespace of the capability configuration. For example, if you configure OPC-UA sources from the AWS IoT SiteWise console, your OPC-UA capability configuration has the namespace `iotsitewise:opcuacollector:version` , where `version` is a number such as `1` .
        :param pulumi.Input[str] capability_configuration: The JSON document that defines the configuration for the gateway capability. For more information, see [Configuring data sources (CLI)](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/configure-sources.html#configure-source-cli) in the *AWS IoT SiteWise User Guide* .
        """
        pulumi.set(__self__, "capability_namespace", capability_namespace)
        if capability_configuration is not None:
            pulumi.set(__self__, "capability_configuration", capability_configuration)

    @property
    @pulumi.getter(name="capabilityNamespace")
    def capability_namespace(self) -> pulumi.Input[str]:
        """
        The namespace of the capability configuration. For example, if you configure OPC-UA sources from the AWS IoT SiteWise console, your OPC-UA capability configuration has the namespace `iotsitewise:opcuacollector:version` , where `version` is a number such as `1` .
        """
        return pulumi.get(self, "capability_namespace")

    @capability_namespace.setter
    def capability_namespace(self, value: pulumi.Input[str]):
        pulumi.set(self, "capability_namespace", value)

    @property
    @pulumi.getter(name="capabilityConfiguration")
    def capability_configuration(self) -> Optional[pulumi.Input[str]]:
        """
        The JSON document that defines the configuration for the gateway capability. For more information, see [Configuring data sources (CLI)](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/configure-sources.html#configure-source-cli) in the *AWS IoT SiteWise User Guide* .
        """
        return pulumi.get(self, "capability_configuration")

    @capability_configuration.setter
    def capability_configuration(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "capability_configuration", value)


if not MYPY:
    class GatewayGreengrassV2ArgsDict(TypedDict):
        """
        Contains the CoreDeviceThingName of AWS IoT Greengrass Group V2 that the gateway runs on.
        """
        core_device_thing_name: pulumi.Input[str]
        """
        The name of the CoreDevice in GreenGrass V2.
        """
elif False:
    GatewayGreengrassV2ArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GatewayGreengrassV2Args:
    def __init__(__self__, *,
                 core_device_thing_name: pulumi.Input[str]):
        """
        Contains the CoreDeviceThingName of AWS IoT Greengrass Group V2 that the gateway runs on.
        :param pulumi.Input[str] core_device_thing_name: The name of the CoreDevice in GreenGrass V2.
        """
        pulumi.set(__self__, "core_device_thing_name", core_device_thing_name)

    @property
    @pulumi.getter(name="coreDeviceThingName")
    def core_device_thing_name(self) -> pulumi.Input[str]:
        """
        The name of the CoreDevice in GreenGrass V2.
        """
        return pulumi.get(self, "core_device_thing_name")

    @core_device_thing_name.setter
    def core_device_thing_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "core_device_thing_name", value)


if not MYPY:
    class GatewayGreengrassArgsDict(TypedDict):
        """
        Contains the ARN of AWS IoT Greengrass Group V1 that the gateway runs on.
        """
        group_arn: pulumi.Input[str]
        """
        The ARN of the Greengrass group.
        """
elif False:
    GatewayGreengrassArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GatewayGreengrassArgs:
    def __init__(__self__, *,
                 group_arn: pulumi.Input[str]):
        """
        Contains the ARN of AWS IoT Greengrass Group V1 that the gateway runs on.
        :param pulumi.Input[str] group_arn: The ARN of the Greengrass group.
        """
        pulumi.set(__self__, "group_arn", group_arn)

    @property
    @pulumi.getter(name="groupArn")
    def group_arn(self) -> pulumi.Input[str]:
        """
        The ARN of the Greengrass group.
        """
        return pulumi.get(self, "group_arn")

    @group_arn.setter
    def group_arn(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_arn", value)


if not MYPY:
    class GatewayPlatformArgsDict(TypedDict):
        """
        Contains a gateway's platform information.
        """
        greengrass: NotRequired[pulumi.Input['GatewayGreengrassArgsDict']]
        """
        A gateway that runs on AWS IoT Greengrass V1.
        """
        greengrass_v2: NotRequired[pulumi.Input['GatewayGreengrassV2ArgsDict']]
        """
        A gateway that runs on AWS IoT Greengrass V2.
        """
        siemens_ie: NotRequired[pulumi.Input['GatewaySiemensIeArgsDict']]
        """
        A gateway that runs on Siemens Industrial Edge.
        """
elif False:
    GatewayPlatformArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GatewayPlatformArgs:
    def __init__(__self__, *,
                 greengrass: Optional[pulumi.Input['GatewayGreengrassArgs']] = None,
                 greengrass_v2: Optional[pulumi.Input['GatewayGreengrassV2Args']] = None,
                 siemens_ie: Optional[pulumi.Input['GatewaySiemensIeArgs']] = None):
        """
        Contains a gateway's platform information.
        :param pulumi.Input['GatewayGreengrassArgs'] greengrass: A gateway that runs on AWS IoT Greengrass V1.
        :param pulumi.Input['GatewayGreengrassV2Args'] greengrass_v2: A gateway that runs on AWS IoT Greengrass V2.
        :param pulumi.Input['GatewaySiemensIeArgs'] siemens_ie: A gateway that runs on Siemens Industrial Edge.
        """
        if greengrass is not None:
            pulumi.set(__self__, "greengrass", greengrass)
        if greengrass_v2 is not None:
            pulumi.set(__self__, "greengrass_v2", greengrass_v2)
        if siemens_ie is not None:
            pulumi.set(__self__, "siemens_ie", siemens_ie)

    @property
    @pulumi.getter
    def greengrass(self) -> Optional[pulumi.Input['GatewayGreengrassArgs']]:
        """
        A gateway that runs on AWS IoT Greengrass V1.
        """
        return pulumi.get(self, "greengrass")

    @greengrass.setter
    def greengrass(self, value: Optional[pulumi.Input['GatewayGreengrassArgs']]):
        pulumi.set(self, "greengrass", value)

    @property
    @pulumi.getter(name="greengrassV2")
    def greengrass_v2(self) -> Optional[pulumi.Input['GatewayGreengrassV2Args']]:
        """
        A gateway that runs on AWS IoT Greengrass V2.
        """
        return pulumi.get(self, "greengrass_v2")

    @greengrass_v2.setter
    def greengrass_v2(self, value: Optional[pulumi.Input['GatewayGreengrassV2Args']]):
        pulumi.set(self, "greengrass_v2", value)

    @property
    @pulumi.getter(name="siemensIe")
    def siemens_ie(self) -> Optional[pulumi.Input['GatewaySiemensIeArgs']]:
        """
        A gateway that runs on Siemens Industrial Edge.
        """
        return pulumi.get(self, "siemens_ie")

    @siemens_ie.setter
    def siemens_ie(self, value: Optional[pulumi.Input['GatewaySiemensIeArgs']]):
        pulumi.set(self, "siemens_ie", value)


if not MYPY:
    class GatewaySiemensIeArgsDict(TypedDict):
        """
        Contains the IotCoreThingName of AWS IoT Thing that the gateway runs on.
        """
        iot_core_thing_name: pulumi.Input[str]
        """
        The name of the IoT Core Thing.
        """
elif False:
    GatewaySiemensIeArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GatewaySiemensIeArgs:
    def __init__(__self__, *,
                 iot_core_thing_name: pulumi.Input[str]):
        """
        Contains the IotCoreThingName of AWS IoT Thing that the gateway runs on.
        :param pulumi.Input[str] iot_core_thing_name: The name of the IoT Core Thing.
        """
        pulumi.set(__self__, "iot_core_thing_name", iot_core_thing_name)

    @property
    @pulumi.getter(name="iotCoreThingName")
    def iot_core_thing_name(self) -> pulumi.Input[str]:
        """
        The name of the IoT Core Thing.
        """
        return pulumi.get(self, "iot_core_thing_name")

    @iot_core_thing_name.setter
    def iot_core_thing_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "iot_core_thing_name", value)


if not MYPY:
    class PortalTypeEntryArgsDict(TypedDict):
        """
        Container associated a certain PortalType.
        """
        portal_tools: pulumi.Input[Sequence[pulumi.Input[str]]]
elif False:
    PortalTypeEntryArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class PortalTypeEntryArgs:
    def __init__(__self__, *,
                 portal_tools: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        Container associated a certain PortalType.
        """
        pulumi.set(__self__, "portal_tools", portal_tools)

    @property
    @pulumi.getter(name="portalTools")
    def portal_tools(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        return pulumi.get(self, "portal_tools")

    @portal_tools.setter
    def portal_tools(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "portal_tools", value)


