# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AccountPolicyPolicyType',
    'AccountPolicyScope',
    'IntegrationStatus',
    'IntegrationType',
    'LogAnomalyDetectorEvaluationFrequency',
    'LogGroupClass',
    'MetricFilterMetricTransformationUnit',
    'SubscriptionFilterDistribution',
]


class AccountPolicyPolicyType(str, Enum):
    """
    Type of the policy.
    """
    DATA_PROTECTION_POLICY = "DATA_PROTECTION_POLICY"
    SUBSCRIPTION_FILTER_POLICY = "SUBSCRIPTION_FILTER_POLICY"


class AccountPolicyScope(str, Enum):
    """
    Scope for policy application
    """
    ALL = "ALL"


class IntegrationStatus(str, Enum):
    """
    Status of creation for the Integration and its resources
    """
    PROVISIONING = "PROVISIONING"
    ACTIVE = "ACTIVE"
    FAILED = "FAILED"


class IntegrationType(str, Enum):
    """
    The type of the Integration.
    """
    OPENSEARCH = "OPENSEARCH"


class LogAnomalyDetectorEvaluationFrequency(str, Enum):
    """
    How often log group is evaluated
    """
    FIVE_MIN = "FIVE_MIN"
    TEN_MIN = "TEN_MIN"
    FIFTEEN_MIN = "FIFTEEN_MIN"
    THIRTY_MIN = "THIRTY_MIN"
    ONE_HOUR = "ONE_HOUR"


class LogGroupClass(str, Enum):
    """
    Specifies the log group class for this log group. There are two classes:
      +  The ``Standard`` log class supports all CWL features.
      +  The ``Infrequent Access`` log class supports a subset of CWL features and incurs lower costs.
      
     For details about the features supported by each class, see [Log classes](https://docs.aws.amazon.com/AmazonCloudWatch/latest/logs/CloudWatch_Logs_Log_Classes.html)
    """
    STANDARD = "STANDARD"
    INFREQUENT_ACCESS = "INFREQUENT_ACCESS"


class MetricFilterMetricTransformationUnit(str, Enum):
    """
    The unit to assign to the metric. If you omit this, the unit is set as ``None``.
    """
    SECONDS = "Seconds"
    MICROSECONDS = "Microseconds"
    MILLISECONDS = "Milliseconds"
    BYTES = "Bytes"
    KILOBYTES = "Kilobytes"
    MEGABYTES = "Megabytes"
    GIGABYTES = "Gigabytes"
    TERABYTES = "Terabytes"
    BITS = "Bits"
    KILOBITS = "Kilobits"
    MEGABITS = "Megabits"
    GIGABITS = "Gigabits"
    TERABITS = "Terabits"
    PERCENT = "Percent"
    COUNT = "Count"
    BYTES_SECOND = "Bytes/Second"
    KILOBYTES_SECOND = "Kilobytes/Second"
    MEGABYTES_SECOND = "Megabytes/Second"
    GIGABYTES_SECOND = "Gigabytes/Second"
    TERABYTES_SECOND = "Terabytes/Second"
    BITS_SECOND = "Bits/Second"
    KILOBITS_SECOND = "Kilobits/Second"
    MEGABITS_SECOND = "Megabits/Second"
    GIGABITS_SECOND = "Gigabits/Second"
    TERABITS_SECOND = "Terabits/Second"
    COUNT_SECOND = "Count/Second"
    NONE = "None"


class SubscriptionFilterDistribution(str, Enum):
    """
    The method used to distribute log data to the destination, which can be either random or grouped by log stream.
    """
    RANDOM = "Random"
    BY_LOG_STREAM = "ByLogStream"
