# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'AllowListCriteriaArgs',
    'AllowListCriteriaArgsDict',
    'FindingsFilterCriterionAdditionalPropertiesArgs',
    'FindingsFilterCriterionAdditionalPropertiesArgsDict',
    'FindingsFilterFindingCriteriaArgs',
    'FindingsFilterFindingCriteriaArgsDict',
]

MYPY = False

if not MYPY:
    class AllowListCriteriaArgsDict(TypedDict):
        """
        The regex or s3 object to use for the AllowList.
        """
        pass
elif False:
    AllowListCriteriaArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AllowListCriteriaArgs:
    def __init__(__self__):
        """
        The regex or s3 object to use for the AllowList.
        """
        pass


if not MYPY:
    class FindingsFilterCriterionAdditionalPropertiesArgsDict(TypedDict):
        eq: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        The value for the specified property matches (equals) the specified value. If you specify multiple values, Amazon Macie uses OR logic to join the values.
        """
        gt: NotRequired[pulumi.Input[int]]
        """
        The value for the specified property is greater than the specified value.
        """
        gte: NotRequired[pulumi.Input[int]]
        """
        The value for the specified property is greater than or equal to the specified value.
        """
        lt: NotRequired[pulumi.Input[int]]
        """
        The value for the specified property is less than the specified value.
        """
        lte: NotRequired[pulumi.Input[int]]
        """
        The value for the specified property is less than or equal to the specified value.
        """
        neq: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        The value for the specified property doesn't match (doesn't equal) the specified value. If you specify multiple values, Amazon Macie uses OR logic to join the values.
        """
elif False:
    FindingsFilterCriterionAdditionalPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class FindingsFilterCriterionAdditionalPropertiesArgs:
    def __init__(__self__, *,
                 eq: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 gt: Optional[pulumi.Input[int]] = None,
                 gte: Optional[pulumi.Input[int]] = None,
                 lt: Optional[pulumi.Input[int]] = None,
                 lte: Optional[pulumi.Input[int]] = None,
                 neq: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[Sequence[pulumi.Input[str]]] eq: The value for the specified property matches (equals) the specified value. If you specify multiple values, Amazon Macie uses OR logic to join the values.
        :param pulumi.Input[int] gt: The value for the specified property is greater than the specified value.
        :param pulumi.Input[int] gte: The value for the specified property is greater than or equal to the specified value.
        :param pulumi.Input[int] lt: The value for the specified property is less than the specified value.
        :param pulumi.Input[int] lte: The value for the specified property is less than or equal to the specified value.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] neq: The value for the specified property doesn't match (doesn't equal) the specified value. If you specify multiple values, Amazon Macie uses OR logic to join the values.
        """
        if eq is not None:
            pulumi.set(__self__, "eq", eq)
        if gt is not None:
            pulumi.set(__self__, "gt", gt)
        if gte is not None:
            pulumi.set(__self__, "gte", gte)
        if lt is not None:
            pulumi.set(__self__, "lt", lt)
        if lte is not None:
            pulumi.set(__self__, "lte", lte)
        if neq is not None:
            pulumi.set(__self__, "neq", neq)

    @property
    @pulumi.getter
    def eq(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The value for the specified property matches (equals) the specified value. If you specify multiple values, Amazon Macie uses OR logic to join the values.
        """
        return pulumi.get(self, "eq")

    @eq.setter
    def eq(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "eq", value)

    @property
    @pulumi.getter
    def gt(self) -> Optional[pulumi.Input[int]]:
        """
        The value for the specified property is greater than the specified value.
        """
        return pulumi.get(self, "gt")

    @gt.setter
    def gt(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "gt", value)

    @property
    @pulumi.getter
    def gte(self) -> Optional[pulumi.Input[int]]:
        """
        The value for the specified property is greater than or equal to the specified value.
        """
        return pulumi.get(self, "gte")

    @gte.setter
    def gte(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "gte", value)

    @property
    @pulumi.getter
    def lt(self) -> Optional[pulumi.Input[int]]:
        """
        The value for the specified property is less than the specified value.
        """
        return pulumi.get(self, "lt")

    @lt.setter
    def lt(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "lt", value)

    @property
    @pulumi.getter
    def lte(self) -> Optional[pulumi.Input[int]]:
        """
        The value for the specified property is less than or equal to the specified value.
        """
        return pulumi.get(self, "lte")

    @lte.setter
    def lte(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "lte", value)

    @property
    @pulumi.getter
    def neq(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The value for the specified property doesn't match (doesn't equal) the specified value. If you specify multiple values, Amazon Macie uses OR logic to join the values.
        """
        return pulumi.get(self, "neq")

    @neq.setter
    def neq(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "neq", value)


if not MYPY:
    class FindingsFilterFindingCriteriaArgsDict(TypedDict):
        criterion: NotRequired[pulumi.Input[Mapping[str, pulumi.Input['FindingsFilterCriterionAdditionalPropertiesArgsDict']]]]
        """
        Specifies a condition that defines the property, operator, and one or more values to use to filter the results.
        """
elif False:
    FindingsFilterFindingCriteriaArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class FindingsFilterFindingCriteriaArgs:
    def __init__(__self__, *,
                 criterion: Optional[pulumi.Input[Mapping[str, pulumi.Input['FindingsFilterCriterionAdditionalPropertiesArgs']]]] = None):
        """
        :param pulumi.Input[Mapping[str, pulumi.Input['FindingsFilterCriterionAdditionalPropertiesArgs']]] criterion: Specifies a condition that defines the property, operator, and one or more values to use to filter the results.
        """
        if criterion is not None:
            pulumi.set(__self__, "criterion", criterion)

    @property
    @pulumi.getter
    def criterion(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input['FindingsFilterCriterionAdditionalPropertiesArgs']]]]:
        """
        Specifies a condition that defines the property, operator, and one or more values to use to filter the results.
        """
        return pulumi.get(self, "criterion")

    @criterion.setter
    def criterion(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input['FindingsFilterCriterionAdditionalPropertiesArgs']]]]):
        pulumi.set(self, "criterion", value)


