# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'AllowListCriteria',
    'FindingsFilterCriterionAdditionalProperties',
    'FindingsFilterFindingCriteria',
]

@pulumi.output_type
class AllowListCriteria(dict):
    """
    The regex or s3 object to use for the AllowList.
    """
    def __init__(__self__):
        """
        The regex or s3 object to use for the AllowList.
        """
        pass


@pulumi.output_type
class FindingsFilterCriterionAdditionalProperties(dict):
    def __init__(__self__, *,
                 eq: Optional[Sequence[str]] = None,
                 gt: Optional[int] = None,
                 gte: Optional[int] = None,
                 lt: Optional[int] = None,
                 lte: Optional[int] = None,
                 neq: Optional[Sequence[str]] = None):
        """
        :param Sequence[str] eq: The value for the specified property matches (equals) the specified value. If you specify multiple values, Amazon Macie uses OR logic to join the values.
        :param int gt: The value for the specified property is greater than the specified value.
        :param int gte: The value for the specified property is greater than or equal to the specified value.
        :param int lt: The value for the specified property is less than the specified value.
        :param int lte: The value for the specified property is less than or equal to the specified value.
        :param Sequence[str] neq: The value for the specified property doesn't match (doesn't equal) the specified value. If you specify multiple values, Amazon Macie uses OR logic to join the values.
        """
        if eq is not None:
            pulumi.set(__self__, "eq", eq)
        if gt is not None:
            pulumi.set(__self__, "gt", gt)
        if gte is not None:
            pulumi.set(__self__, "gte", gte)
        if lt is not None:
            pulumi.set(__self__, "lt", lt)
        if lte is not None:
            pulumi.set(__self__, "lte", lte)
        if neq is not None:
            pulumi.set(__self__, "neq", neq)

    @property
    @pulumi.getter
    def eq(self) -> Optional[Sequence[str]]:
        """
        The value for the specified property matches (equals) the specified value. If you specify multiple values, Amazon Macie uses OR logic to join the values.
        """
        return pulumi.get(self, "eq")

    @property
    @pulumi.getter
    def gt(self) -> Optional[int]:
        """
        The value for the specified property is greater than the specified value.
        """
        return pulumi.get(self, "gt")

    @property
    @pulumi.getter
    def gte(self) -> Optional[int]:
        """
        The value for the specified property is greater than or equal to the specified value.
        """
        return pulumi.get(self, "gte")

    @property
    @pulumi.getter
    def lt(self) -> Optional[int]:
        """
        The value for the specified property is less than the specified value.
        """
        return pulumi.get(self, "lt")

    @property
    @pulumi.getter
    def lte(self) -> Optional[int]:
        """
        The value for the specified property is less than or equal to the specified value.
        """
        return pulumi.get(self, "lte")

    @property
    @pulumi.getter
    def neq(self) -> Optional[Sequence[str]]:
        """
        The value for the specified property doesn't match (doesn't equal) the specified value. If you specify multiple values, Amazon Macie uses OR logic to join the values.
        """
        return pulumi.get(self, "neq")


@pulumi.output_type
class FindingsFilterFindingCriteria(dict):
    def __init__(__self__, *,
                 criterion: Optional[Mapping[str, 'outputs.FindingsFilterCriterionAdditionalProperties']] = None):
        """
        :param Mapping[str, 'FindingsFilterCriterionAdditionalProperties'] criterion: Specifies a condition that defines the property, operator, and one or more values to use to filter the results.
        """
        if criterion is not None:
            pulumi.set(__self__, "criterion", criterion)

    @property
    @pulumi.getter
    def criterion(self) -> Optional[Mapping[str, 'outputs.FindingsFilterCriterionAdditionalProperties']]:
        """
        Specifies a condition that defines the property, operator, and one or more values to use to filter the results.
        """
        return pulumi.get(self, "criterion")


