# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetStudioComponentResult',
    'AwaitableGetStudioComponentResult',
    'get_studio_component',
    'get_studio_component_output',
]

@pulumi.output_type
class GetStudioComponentResult:
    def __init__(__self__, configuration=None, description=None, ec2_security_group_ids=None, initialization_scripts=None, name=None, script_parameters=None, studio_component_id=None, type=None):
        if configuration and not isinstance(configuration, dict):
            raise TypeError("Expected argument 'configuration' to be a dict")
        pulumi.set(__self__, "configuration", configuration)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if ec2_security_group_ids and not isinstance(ec2_security_group_ids, list):
            raise TypeError("Expected argument 'ec2_security_group_ids' to be a list")
        pulumi.set(__self__, "ec2_security_group_ids", ec2_security_group_ids)
        if initialization_scripts and not isinstance(initialization_scripts, list):
            raise TypeError("Expected argument 'initialization_scripts' to be a list")
        pulumi.set(__self__, "initialization_scripts", initialization_scripts)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if script_parameters and not isinstance(script_parameters, list):
            raise TypeError("Expected argument 'script_parameters' to be a list")
        pulumi.set(__self__, "script_parameters", script_parameters)
        if studio_component_id and not isinstance(studio_component_id, str):
            raise TypeError("Expected argument 'studio_component_id' to be a str")
        pulumi.set(__self__, "studio_component_id", studio_component_id)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def configuration(self) -> Optional['outputs.StudioComponentConfiguration']:
        """
        The configuration of the studio component, based on component type.
        """
        return pulumi.get(self, "configuration")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        A human-readable description for the studio component resource.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="ec2SecurityGroupIds")
    def ec2_security_group_ids(self) -> Optional[Sequence[str]]:
        """
        The EC2 security groups that control access to the studio component.
        """
        return pulumi.get(self, "ec2_security_group_ids")

    @property
    @pulumi.getter(name="initializationScripts")
    def initialization_scripts(self) -> Optional[Sequence['outputs.StudioComponentInitializationScript']]:
        """
        Initialization scripts for studio components.
        """
        return pulumi.get(self, "initialization_scripts")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        A friendly name for the studio component resource.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="scriptParameters")
    def script_parameters(self) -> Optional[Sequence['outputs.StudioComponentScriptParameterKeyValue']]:
        """
        Parameters for the studio component scripts.
        """
        return pulumi.get(self, "script_parameters")

    @property
    @pulumi.getter(name="studioComponentId")
    def studio_component_id(self) -> Optional[str]:
        """
        The unique identifier for the studio component resource.
        """
        return pulumi.get(self, "studio_component_id")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        The type of the studio component.
        """
        return pulumi.get(self, "type")


class AwaitableGetStudioComponentResult(GetStudioComponentResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetStudioComponentResult(
            configuration=self.configuration,
            description=self.description,
            ec2_security_group_ids=self.ec2_security_group_ids,
            initialization_scripts=self.initialization_scripts,
            name=self.name,
            script_parameters=self.script_parameters,
            studio_component_id=self.studio_component_id,
            type=self.type)


def get_studio_component(studio_component_id: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetStudioComponentResult:
    """
    Resource Type definition for AWS::NimbleStudio::StudioComponent


    :param str studio_component_id: The unique identifier for the studio component resource.
    """
    __args__ = dict()
    __args__['studioComponentId'] = studio_component_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:nimblestudio:getStudioComponent', __args__, opts=opts, typ=GetStudioComponentResult).value

    return AwaitableGetStudioComponentResult(
        configuration=pulumi.get(__ret__, 'configuration'),
        description=pulumi.get(__ret__, 'description'),
        ec2_security_group_ids=pulumi.get(__ret__, 'ec2_security_group_ids'),
        initialization_scripts=pulumi.get(__ret__, 'initialization_scripts'),
        name=pulumi.get(__ret__, 'name'),
        script_parameters=pulumi.get(__ret__, 'script_parameters'),
        studio_component_id=pulumi.get(__ret__, 'studio_component_id'),
        type=pulumi.get(__ret__, 'type'))
def get_studio_component_output(studio_component_id: Optional[pulumi.Input[str]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetStudioComponentResult]:
    """
    Resource Type definition for AWS::NimbleStudio::StudioComponent


    :param str studio_component_id: The unique identifier for the studio component resource.
    """
    __args__ = dict()
    __args__['studioComponentId'] = studio_component_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('aws-native:nimblestudio:getStudioComponent', __args__, opts=opts, typ=GetStudioComponentResult)
    return __ret__.apply(lambda __response__: GetStudioComponentResult(
        configuration=pulumi.get(__response__, 'configuration'),
        description=pulumi.get(__response__, 'description'),
        ec2_security_group_ids=pulumi.get(__response__, 'ec2_security_group_ids'),
        initialization_scripts=pulumi.get(__response__, 'initialization_scripts'),
        name=pulumi.get(__response__, 'name'),
        script_parameters=pulumi.get(__response__, 'script_parameters'),
        studio_component_id=pulumi.get(__response__, 'studio_component_id'),
        type=pulumi.get(__response__, 'type')))
