# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'ApplicationInstanceManifestOverridesPayload',
    'ApplicationInstanceManifestPayload',
    'PackageStorageLocation',
]

@pulumi.output_type
class ApplicationInstanceManifestOverridesPayload(dict):
    """
    Parameter overrides for an application instance. This is a JSON document that has a single key (``PayloadData``) where the value is an escaped string representation of the overrides document.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "payloadData":
            suggest = "payload_data"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ApplicationInstanceManifestOverridesPayload. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ApplicationInstanceManifestOverridesPayload.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ApplicationInstanceManifestOverridesPayload.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 payload_data: Optional[str] = None):
        """
        Parameter overrides for an application instance. This is a JSON document that has a single key (``PayloadData``) where the value is an escaped string representation of the overrides document.
        :param str payload_data: The overrides document.
        """
        if payload_data is not None:
            pulumi.set(__self__, "payload_data", payload_data)

    @property
    @pulumi.getter(name="payloadData")
    def payload_data(self) -> Optional[str]:
        """
        The overrides document.
        """
        return pulumi.get(self, "payload_data")


@pulumi.output_type
class ApplicationInstanceManifestPayload(dict):
    """
    A application verion's manifest file. This is a JSON document that has a single key (``PayloadData``) where the value is an escaped string representation of the application manifest (``graph.json``). This file is located in the ``graphs`` folder in your application source.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "payloadData":
            suggest = "payload_data"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ApplicationInstanceManifestPayload. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ApplicationInstanceManifestPayload.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ApplicationInstanceManifestPayload.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 payload_data: Optional[str] = None):
        """
        A application verion's manifest file. This is a JSON document that has a single key (``PayloadData``) where the value is an escaped string representation of the application manifest (``graph.json``). This file is located in the ``graphs`` folder in your application source.
        :param str payload_data: The application manifest.
        """
        if payload_data is not None:
            pulumi.set(__self__, "payload_data", payload_data)

    @property
    @pulumi.getter(name="payloadData")
    def payload_data(self) -> Optional[str]:
        """
        The application manifest.
        """
        return pulumi.get(self, "payload_data")


@pulumi.output_type
class PackageStorageLocation(dict):
    """
    A storage location.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "binaryPrefixLocation":
            suggest = "binary_prefix_location"
        elif key == "generatedPrefixLocation":
            suggest = "generated_prefix_location"
        elif key == "manifestPrefixLocation":
            suggest = "manifest_prefix_location"
        elif key == "repoPrefixLocation":
            suggest = "repo_prefix_location"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PackageStorageLocation. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PackageStorageLocation.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PackageStorageLocation.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 binary_prefix_location: Optional[str] = None,
                 bucket: Optional[str] = None,
                 generated_prefix_location: Optional[str] = None,
                 manifest_prefix_location: Optional[str] = None,
                 repo_prefix_location: Optional[str] = None):
        """
        A storage location.
        :param str binary_prefix_location: The location's binary prefix.
        :param str bucket: The location's bucket.
        :param str generated_prefix_location: The location's generated prefix.
        :param str manifest_prefix_location: The location's manifest prefix.
        :param str repo_prefix_location: The location's repo prefix.
        """
        if binary_prefix_location is not None:
            pulumi.set(__self__, "binary_prefix_location", binary_prefix_location)
        if bucket is not None:
            pulumi.set(__self__, "bucket", bucket)
        if generated_prefix_location is not None:
            pulumi.set(__self__, "generated_prefix_location", generated_prefix_location)
        if manifest_prefix_location is not None:
            pulumi.set(__self__, "manifest_prefix_location", manifest_prefix_location)
        if repo_prefix_location is not None:
            pulumi.set(__self__, "repo_prefix_location", repo_prefix_location)

    @property
    @pulumi.getter(name="binaryPrefixLocation")
    def binary_prefix_location(self) -> Optional[str]:
        """
        The location's binary prefix.
        """
        return pulumi.get(self, "binary_prefix_location")

    @property
    @pulumi.getter
    def bucket(self) -> Optional[str]:
        """
        The location's bucket.
        """
        return pulumi.get(self, "bucket")

    @property
    @pulumi.getter(name="generatedPrefixLocation")
    def generated_prefix_location(self) -> Optional[str]:
        """
        The location's generated prefix.
        """
        return pulumi.get(self, "generated_prefix_location")

    @property
    @pulumi.getter(name="manifestPrefixLocation")
    def manifest_prefix_location(self) -> Optional[str]:
        """
        The location's manifest prefix.
        """
        return pulumi.get(self, "manifest_prefix_location")

    @property
    @pulumi.getter(name="repoPrefixLocation")
    def repo_prefix_location(self) -> Optional[str]:
        """
        The location's repo prefix.
        """
        return pulumi.get(self, "repo_prefix_location")


