# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['HealthCheckArgs', 'HealthCheck']

@pulumi.input_type
class HealthCheckArgs:
    def __init__(__self__, *,
                 health_check_config: pulumi.Input['HealthCheckConfigPropertiesArgs'],
                 health_check_tags: Optional[pulumi.Input[Sequence[pulumi.Input['HealthCheckTagArgs']]]] = None):
        """
        The set of arguments for constructing a HealthCheck resource.
        :param pulumi.Input['HealthCheckConfigPropertiesArgs'] health_check_config: A complex type that contains information about the health check.
        :param pulumi.Input[Sequence[pulumi.Input['HealthCheckTagArgs']]] health_check_tags: An array of key-value pairs to apply to this resource.
        """
        pulumi.set(__self__, "health_check_config", health_check_config)
        if health_check_tags is not None:
            pulumi.set(__self__, "health_check_tags", health_check_tags)

    @property
    @pulumi.getter(name="healthCheckConfig")
    def health_check_config(self) -> pulumi.Input['HealthCheckConfigPropertiesArgs']:
        """
        A complex type that contains information about the health check.
        """
        return pulumi.get(self, "health_check_config")

    @health_check_config.setter
    def health_check_config(self, value: pulumi.Input['HealthCheckConfigPropertiesArgs']):
        pulumi.set(self, "health_check_config", value)

    @property
    @pulumi.getter(name="healthCheckTags")
    def health_check_tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['HealthCheckTagArgs']]]]:
        """
        An array of key-value pairs to apply to this resource.
        """
        return pulumi.get(self, "health_check_tags")

    @health_check_tags.setter
    def health_check_tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['HealthCheckTagArgs']]]]):
        pulumi.set(self, "health_check_tags", value)


class HealthCheck(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 health_check_config: Optional[pulumi.Input[Union['HealthCheckConfigPropertiesArgs', 'HealthCheckConfigPropertiesArgsDict']]] = None,
                 health_check_tags: Optional[pulumi.Input[Sequence[pulumi.Input[Union['HealthCheckTagArgs', 'HealthCheckTagArgsDict']]]]] = None,
                 __props__=None):
        """
        Resource schema for AWS::Route53::HealthCheck.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['HealthCheckConfigPropertiesArgs', 'HealthCheckConfigPropertiesArgsDict']] health_check_config: A complex type that contains information about the health check.
        :param pulumi.Input[Sequence[pulumi.Input[Union['HealthCheckTagArgs', 'HealthCheckTagArgsDict']]]] health_check_tags: An array of key-value pairs to apply to this resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: HealthCheckArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource schema for AWS::Route53::HealthCheck.

        :param str resource_name: The name of the resource.
        :param HealthCheckArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(HealthCheckArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 health_check_config: Optional[pulumi.Input[Union['HealthCheckConfigPropertiesArgs', 'HealthCheckConfigPropertiesArgsDict']]] = None,
                 health_check_tags: Optional[pulumi.Input[Sequence[pulumi.Input[Union['HealthCheckTagArgs', 'HealthCheckTagArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = HealthCheckArgs.__new__(HealthCheckArgs)

            if health_check_config is None and not opts.urn:
                raise TypeError("Missing required property 'health_check_config'")
            __props__.__dict__["health_check_config"] = health_check_config
            __props__.__dict__["health_check_tags"] = health_check_tags
            __props__.__dict__["health_check_id"] = None
        super(HealthCheck, __self__).__init__(
            'aws-native:route53:HealthCheck',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'HealthCheck':
        """
        Get an existing HealthCheck resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = HealthCheckArgs.__new__(HealthCheckArgs)

        __props__.__dict__["health_check_config"] = None
        __props__.__dict__["health_check_id"] = None
        __props__.__dict__["health_check_tags"] = None
        return HealthCheck(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="healthCheckConfig")
    def health_check_config(self) -> pulumi.Output['outputs.HealthCheckConfigProperties']:
        """
        A complex type that contains information about the health check.
        """
        return pulumi.get(self, "health_check_config")

    @property
    @pulumi.getter(name="healthCheckId")
    def health_check_id(self) -> pulumi.Output[str]:
        """
        The identifier that Amazon Route 53 assigned to the health check when you created it. When you add or update a resource record set, you use this value to specify which health check to use. The value can be up to 64 characters long.
        """
        return pulumi.get(self, "health_check_id")

    @property
    @pulumi.getter(name="healthCheckTags")
    def health_check_tags(self) -> pulumi.Output[Optional[Sequence['outputs.HealthCheckTag']]]:
        """
        An array of key-value pairs to apply to this resource.
        """
        return pulumi.get(self, "health_check_tags")

