# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetResolverRuleAssociationResult',
    'AwaitableGetResolverRuleAssociationResult',
    'get_resolver_rule_association',
    'get_resolver_rule_association_output',
]

@pulumi.output_type
class GetResolverRuleAssociationResult:
    def __init__(__self__, resolver_rule_association_id=None):
        if resolver_rule_association_id and not isinstance(resolver_rule_association_id, str):
            raise TypeError("Expected argument 'resolver_rule_association_id' to be a str")
        pulumi.set(__self__, "resolver_rule_association_id", resolver_rule_association_id)

    @property
    @pulumi.getter(name="resolverRuleAssociationId")
    def resolver_rule_association_id(self) -> Optional[str]:
        """
        The ID of the resolver rule association that you want to get information about, such as `rslvr-rrassoc-97242eaf88example` .
        """
        return pulumi.get(self, "resolver_rule_association_id")


class AwaitableGetResolverRuleAssociationResult(GetResolverRuleAssociationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetResolverRuleAssociationResult(
            resolver_rule_association_id=self.resolver_rule_association_id)


def get_resolver_rule_association(resolver_rule_association_id: Optional[str] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetResolverRuleAssociationResult:
    """
    In the response to an [AssociateResolverRule](https://docs.aws.amazon.com/Route53/latest/APIReference/API_route53resolver_AssociateResolverRule.html), [DisassociateResolverRule](https://docs.aws.amazon.com/Route53/latest/APIReference/API_route53resolver_DisassociateResolverRule.html), or [ListResolverRuleAssociations](https://docs.aws.amazon.com/Route53/latest/APIReference/API_route53resolver_ListResolverRuleAssociations.html) request, provides information about an association between a resolver rule and a VPC. The association determines which DNS queries that originate in the VPC are forwarded to your network.


    :param str resolver_rule_association_id: The ID of the resolver rule association that you want to get information about, such as `rslvr-rrassoc-97242eaf88example` .
    """
    __args__ = dict()
    __args__['resolverRuleAssociationId'] = resolver_rule_association_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:route53resolver:getResolverRuleAssociation', __args__, opts=opts, typ=GetResolverRuleAssociationResult).value

    return AwaitableGetResolverRuleAssociationResult(
        resolver_rule_association_id=pulumi.get(__ret__, 'resolver_rule_association_id'))
def get_resolver_rule_association_output(resolver_rule_association_id: Optional[pulumi.Input[str]] = None,
                                         opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetResolverRuleAssociationResult]:
    """
    In the response to an [AssociateResolverRule](https://docs.aws.amazon.com/Route53/latest/APIReference/API_route53resolver_AssociateResolverRule.html), [DisassociateResolverRule](https://docs.aws.amazon.com/Route53/latest/APIReference/API_route53resolver_DisassociateResolverRule.html), or [ListResolverRuleAssociations](https://docs.aws.amazon.com/Route53/latest/APIReference/API_route53resolver_ListResolverRuleAssociations.html) request, provides information about an association between a resolver rule and a VPC. The association determines which DNS queries that originate in the VPC are forwarded to your network.


    :param str resolver_rule_association_id: The ID of the resolver rule association that you want to get information about, such as `rslvr-rrassoc-97242eaf88example` .
    """
    __args__ = dict()
    __args__['resolverRuleAssociationId'] = resolver_rule_association_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('aws-native:route53resolver:getResolverRuleAssociation', __args__, opts=opts, typ=GetResolverRuleAssociationResult)
    return __ret__.apply(lambda __response__: GetResolverRuleAssociationResult(
        resolver_rule_association_id=pulumi.get(__response__, 'resolver_rule_association_id')))
